<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>
<script language="JavaScript" src="admin/scripts/templates.js" type="text/javascript"></script>
<script type="text/javascript" src="common/scripts/jquery.cascade.js"></script>
<script type="text/javascript" src="common/scripts/jquery.field.js"></script>
<script language="JavaScript" src="admin/scripts/users.js"></script>
<script language="JavaScript" src="admin/scripts/preference.js"></script>

<style type="text/css">@import "common/styles/sasStyles.css";</style>
<style type="text/css">@import "includes/view.css";</style>
<script language="JavaScript" src="includes/view.js"></script>

<c:if test="${enableHTML}">
<script type="text/javascript" src="common/scripts/jHtmlArea-0.8.js"></script>
<script type="text/javascript" src="common/scripts/jquery-ui.js"></script>
<link rel="stylesheet" type="text/css" href="common/styles/jHtmlArea.css" />
<link rel="stylesheet" type="text/css" href="common/styles/jquery-ui.css"/>

<style type="text/css">
@import "common/styles/jHtmlArea-sas.css";

.ui-dialog .ui-dialog-titlebar-close {
	background: url(common/images/closeX.gif);
}
</style>

<script type="text/javascript">
	$(document).ready(function() {
        $("#text").htmlarea({
        	// toolbar: ["html", "|", "link", "unlink"],
        	toolbar: ["link", "unlink"],
        	toolbarText: $.extend({}, jHtmlArea.defaultOptions.toolbarText, {
	        	html:   "<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.toolbar.tooltip.html.txt"/></esapi:encodeForJavaScript>",
				link: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.toolbar.tooltip.insertLink.txt"/></esapi:encodeForJavaScript>",
				unlink: "<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.toolbar.tooltip.unlink.txt"/></esapi:encodeForJavaScript>"
		    }),
        	promptText: $.extend({}, jHtmlArea.defaultOptions.promptText, {
				title: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.title.txt"/></esapi:encodeForJavaScript>",
				buttonOk: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.button.ok.txt"/></esapi:encodeForJavaScript>",
				linkURL: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.linkURL.txt"/></esapi:encodeForJavaScript>",
				linkURLErrors: ["<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.linkURLError0.txt"/></esapi:encodeForJavaScript>",
					"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.linkURLError1.txt"/></esapi:encodeForJavaScript>"]
		    })
         });
	});
</script>
</c:if>

<div>
<%-- Error handling code --%>
<c:url var="reloadURL" value="/a_messaging.sj?method=listMessages&treeSelectedMessage=${message.id}" />
<tiles:insert page="/admin/adminDetailErrorHandling.jsp" flush="true">
	<tiles:put name="reloadURL" value="${reloadURL}" />
	<tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
	<tiles:put name="objectTypeName" value="memo" />
</tiles:insert>


<form id ="memoDefForm" action="a_messaging.sj" method="post" onsubmit="return submitTemplateForm(this);">
<input type="hidden" name="method" value="saveMemo">
<c:choose>
<c:when test="${message != null}">
<input type="hidden" name="id" value="${message.id}">
<input type="hidden" name="version" value="${message.version}">
<input type="hidden" name="oldBusinessUnit" value="${esapi:encodeForHTMLAttribute(message.oldBusinessUnit)}">
</c:when>
</c:choose>

<table id="memoDefinition" class="configurationTable" style="width:600px; margin-left: 5px"
   border="0" cellspacing="0" cellpadding="0">
   <tr align="left" valign="top" >
      <td colspan="3" class="configurationTableSectionNoHover" style="padding:5px;"> <fmt:message key="fcm.templates.memo.definition.txt" /> </td>
   </tr>
   <tr class="configurationTableDataRow" ><td colspan="3">&nbsp;</td></tr>
   <tr class="configurationTableDataRow" valign="top">
      <td nowrap scope="col"><fmt:message key='fcm.templates.memo.id.txt' /></td>
      <td  valign="middle" scope="col">${message.id}</td>
      <td>&nbsp;</td>
   <!--<tr class="configurationTableDataRow" ><td colspan="3">&nbsp;</td</tr>-->
   </tr><tr class="configurationTableDataRow" valign="top">
      <td nowrap scope="col"> <fmt:message key='fcm.templates.memo.name.txt' /> </td>
      <td valign="middle" scope="col">
         <input id="name" name="name" type="text" class="famTextEntry"
            value="${esapi:encodeForHTMLAttribute(message.name)}" size="71" maxlength="50" />
      </td>
      <td>&nbsp;</td>
   </tr>
   <!--<tr class="configurationTableDataRow" ><td colspan="3">&nbsp;</td</tr>-->
<tr class="configurationTableDataRow" valign="top">
      <td><fmt:message key="fcm.details.bu.txt" />: </td>
      <td valign="middle" scope="col"><select name="businessUnit" id="buId" class="famSelect">
         <c:set var="businessUnitExists" value="" />

         <c:forEach var="businessUnit" items="${businessUnits}">
            <c:choose>
            	<c:when test="${message.businessUnit == businessUnit.id}">
            		<c:set var="sltd" value="selected"/>
            		<c:set var="businessUnitExists" value="true" />
            	</c:when>
            	<c:otherwise>
            		<c:set var="sltd" value=""/>
		</c:otherwise>
	    </c:choose>
            <option value="${businessUnit.id}" ${sltd}>${esapi:encodeForHTML(businessUnit.name)}</option>
         </c:forEach>
         <c:if test="${empty businessUnitExists }" >
	 	<option selected value=""><fmt:message key="fcm.groups.selectBusinessUnit.txt" />&nbsp;&nbsp;</option>
	 </c:if>
        </select><br/>&nbsp;
      </td>
		<td>&nbsp;</td>
    </tr>

   <tr  class="configurationTableDataRow" valign="top">
      <td nowrap> <fmt:message key='fcm.templates.memo.text.txt' /></td>
      <td>
        <textarea id="text" class="famTextEntry" name="text" cols="100" rows="8" maxlength="${memoMaxSize}" wrap="soft">${esapi:encodeForHTML(message.text)}</textarea>
      </td>
      <td>&nbsp;</td>
   </tr>
   <tr class="configurationTableDataRow" ><td colspan="3">&nbsp;</td></tr>
</table>

<c:set var="strategiesAssigned">
<c:if test="${fn:length(message.strategies)>0}">true</c:if>
</c:set>
<input type="hidden" name="associatedStrategies" id="associatedStrategies" value="${strategiesAssigned}"/>
</form>
</div>

<c:if test="${not empty updateTemplates && !updateTemplates}">
  <script language="JavaScript" type="text/javascript">
  //<!--
    setFormsReadOnly();
  //-->
  </script>
</c:if>


