<%@ page language="java" session="true"	contentType="text/html; charset=UTF-8"%>
<%@ include file="/common/taglibs.jsp"%>
<script language="JavaScript" src="admin/scripts/models.js"></script>
<script language="JavaScript" src="common/scripts/i18n.js"></script>

<script type="text/javascript" src="common/scripts/jquery.cascade.js"></script>
<script type="text/javascript" src="common/scripts/jquery.field.js"></script>
<script language="JavaScript" src="admin/scripts/users.js"></script>
<script language="JavaScript" src="admin/scripts/preference.js"></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/tasks.js"></script>
<script language='JavaScript' src='common/scripts/menuFrames.js'></script>
<script language="JavaScript" src="includes/view.js"></script>

<style type="text/css">@import "common/styles/sasStyles.css";</style>
<style type="text/css">@import "includes/view.css";</style>
<style type="text/css">@import"admin/styles/users.css"</style>

<style>
 .rowSelected
      {
         background-color:#ddddee;
         color:#648BB9;
      }
</style>


<!-- include jQuery and jQueryUI libraries -->
<script type="text/javascript"	src="admin/scripts/jquery-1.9.1.js"></script>
<script type="text/javascript"	src="common/scripts/jquery-ui.js"></script>

<!-- include plugin -->
<script type="text/javascript" src="admin/scripts/jquery.tree.js"></script>
<link rel="stylesheet" type="text/css"	href="admin/styles/jquery.tree.css" />

<!-- jqplot plugins -->
<!-- <script type="text/javascript" src="admin/scripts/jqplot/jquery.min.js"></script>-->
<script type="text/javascript" src="admin/scripts/jqplot/jquery.jqplot.min.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.logAxisRenderer.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.canvasTextRenderer.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.canvasAxisLabelRenderer.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.canvasAxisTickRenderer.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.pointLabels.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.enhancedLegendRenderer.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.categoryAxisRenderer.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.highlighter.js"></script>
<script type="text/javascript" src="admin/scripts/jqplot/jqplot.barRenderer.js"></script>

<link rel="stylesheet" type="text/css" href="admin/scripts/jqplot/jquery.jqplot.min.css" />


<script type="text/javascript">
var action="<c:url value='/a_model.sj'/>";
<c:set var="txnCnt">
<fmt:message key="fcm.models.transactionCount.tooltip.txt"/>
</c:set>
function tooltipContentEditor(str, seriesIndex, pointIndex, plot) {
    // display series_label, x-axis_tick, y-axis value
    //return plot.series[seriesIndex]["label"] + ", " + plot.data[seriesIndex][pointIndex];
    return "${txnCnt}: " +$.jqplot.sprintf("%'d",  plot.data[seriesIndex][pointIndex]) + " " +plot.axes.xaxis.ticks[pointIndex];
}

	$(document).ready(function() {

		var multiOrgs = [];
		var tenantMultiOrgs = [];

		<c:forEach var="modelMO" items="${modelScore.multiOrgNodes}" varStatus="status">
		multiOrgs.push("#mo${esapi:encodeForJavaScript(modelMO.id)}");
		</c:forEach>
		//generate multiorg tree asynchronously
		getMoTree();

		function getMoTree(){
			var moTree=$.ajax({
		        url: 'a_model.sj?method=getMultiOrgNodes',
		        type:'POST',
		        success : outputTree,
		        error: function(result){
		        	console.log("error:" + result);
		        }
			});
		}
		function outputTree(moTree){
			$('#tree').html(moTree);
			$('#tree').tree({
	  			nodesInitUrl: null,
	  			onCheck : {
	  				//ancestors: 'checkIfFull',
	  				descendants : 'check',
	  				ancestors : 'uncheck',
	  				node : 'expand'
	  			},
	  			onUncheck : {
	  				ancestors : 'uncheck',
	  				descendants : 'uncheck'//,
	  				//node : 'collapse'
	  			}
	  		  });
			//check root
			$(multiOrgs.join(',')).prop("checked", true).change();
			//check and disable roots' children
			$(multiOrgs.join(',')).parent().find('li input:checkbox').prop('disabled', true).change();
			$(multiOrgs.join(',')).parent().find('li input:checkbox:not(:checked)').prop('checked', true).change();
			//determine if select all should be checked
			var numberOfChecked = $('li input:checkbox:checked').length;
			var totalCheckboxes = $('li input:checkbox').length;
			var numberNotChecked = totalCheckboxes - numberOfChecked;
			//alert(  "total: " +totalCheckboxes + " checked: "  +numberOfChecked +"unchecked:" +numberNotChecked);
			if (numberNotChecked == 0)
				$('#moSelectAll').prop('checked', true);

			$('#moSelectAll').change(function() {

				if (this.checked) {
					$('#tree').tree('checkAll');
					$('.orgLevel2 input').prop("disabled", true);
				} else {
					$('#tree').tree('uncheckAll');
					$('.orgLevel2 input').prop("disabled", false);
				}

				$(this).parent().bind('click', function(e) {
					e.stopPropagation()
				});
			});
			$('#orgLevel1 input').bind('click', function() {
				$('#moSelectAll').prop('checked', false);
			});
		}

		<c:forEach var="scoreField" items="${scoreFields}" varStatus="status">
			<c:if test="${modelScore.scoreId==scoreField.FIELD_ID}"><c:set var="scoreName" value="${fn:toUpperCase(scoreField.FIELD_NAME)}"/></c:if>
		</c:forEach>
		<c:if test="${modelScore.id!='-1'}">
		//jqplot
	    <c:set var="series1">
			<fmt:message key="fcm.models.currentMonth.txt"/>
		</c:set>
		<c:set var="yAxisLabel">
			<fmt:message key="fcm.models.frequency.txt"/>
		</c:set>
	    //<c:set var="series2" value="Previous Month"/>
	    /***************************************************************************************************************************/
		var current_ticks=[];
	    //var previous_ticks=[];
	    var current_data=[];
	    //var previous_data=[];
		var s1=[];
		//var s2=[];
		var ticks=[];
		var plotObj=[];

		<c:set var="RRR_MODEL_ID"      value="${fn:substring(modelScore.model,0,8)}" />
		<c:set var="RRR_MODEL_VERSION" value="${fn:substringAfter(modelScore.model, RRR_MODEL_ID)}" />
		<c:set var="scoreNum" value="${fn:substring(scoreName,10,11)}"/>
		<c:set var="binSize" value="50"/>

	    var q='tsperiod=P1M&q=RRR_MODEL_ID_${scoreNum}:${RRR_MODEL_ID} AND RRR_MODEL_VERSION_${scoreNum}:${RRR_MODEL_VERSION}';
	    var type='facets';
		var schema='fgdb';
		var params ='{"size":0,"aggs": {"${scoreName}": {"histogram": {"field": "${scoreName}","interval":${binSize}}}}}';
		var currentDate = new Date();
	    var tsoffset =Date.UTC(currentDate.getFullYear(),currentDate.getMonth()-1, currentDate.getDate());
	    var withOffset=q+'&tsoffset='+tsoffset;

		var getQueryUrl = function(type, schema, q) {
        	if (type == undefined || type == null) {
        		type = "facets";
        	}
        	var urlSegments = [];
        	urlSegments[urlSegments.length] ="${pageContext.request.contextPath}";
        	urlSegments[urlSegments.length] = "/rest/transactions/"+type + "?";
        	if (schema != null && schema != undefined) {
            	urlSegments[urlSegments.length] = "schema=" + encodeURIComponent(schema);
        		try {
        			urlSegments[urlSegments.length] = "&"+q;
        		} catch (e) {}
        	}
        	return urlSegments.join("");
        };
        var current=$.ajax({
			async:true,
			cache:false,
			type: "POST",
			url: getQueryUrl(type,schema,q),
			data: params,
			dataType: "json",
			contentType:"application/json; charset=utf-8"
		})/*,
		previous=$.ajax({
			async:true,
			cache:false,
			type: "POST",
			url: getQueryUrl(type,schema,withOffset),
			data: params,
			dataType: "json",
			contentType:"application/json; charset=utf-8"
		})*/
		$.when(current).fail(function(){
			<c:set var="noTas" >
			<fmt:message key="fcm.models.noTasServer.txt">
			<fmt:param>${scoreName}</fmt:param>
			</fmt:message>
			</c:set>
			$('#distributionBlock').html("${noTas}");
			$('#distributionBlock').css({fontSize: '0.79rem', fontStyle:'italic', textAlign:'center'});
		});
        if (!String.prototype.startsWith) {
        	String.prototype.startsWith = function(search, pos) {
        		return this.substr(!pos || pos < 0 ? 0 : +pos, search.length) === search;
        	};
        }
        $.when(current/*,previous*/).done(function(currentData/*,previousData*/) {
        	current_data=[];
        	//previous_data=[];
        	if(typeof currentData/*[0]*/['*'].children != 'undefined'){
	        	if(typeof currentData/*[0]*/['*'].children[0].children != 'undefined'){
					for(i=0;i<currentData/*[0]*/['*'].children[0].children.length;i++){
						var currTick=currentData/*[0]*/['*'].children[0].children[i].name.replace(/\.0/g, '');
						current_ticks.push(currTick);
						if(currentData/*[0]*/['*'].children[0].children[i].size==0)// zeros as NaN for logaxisrenderer
							current_data.push(NaN);
						else
							current_data.push(currentData/*[0]*/['*'].children[0].children[i].size);
					}
	        	}
        	}
        	/*
			if(typeof previousData[0]['*'].children[0].children != 'undefined'){
				for(i=0;i<previousData[0]['*'].children[0].children.length;i++){
					previous_ticks.push(previousData[0]['*'].children[0].children[i].name.replace(/\.0/g, ''));
					previous_data.push(previousData[0]['*'].children[0].children[i].size);
				}
			}
        	*/
			/********************************************CONSOLIDATE DATA************************************************************/
			 /*for(i=0;i<current_ticks.length;i++){
			 	if(current_ticks[i]==previous_ticks[i]){
			 		if(typeof current_ticks[i]!='undefined')
			 			ticks.push(current_ticks[i]);
			 	}else{
			 		if(typeof current_ticks[i]!='undefined') ticks.push(current_ticks[i]);
			 		if(typeof previous_ticks[i]!='undefined')ticks.push(previous_ticks[i]);
			 	}
			 }*/
			var lowerBound=0;
			var binSize=${binSize};
			var top=1000/binSize;

			for(i=0;i<top;i++){
				 ticks.push(lowerBound + "-" + (lowerBound+binSize));
				 lowerBound=lowerBound+binSize;
			}

			for(i=0;i<ticks.length;i++){
			 	var current=NaN;
			 	for(j=0;j<current_ticks.length;j++){
					if(current_ticks[j]==ticks[i]){
						current=current_data[j];
						break;
					}
				}
			  	/*var previous=0;
			  	for(k=0;k<previous_ticks.length;k++){
			 		if(previous_ticks[k]==ticks[i]){
			 			previous=previous_data[k];
			 			break;
			 		}
			 	}*/
			  plotObj.push({tick:ticks[i],current:current/*,previous:previous*/});
			 }


			/*plotObj.sort(function(a, b) {
			    var range1 = split(a.tick);
			    var range2 = split(b.tick);
			    return (range1 < range2) ? -1 : (range1 > range2) ? 1 : 0;
			});*/

			var s1 = plotObj.map(function(a) {return a.current;});
			//var s2 = plotObj.map(function(a) {return a.previous;});
			ticks=[];
			ticks= plotObj.map(function(a){return a.tick;});
			for(i=0;i<ticks.length;i++){
				if(ticks[i].startsWith('0')){
					ticks[i]='(<'+ticks[i].split('-')[1]+')';
				}else{
					ticks[i]='(>='+ticks[i].split('-')[0]+', <'+ticks[i].split('-')[1]+')';
				}
			}
			function split(str) {
			 var i = str.indexOf("-");
			 if(i > 0)
			  return  str.slice(0, i);
			 else
			  return "";
			}

			if(s1.length!=0 && current_data.length!=0 /*&& s2.length!=0*/){
				var maxCurrent = current_data.reduce(function(a, b) {
				    return Math.max(a, b);
				});
				var yAxisRenderer=$.jqplot.LogAxisRenderer;
				if(maxCurrent<10){
					yAxisRenderer=$.jqplot.LinearAxisRenderer;
				}
			    $.jqplot.config.enablePlugins = true;
			    var plot1 = $.jqplot('distributionBlock', [s1/*, s2*/], {
			        animate:true,
			    	// The "seriesDefaults" option is an options object that will be applied to all series in the chart.
			        seriesDefaults:{
			            renderer:$.jqplot.BarRenderer,
			            rendererOptions: {
			            	shadow:true,
			            	//barWidth: 15,
				            barPadding: 0,
				            barMargin: 0},
			    		pointLabels: { show: false }
			        },
			        seriesColors: [/*'#77933C',*/ '#B9CDE5'],

			        // Custom labels for the series are specified with the "label"
			        // option on the series option.  Here a series option object
			        // is specified for each series.
			        series:[
			            {label:'${series1}'},
			            //{label:'${series2}'},
			            {rendererOptions:{
					        animation:{speed: 2500}
				        	}
			            }
			        ],
			        grid: {
			            drawBorder: false,
			            shadow: true,
			            shadowAngle:0,
			            shadowDepth:1,
			            background: "#f0f1f2"
			        },
			        highlighter: {
			        	show: true,
			        	tooltipAxes:'xy',
			        	showMarker:false,
			            useAxesFormatters: true,
			            tooltipContentEditor:tooltipContentEditor,
			            tooltipLocation:'n'
			        },
			        // Show the legend and put it outside the grid, but inside the
			        // plot container, shrinking the grid to accomodate the legend.
			        // A value of "outside" would not shrink the grid and allow
			        // the legend to overflow the container.

			        legend: {
			            show: true,
			            renderer: $.jqplot.EnhancedLegendRenderer,
			            rendererOptions: {
			                numberRows: 1,
			                seriesToggle:false
			            },
			            placement: 'outsideGrid',
			            location: 'n'
			        },

			        axes: {
			            // Use a category axis on the x axis and use our custom ticks.
			            xaxis: {
			                renderer: $.jqplot.CategoryAxisRenderer,
			                labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
			                tickRenderer: $.jqplot.CanvasAxisTickRenderer,
			                shadow:false,
			                tickOptions: {
			                    angle: -90,
			                    showGridline:false,
			                    fontSize:'8pt',
			                    fontColor:'black',
			                    fontWeight:'none'
			                },
			                ticks: ticks
			            },
			            // Pad the y axis just a little so bars can get close to, but
			            // not touch, the grid boundaries.  1.2 is the default padding.
			            yaxis: {
			            	renderer : yAxisRenderer/*$.jqplot.LinearAxisRenderer*//*$.jqplot.LogAxisRenderer*/,
			            	label:'${yAxisLabel}',
			            	labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
			            	tickRenderer: $.jqplot.CanvasAxisTickRenderer,
			            	shadow:false,
			                pad: 0,
			                tickOptions: {
			                	//formatString: "%'d",//to avoid repeating values when max value is small
			                	showGridline:true,
			                	fontSize:'8pt',
			                    fontColor:'black',
			                    fontWeight:'none'
			                }
			            }
			        }

			    });
			}else{
				<c:set var="noData" >
				<fmt:message key="fcm.models.noTransactionData.fmt.txt">
				<fmt:param>${modelScore.label}</fmt:param>
				</fmt:message>
				</c:set>
				$('#distributionBlock').html("${noData}");
				$('#distributionBlock').css({fontSize: '0.79rem', fontStyle:'italic', textAlign:'center'});

			}
        });

		</c:if>//if score is not blank
});
//-->
</script>


<div>
	<%-- Error handling code --%>
	<c:url var="reloadURL"
		value="/a_model.sj?method=listNodes&treeSelectedNode=M${modelScore.id}" />
	<tiles:insert page="/admin/adminDetailErrorHandling.jsp" flush="true">
		<tiles:put name="reloadURL" value="${reloadURL}" />
		<tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
		<tiles:put name="objectTypeName" value="multi org" />
	</tiles:insert>

<form name="modelScoreForm" id="modelScoreForm"	action="<c:url value='/a_model.sj'/>" method="post">

<input type="hidden" id="method" name="method" value="saveModel">
<input type="hidden" name="id" id="id" value="${modelScore.id}">
<input type="hidden" name="lockVersion" value="${modelScore.lockVersion}" />

<TABLE name="tableView" class="configurationTable minWidthConfigTable" style="width: 800px; margin-left: 5px; margin-right: 5px" border="0" cellspacing="0" cellpadding="0">

<tr align="left" valign="top">
	<td colspan="3" class="configurationTableSectionNoHover" style="padding: 5px;">
		<fmt:message key="fcm.models.overview.modelDefinition.txt" />
	</td>
</tr>
<tr class="configurationTableDataRow">
	<td colspan="3">&nbsp;</td>
</tr>

<tr class="configurationTableDataRow" valign="top">
	<td nowrap valign="middle">
	<fmt:message key="fcm.models.name.txt" />:
	</td>
	<td valign="middle" colspan="2">
	<input name="label" id="label" value="${esapi:encodeForHTMLAttribute(modelScore.label)}" type="text" class="famTextEntry" size="30" maxlength="25"/>
	</td>
</tr>


<tr class="configurationTableDataRow" valign="top">
	<td nowrap valign="middle">
		<fmt:message key="fcm.models.overview.model.txt" />:
	</td>
	<td valign="middle" colspan="2">
	<c:if test="${modelScore.model==null}">
		<select name="model" id="model"	class="famSelect" style="width: 240px;">
			<option value=""
			<c:if test="${modelScore.model==null}">selected </c:if>>
			<fmt:message key="fcm.sq.strategy.noneSelected.txt" /></option>
			<c:forEach var="availableModelPackage" items="${availableModelPackages}">
			<option value="${esapi:encodeForHTMLAttribute(availableModelPackage)}"
			<c:if test="${availableModelPackage==modelScore.model}">selected</c:if>
			>${esapi:encodeForHTMLAttribute(availableModelPackage)}</option>
			</c:forEach>
		</select>
	</c:if>
	<c:if test="${modelScore.model!=null}">
		<input type="hidden" id="model" name="model" value="${modelScore.model}"/>
		${modelScore.model}
	</c:if>
	</td>
</tr>

<tr class="configurationTableDataRow" valign="top">
      <td nowrap valign="middle" ><fmt:message key="fcm.models.scoreField.txt" />:</td>
      <td valign="middle"  colspan="2">
	      	<select name="scoreId" id="scoreId" class="famSelect" style="width:240px;">
	      	<option value=""><fmt:message key="fcm.sq.strategy.noneSelected.txt"/></option>
	      	<c:forEach var="scoreField" items="${scoreFields}" varStatus="status">
	      			<option value="${scoreField.FIELD_ID}"<c:if test="${modelScore.scoreId==scoreField.FIELD_ID}"> selected</c:if>>
	      			${scoreField.FIELD_NAME}<c:if test="${modelScore.scoreId!=scoreField.FIELD_ID && scoreField.INUSE!=null}"> (<fmt:message key="fcm.models.inUse.txt"/>)</c:if>
	      			</option>
	      	</c:forEach>
	      	</select>
      </td>
</tr>
<tr class="configurationTableDataRow">
		<td colspan="3">&nbsp;</td>
</tr>
<tr class="configurationTableDataRow">
	<td colspan="3" style="padding: 0px;">
	<div id="multiOrgs" onclick="showDiv($('#multiOrgImg')[0], 'multiOrgBlock');" class="configurationSectionTitle">
	<div class="configuration-section-title-left">
	<span id="multiOrgImg" class="configurationSectionTwirly sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf06d;">
	</span>
	&nbsp;&nbsp;<fmt:message key="rules.rule.transactionScope.txt" />
	</div>
	<div class="configuration-section-title-right">
	<label><fmt:message key="fcm.users.selectAll.txt" /><input id="moSelectAll" type="checkbox" /></label>
	</div>
	</div>
	</td>
</tr>
<!-- ---------------------------------HIERARCHICHAL MO ------------------------------------------------------------------->

<tr class="configurationTableDataRow">
	<td colspan="3">
		<div id="multiOrgBlock" style="height: auto; display: none; overflow: none;">
			<div id="tree" class="configurationSection"	style="border: none; background-color: #f0f1f2; background-image: none; height: auto; overflow: none; padding: 5px;">
			</div>
		</div>
	</td>
</tr>
<!-- HIERARCHICHAL MO -->

<tr class="configurationTableDataRow">
	<td colspan="5">&nbsp;</td>
</tr>
<c:if test="${modelScore.id!='-1'}">
<!-- RULES ASSOCIATED WITH THE SCORE -->
<tr class="configurationTableDataRow">
				<td colspan="3" style="padding: 0px;">
					<div id="rules"
						onclick="showDiv($('#rulesImg')[0], 'rulesBlock');"
						class="configurationSectionTitle">
						<div class="configuration-section-title-left">
							<span id="rulesImg"
								class="configurationSectionTwirly sapUiBtnIco sapUiBtnIcoL sapUiIcon"
								style="font-family: sas-icons"
								data-sap-ui-icon-content="&#xf06e;"></span> &nbsp;&nbsp;<fmt:message key="fcm.models.rulesUsingThisScoreResult.txt" />
						</div>

					</div>
				</td>
</tr>

<tr>
		<td colspan="3" style="font-size:0.7rem;">
		<div id="rulesBlock"	style="height: auto; overflow: none;">
		<div class="configuration-section-title-right" style="padding:5px;">
		<c:if test="${not empty modelScore.scoreRules && fn:length(models)>0}">
		<fmt:message key="fcm.models.moveRules.txt"/>:
		<select name="newModelId" id="newModelId">
			<c:forEach var="model" items="${models}">
				<option value="${model.id}">${model.label}</option>
			</c:forEach>
		</select>
		<button class="sapMBtn btnVerticalAlignMiddleAdjustment" onclick="javascript:processMultiSelectRequest()" type="button">
    	<div class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnPaddingLeft sapMBtnPaddingRight sapMFocusable">
    		<span class="sapMBtnContent"><fmt:message key="fcm.models.go.txt"/></span>
    	</div>
    	</button>
		</c:if>
		</div>
<table class="mainTable" id="rulesTable" width="100%"
						align="left"
						style="margin: 0px 0px 0px 0px; -moz-user-select: none;"
						onselectstart="return false;" border="0" cellspacing="0"
						cellpadding="0">
						<thead>
							<TR class="tableColumnHeaderRow">
								<TH class="centeredTableHeader" nowrap rules:sortAsNum>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.ruleId.txt" /></TH>
								<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.ruleName.txt" /></TH>
								<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.ruleType.txt" /></TH>
								<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.businessUnit.txt" /></TH>
								<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.ruleState.txt" /></TH>
								<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.multiOrg.txt" /></TH>
								<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.queueName.txt" /></TH>
								<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.ruleDescription.txt" /></TH>
								<c:if test="${depth=='full'}">
									<TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variableDetailContent.tableHeader.ruleCode.txt" /></TH>
								</c:if>
							</TR>
						</thead>
						<TBODY id="ruleTableBody">
							<c:if test="${empty modelScore.scoreRules}">
								<TR rowspan="2">
									<TD align="right" style="font-size: 0.79rem;" colspan="100%"><center>
											<em><fmt:message key="fcm.models.noRulesUsingScoreResult.txt" />
										</center>
										</em></TD>
								</TR>
							</c:if>
							<c:if test="${not empty modelScore.scoreRules}">
								<c:forEach var="rule" items="${modelScore.scoreRules}"
									varStatus="status">
									<%-- Not honoring color alternation in css dataRow${status.count%2+1}_tableRow, so do it by hand --%>
									<%--<c:set var="bgcolor" value="white" />
									<c:if test="${status.count%2==0}">
										<c:set var="bgcolor" value="#f0f1f2" />
									</c:if>--%>
									<c:set var="bgcolor" value="transparent" />
									<TR id="${status.count}" style="cursor:pointer;" class="dataRow${status.count%2+1}_tableRow"
										onclick='handleRuleSelection(${rule.RULE_ID}, ${rule.BASE_RULE_ID}, "${rule.RULE_NAME}", "${esapi:encodeForJavaScript(rule.RULE_DESC)}", ${rule.RULE_VERSION_NBR}, ${rule.lockVersion}, "${rule.RULE_STATE}",${rule.blockingRules_coding},${rule.blockingRules_testing}, this,"rowSelected",event);'
										rulestate="${rule.RULE_STATE}" baseruleid="${rule.BASE_RULE_ID}">
										<TD style="background-color:${bgcolor};vertical-align:top;"	class="textTableCell">${rule.BASE_RULE_ID}.${rule.RULE_VERSION_NBR}</TD>
										<TD style="background-color:${bgcolor};vertical-align:top;" class="textTableCell">${fn:trim(fn:escapeXml(rule.RULE_NAME))}
										</TD>
										<TD style="background-color:${bgcolor};vertical-align:top;" class="textTableCell">${fn:trim(fn:escapeXml(rule.RULE_TYPE_NAME))}
										</TD>
										<TD style="background-color:${bgcolor};vertical-align:top;" class="textTableCell">${fn:trim(fn:escapeXml(rule.BUSINESS_UNIT_NAME))}
										</TD>
										<TD style="background-color:${bgcolor};vertical-align:top;"	class="textTableCell">${fn:trim(fn:escapeXml(rule.RULE_STATE))}
										</TD>
										<TD style="background-color:${bgcolor};vertical-align:top;"	class="textTableCell">${fn:trim(fn:escapeXml(rule.MULTI_ORG))}
										</TD>
										<TD style="background-color:${bgcolor};vertical-align:top;"	class="textTableCell">
											<c:if test="${empty rule.QUEUE_NAME}">N/A</c:if>
											<c:if test="${not empty rule.QUEUE_NAME}">${fn:trim(fn:escapeXml(rule.QUEUE_NAME))}</c:if>
										</TD>
										<TD style="background-color:${bgcolor};vertical-align:top;"	class="textTableCell">${fn:trim(fn:escapeXml(rule.RULE_DESC))}</TD>
										<c:if test="${depth=='full'}">
											<TD style="background-color:${bgcolor};vertical-align:top;"	class="textTableCell">
												<pre style="font-size: xx-small;">${fn:trim(fn:escapeXml(rule.RULE_CODE))}</pre>
											</TD>
										</c:if>
									</TR>
								</c:forEach>
								<input type="hidden" name="allRuleIds" id="allRuleIds" value="<c:forEach var="rule" items="${modelScore.scoreRules}" varStatus="status"><c:if test="${not status.first}">,</c:if>${rule.RULE_ID}</c:forEach>"/>
								<input type="hidden" name="allRuleLockVersions" id="allRuleLockVersions" value="<c:forEach var="rule" items="${modelScore.scoreRules}" varStatus="status"><c:if test="${not status.first}">,</c:if>${rule.lockVersion}</c:forEach>"/>
								<input type="hidden" name="allRuleBlockingRules_coding" id="allRuleBlockingRules_coding" value="<c:forEach var="rule" items="${modelScore.scoreRules}" varStatus="status"><c:if test="${rule.blockingRules_coding>0}">${rule.RULE_NAME},</c:if></c:forEach>"/>
								<input type="hidden" name="allRuleBlockingRules_testing" id="allRuleBlockingRules_testing" value="<c:forEach var="rule" items="${modelScore.scoreRules}" varStatus="stat"><c:if test="${rule.blockingRules_testing>0}">${rule.RULE_NAME},</c:if></c:forEach>"/>
							</c:if>
						</TBODY>
					</table>




		</div>
		</td>
</tr>

</c:if>
<!-- RULES ASSOCIATED WITH THE SCORE -->
<tr class="configurationTableDataRow">
	<td colspan="4">&nbsp;</td>
</tr>
<c:if test="${modelScore.id!='-1'}">
<!-- DISTRIBUTION GRAPH -->
<tr class="configurationTableDataRow">
				<td colspan="3" style="padding: 0px;">
					<div id="distribution"
						onclick="showDiv($('#distributionImg')[0], 'distributionBlock');"
						class="configurationSectionTitle">
						<div class="configuration-section-title-left">
							<span id="distributionImg"
								class="configurationSectionTwirly sapUiBtnIco sapUiBtnIcoL sapUiIcon"
								style="font-family: sas-icons"
								data-sap-ui-icon-content="&#xf06e;"></span> &nbsp;&nbsp;<fmt:message key="fcm.models.scoreDistribution.txt"/>
						</div>

					</div>
				</td>
</tr>

<tr class="configurationTableDataRow">
		<td colspan="3" style="font-size:0.7rem;">
		<div id="distributionBlock"	style="height: auto; overflow: none;">
		</div>
		</td>
</tr>
<tr class="configurationTableDataRow">
	<td colspan="3">&nbsp;</td>
</tr>
</c:if>

</TABLE>
</form>
</div>
<c:if test="${modelScore.id!='-1'}"><div id="jqplot" style="width:800px; height:400px;"></div></c:if>


<c:if test="${not empty updateSystemProps && !updateSystemProps}">
	<script language="JavaScript">

     //<!--
       setFormsReadOnly();

	//-->
	</script>
</c:if>
