
<%@ include file="/common/taglibs.jsp" %>
<%@ page import="java.util.List" %>
<%@ page contentType="text/html; charset=UTF-8" %>


<SCRIPT language="JavaScript" src="common/scripts/cf.js"></SCRIPT>
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/tasks.js"></script>
<script language="JavaScript" src="rules/scripts/ruleActions.js"></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/itemPriorityList.js"></script>
<script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
<style>
     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#648BB9;
      }

	eXtremeTable .odd a, .even a {
	   color: Black;
	   font-size: .88rem;
	   background-color : #FFFFFF;
	}

	.eXtremeTable .odd td, .eXtremeTable .even td {
	   padding-top: 2px;
	   padding-right: 3px;
	   padding-bottom: 2px;
	   padding-left: 3px;
	   vertical-align: middle;
	   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
	   font-size: .88rem;
	}

	.eXtremeTable .odd {
	   background-color: #FFFFFF;
	}

	.eXtremeTable .even  {
	   background-color : #f0f1f2;
	}
	.eXtremeTable .toolbar {

	   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
	   font-size: .7rem;
	   margin-right: 1px;

	}

	.eXtremeTable .toolbar td {
	   color: #444444;
	   padding: 0px 3px 0px 3px;
	   text-align:center;
	}

	.eXtremeTable .separator {
	   width: .7rem;
	}
	.eXtremeTable .title {
	   color: #444444;
	   font-weight: bold;
	   font-family: AvenirNext,'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
	   font-size: .88rem;
	   vertical-align: bottom;

	}

	.eXtremeTable .title span {
	   margin-left: 0px;

	}
	.eXtremeTable .tableHeaderSort {

	   border-top: 1px solid #E6DAC2;
	   border-bottom: 1px solid #E6DAC2;
	   border-right:none;
	   border-left: none;
	   color:#353535;
	   font-weight:bold;
	   font-family : AvenirNext,'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
	   font-size : .88rem;
	   background-color : #f0f1f2;
	      text-decoration:underline;
	}
	.eXtremeTable .calcRow {
	   background-color: #f0f1f2;
	   border-top: solid 1px;
	   border-color: #c6cad0;
	}

	.eXtremeTable .calcTitle {
	   background-color: #f0f1f2;
	   color: black;
	   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
	   font-weight: bold;
	   font-size: .88rem;
	   border-top: solid 1px;
	   border-color: #c6cad0;
	}

	.eXtremeTable .calcResult {
	   background-color: #f0f1f2;
	   color: black;
	   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
	   border-top: solid 1px;
	   border-color: #c6cad0;
	   text-align:right;
	}

</style>


<%-- Set globally available values for all Rules tab processing --%>
<c:if test="${empty QUOT}">
    <c:set var="QUOT" value='"' scope="session" />
    <c:set var="ESCQUOT" value='\\"' scope="session" />
</c:if>

<c:choose>
	<c:when test="${empty productName}">
<pre id="tabTitle" style="display:none;">SAS&reg; Fraud Management - <fmt:message key="creditfraud.tab.rules.txt" /></pre>
	</c:when>
	<c:otherwise>
<pre id="tabTitle" style="display:none;">${fn:replace(fn:replace(productName, "<sup>", ""), "</sup>", "")} - <fmt:message key="creditfraud.tab.rules.txt" /></pre>
	</c:otherwise>
</c:choose>
<script language="JavaScript">
if (parent.document)
  parent.document.title = document.getElementById("tabTitle").innerHTML;
//debugger;
var action = '<c:url value="/r_rules.do"/>';
var estimateAction = '<c:url value="/r_ruleEstimates.do"/>';
var workflow = '${esapi:encodeForHTML(workflow)}';
<c:set var="quot" value='"'/>
<c:set var="escquot" value='\\"'/>
var userId = "${fn:replace(userId,quot,escquot)}";
var noLandlordEstimation = <c:if test='${empty noLandlordEstimation}'> 0 </c:if>${noLandlordEstimation};
var estimationBusinessUnitName = "${estimationBusinessUnitName}";
var item;
var reloadParams = '?method=listRules&workflow=build&buildID=${esapi:encodeForURL(buildID)}&showAll=true';

<c:forEach var="rule" items="${rules}" >
  item = new Object();
  item.id = ${rule.id};
  item.version = ${rule.version};
</c:forEach>
var ruleNames = new Array();

function ignoreReturn(evt)
{
   if(!evt) evt = window.event;
   if(evt.keyCode == 13) return false;
   return true;
}
</script>
<c:forEach var="rule" items="${rules}" >
   <pre id="ruleName${rule.id}" style="display:none">${fn:escapeXml(rule.name)}</pre>
	<script language="JavaScript">
  	 ruleNames[${rule.id}] = document.getElementById("ruleName${rule.id}").innerHTML;
   </script>
</c:forEach>



<span style='height:0.5em'/>
<div id="rulesTabScrollableDiv" class="rulesTabScrollableClass">

<%-- Error handling code --%>
<style>
   .confirmationMessage { text-align:left; }
   .errorMessage { text-align:left; }
</style>
<div onclick="this.innerHTML='<br>'">
   <c:url var="reloadURL" value="/r_rules.do?method=listRules&ruleFolder=${esapi:encodeForURL(ruleFolder)}&showAll=true" />
   <tiles:insert page="rulesSystemMessages.jsp" flush="true">
     <tiles:put name="reloadURL" value="${reloadURL}" />
     <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
     <tiles:put name="objectTypeName" value="Rule" />
   </tiles:insert>
</div>

<div id="preTableBlock" align="left">
<h4>
	<fmt:message key="rules.diagnostic.rulesInBuild.fmt.txt">
 			<fmt:param value="${buildID}"/>
 	</fmt:message>
 	<c:set var="buildId" value="${buildID}" scope="request"/>

</h4>
</div>

<div >
<table width="98%">

<tr><td>

<table class="mainTable" id="ruleListTable" align="left" style="margin:0px 0px 0px 0px;-moz-user-select:none;" onselectstart="return false;" border="0" cellspacing="0" cellpadding="0">
   <thead>
       <TR class="tableColumnHeaderRow">
        <TH class="centeredTableHeader" nowrap rules:sortAsNum title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListDetailContent.tableHeader.id.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.id.txt"/></TH>
        <TH class="centeredTableHeader" nowrap rules:sortAsText >&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.name.txt"/></TH>
        <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.type.txt"/></TH>
        <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.description.txt"/></TH>
        <TH class="centeredTableHeader" nowrap rules:sortAsText style="display:;">&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.multiOrg.txt"/></TH>
        <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.lastUpdatedBy.txt"/></TH>
        <TH class="centeredTableHeader" nowrap rules:sortAsLocalDate>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.lastUpdatedTime.txt"/></TH>
       </TR>
   </thead>
   <TBODY id="ruleTableBody">
      <c:choose>
	      <c:when test="${empty rules}">
		      <TR rowspan="2">
		         <TD align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></TD>
		      </TR>
	      </c:when>
      	  <c:otherwise>
	     	<c:forEach var="rule" items="${rules}" varStatus="status">
	     	 <TR  id="${status.count}" class="dataRow${status.count%2+1}_tableRow" rulestate="${esapi:encodeForHTMLAttribute(rule.workflowState)}" baseruleid="${esapi:encodeForHTMLAttribute(rule.baseRuleId)}"
	             <c:choose>
	               <c:when test="${rule.workflowState !='Production'}">
	               		style="color:#D8D8D8  ;font-style:italic; cursor:not-allowed;"
	               </c:when>
	               <c:otherwise>
	                  style="cursor:pointer;" ondblclick="showTxnsFired('showTxnsFired','','','${buildID}');"
	               </c:otherwise>
	             </c:choose>
	             onclick="handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${rule.id}], '','${esapi:encodeForJavaScript(fn:escapeXml(rule.description))}','',${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)},'', '${esapi:encodeForJavaScript(rule.workflowState)}', '', '', '${esapi:encodeForJavaScript(rule.multiOrgNodeKey)}','','','', '', this,'rowSelected',event);">

				<TD class="textTableCell" title="${esapi:encodeForHTMLAttribute(rule.id)}">&nbsp;${esapi:encodeForHTML(rule.baseRuleId)}.${esapi:encodeForHTML(rule.version)}</TD>
	            <TD class="textTableCell" >&nbsp;${fn:trim(fn:escapeXml(rule.name))}</TD>
	            <TD class="textTableCell">&nbsp;
	               <fmt:message key="rules.ruleType.${rule.ruleTypeName}.txt"/>
	               <c:if test="${not empty rule.alertTypeCode && rule.alertTypeCode != ' '}">(${rule.alertTypeCode})</c:if>
              </TD>
				<TD class="textTableCell">&nbsp;${fn:escapeXml(rule.description)}</TD>
	            <TD class="textTableCell" style="display:;" title="${esapi:encodeForHTMLAttribute(fn:escapeXml(rule.businessUnitName))}"> &nbsp;${fn:trim(fn:escapeXml(rule.multiOrgLabel))} (${fn:trim(fn:escapeXml(rule.multiOrgNodeKey))})</TD>
	            <TD class="textTableCell" > &nbsp;${fn:escapeXml(rule.lastUpdateUser)}</TD>
	            <TD class="textTableCell" > &nbsp;<span dateFormat="${esapi:encodeForHTMLAttribute(dateFormat)} ${esapi:encodeForHTMLAttribute(timeFormat)}" sortvalue="${esapi:encodeForHTMLAttribute(rule.lastUpdateTimestampUtcMillis)}"><fmt:formatDate value='${rule.lastUpdateTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/></span></TD>
	         </TR>
	      </c:forEach>
      </c:otherwise>
      </c:choose>
   </TBODY>
</table>
</td></tr>
</table>
</div>
<!--
<c:if test="${workflow == 'Production'}">
<div id="rulesExportDiv" style="display:none;">
<h2> this is a test </h2>
<span id="ruleData" style="width:100%">
      <ec:table
         items="rules"
         var="rules"
         action="r_rules.do"
         title="Production Rules"
         width="100%"
         sortable="false"
         filterable="false"
         showExports="true"
         showStatusBar="true"
         tableId="ruleData"
         styleClass="mainTable"
         rowsDisplayed="20"
         view="html2"
       >
       <ec:exportPdf
          imageName="pdf"
          fileName="ProductionRules.pdf"
          tooltip="Export PDF"
          headerColor="#353535"
          headerBackgroundColor="#e0e2e5"
          headerTitle="Production Rules"
          view="pdfRulesList"
       />
       <ec:row>
       <c:set var="color" value="black" />
       <ec:column property="ruleId" title="ID" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="name" title="Name" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="businessUnitName" title="Business Unit" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="ruleTypeName" title="Type" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="alertTypeCode" title="Alert Type" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="shortDescription" title="Description" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="multiOrgNode" title="Multi-Org" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="lastUpdateUser" title="Last Updated By" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="lastUpdateTimestamp" title="Last Updated Time" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       </ec:row>
   </ec:table>
   <br><br>
</span>
</div>
</c:if>
-->

</div>

<script>
   attachEventHandlerToTableCells(['ruleListTable', 'rulePendingApprovalListTable']);
   // refresh rule folders because items may have changed

   <c:if test="${! (fn:containsIgnoreCase(workflow, 'versions') || fn:containsIgnoreCase(workflow, 'searchResults')) }">
   	var buildID="${buildID}";
   	refreshRuleFolders(action);
   </c:if>

   <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
      sortRules("ruleListTable");
      sortRules("rulePendingApprovalListTable");
   </c:if>

   <c:if test="${prioritizeRules=='yes'}">
	    document.getElementById("prioritizeRulesBlock").style.display='block';
	    document.getElementById("ruleListTable").style.display='none';
	    document.getElementById("preTableBlock").style.display='none';
   </c:if>

   <c:if test="${lastRulePriorityTabView=='postRuleDiv'}">
     swapGridContents('postRule',1);
   </c:if>

</script>


  <%-- Debug log --%>
  <pre id="debugLog" style="position:absolute; top:300px; left:0px; height:0px; width:0px; border:0px; background:yellow;text-align:left;"></pre>


