<!DOCTYPE html>
<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge">

<link rel="stylesheet" href="resources/themes/sas/hc/ui/core/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/themes/sas/hc/ui/commons/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/themes/sap/m/themes/sas_corporate/library.css" type="text/css"/>
<style type="text/css">@import "common/styles/sasStyles.css";</style>
<style type="text/css">@import "common/styles/cf.css";</style>
<style type="text/css">@import "rules/styles/rules.css";</style>
<style type="text/css">
/* S1467779 - overrides <span> in cf.css, otherwise the font size for errors, warnings and notes are bigger then that of <pre> */
pre span {font-size: inherit !important;}  
</style>

<script language='JavaScript' src='common/scripts/jquery.js'></script>
<script language='JavaScript' src='common/scripts/i18n.js'></script>
<script language="JavaScript" src="rules/scripts/estimate.js"></script>
<script language='JavaScript' src='common/scripts/sasSolutions.js'></script>
<script language='JavaScript' src='common/scripts/cf.js'></script>
<SCRIPT language=JavaScript src="admin/scripts/admin.js"></SCRIPT>
<SCRIPT language=JavaScript src="rules/scripts/rules.js"></SCRIPT>
<SCRIPT language=JavaScript src="rules/scripts/ruleSasTest.js"></SCRIPT>
<script src="<c:url value="/rules/scripts/sas-log.js" />"></script>
<script language="JavaScript">
var action = '<c:url value="/r_rules.do"/>';
var estimateAction = '<c:url value="/r_ruleEstimates.do"/>';
var userId = '';
<c:if test="${not empty userId}">
   <c:set var="quot" value='"'/>
   <c:set var="escquot" value='\\"'/>
   userId = "${fn:replace(userId,quot,escquot)}";
</c:if>

function ignoreReturn(evt)
{
   if(!evt) evt = window.event;
   if(evt.keyCode == 13) return false;
   return true;
}

</script>
</head>

<body class="details" style="margin:0px;background-color:#FFFFFF" onLoad="i18n.init();estimatesLoadHandler();">
<div id="rulesTabScrollableDiv" class="rulesTabScrollableClass">
 <div style="margin-left:10px;">
      <h4 style="text-align:left">
        <fmt:message key='rules.ruleEstimatesLog.reportTitle.fmt.txt'><fmt:param>${estimateId}</fmt:param></fmt:message>&nbsp;&nbsp;
        <c:if test="${logCount>0}">
           <select id="logNum" onchange="_showSASLog(${estimateId},this.options[this.selectedIndex].value);">
             <c:forEach var="tt" begin="1" end="${logCount}">
               <option value="${tt}" style="width:30em;"<c:if test="${tt==logNum}">selected=selected</c:if> >
               <fmt:message key='rules.ruleEstimatesLog.threadLogCount.fmt.txt'><fmt:param>${tt}</fmt:param><fmt:param>${logCount}</fmt:param></fmt:message></option>
             </c:forEach>
           </select>
        </c:if>
     </h4>
 </div>
 <c:out value="${sasLog}" escapeXml="false" />
</div>

</body>
</html>
