<%@ include file="/common/taglibs.jsp" %>
<%@ page import="java.util.List" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<script language='JavaScript' src='common/scripts/i18n.js'></script>
<SCRIPT language="JavaScript" src="common/scripts/cf.js"></SCRIPT>
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/tasks.js"></script>
<script language="JavaScript" src="rules/scripts/ruleActions.js"></script>
<script language="JavaScript" src="rules/scripts/scavenger.js"></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
<style>
     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#648BB9;
      }

eXtremeTable .odd a, .even a {
   color: Black;
   font-size: 0.88rem;
   background-color : #FFFFFF;
}

.eXtremeTable .odd td, .eXtremeTable .even td {
   padding-top: 2px;
   padding-right: 3px;
   padding-bottom: 2px;
   padding-left: 3px;
   vertical-align: middle;
   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   font-size: 0.88rem;
}

.eXtremeTable .odd {
   background-color: #FFFFFF;
}

.eXtremeTable .even {
   background-color : #f0f1f2;
}
.eXtremeTable .toolbar {

   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   font-size: 0.70rem;
   margin-right: 1px;

}

.eXtremeTable .toolbar td {
   color: #444444;
   padding: 0px 3px 0px 3px;
   text-align:center;
}

.eXtremeTable .separator {
   width: 7px;
}
.eXtremeTable .title {
   color: #444444;
   font-weight: bold;
   font-family: 'AvenirNext', 'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
   font-size: 1rem;
   vertical-align: bottom;

}

.eXtremeTable .title span {
   margin-left: 0px;

}
.eXtremeTable .tableHeaderSort {

   border-top: 1px solid #E6DAC2;
   border-bottom: 1px solid #E6DAC2;
   border-right:none;
   border-left: none;
   color:#353535;
   font-weight:bold;
   font-family : 'AvenirNext', 'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
   font-size : 0.70rem;
   background-color : #f0f1f2;
      text-decoration:underline;
}
.eXtremeTable .calcRow {
   background-color: #f0f1f2;
   border-top: solid 1px;
   border-color: #c6cad0;
}

.eXtremeTable .calcTitle {
   background-color: #f0f1f2;
   color: black;
   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   font-weight: bold;
   font-size: 0.88rem;
   border-top: solid 1px;
   border-color: #c6cad0;
}

.eXtremeTable .calcResult {
   background-color: #f0f1f2;
   color: black;
   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   border-top: solid 1px;
   border-color: #c6cad0;
   text-align:right;
}

</style>

<%-- Set globally available values for all Rules tab processing --%>
<c:if test="${empty QUOT}">
    <c:set var="QUOT" value='"' scope="session" />
    <c:set var="ESCQUOT" value='\\"' scope="session" />
</c:if>

<c:choose>
	<c:when test="${empty productName}">
       <pre id="tabTitle" style="display:none;">SAS&reg; Fraud Management - <fmt:message key="creditfraud.tab.rules.txt" /></pre>
	</c:when>
	<c:otherwise>
       <pre id="tabTitle" style="display:none;">${fn:replace(fn:replace(productName, "<sup>", ""), "</sup>", "")} - <fmt:message key="creditfraud.tab.rules.txt" /></pre>
	</c:otherwise>
</c:choose>

<script language="JavaScript">
//<!--
if (parent.document)
  parent.document.title = document.getElementById("tabTitle").innerHTML;


//"Freeze" the search block so it is always visible
function repositionSearchBlock(e) {
	var target = e.target || e.srcElement;
	$(target).find("#ruleSearchBlock").css("top", target.scrollTop + "px");
}
$("body").scroll(repositionSearchBlock);

var action = '<c:url value="/r_rules.do"/>';
var estimateAction = '<c:url value="/r_ruleEstimates.do"/>';
var workflow = '${esapi:encodeForHTML(workflow)}';
var searchFolder = '${esapi:encodeForHTML(searchFolder)}';
<c:set var="quot" value='"'/>
<c:set var="escquot" value='\\"'/>
var noLandlordEstimation = <c:if test='${empty noLandlordEstimation}'> 0 </c:if>${noLandlordEstimation};
var estimationBusinessUnitName = "${estimationBusinessUnitName}";
var item;
var reloadParams = "?method=listRules&workflow=${esapi:encodeForURL(workflow)}&showAll=true";

<c:forEach var="rule" items="${rules}" >
  item = new Object();
  item.id = ${rule.id};
  item.version = ${rule.version};
</c:forEach>

function ignoreReturn(evt)
{
   if(!evt) evt = window.event;
   if(evt.keyCode == 13) return false;
   return true;
}

<c:set var="pendingApprovalRuleExists" value=""/>
var ruleNames = new Array();

<c:forEach var="rule" items="${rules}" >
	<c:if test="${rule.pendingApproval == 'true'}">
		<c:set var="pendingApprovalRuleExists" value="true"/>
	</c:if>

//-->
</script>
   <pre id="ruleName${rule.id}" style="display:none">${fn:escapeXml(rule.name)}</pre>
<script>
//<!--
   ruleNames[${rule.id}] = document.getElementById("ruleName${rule.id}").innerHTML;
</c:forEach>

//-->
</script>
<script>
parent._estimateIdsFromForeignBusinessUnits = new Array();
<c:forEach var="id" items="${estimateIdsFromForeignBusinessUnits}">
	parent._estimateIdsFromForeignBusinessUnits["${id}"] = true;
</c:forEach>
</script>

<c:if test="${!fn:containsIgnoreCase(workflow, 'estimat')}">
  <div id="ruleSearchBlock" style="position:relative">
    <tiles:insert page="/rules/ruleSearch.jsp"/>
  </div>
</c:if>
<span style='height:0.5em'/>
<div id="rulesTabScrollableDiv" class="rulesTabScrollableClass">
<%-- Error handling code --%>
<style>
   .confirmationMessage { text-align:left; }
   .errorMessage { text-align:left; }
</style>
<div onclick="this.innerHTML='<br>'">
   <c:url var="reloadURL" value="/r_rules.do?method=listRules&showAll=true&ruleFolder=${esapi:encodeForURL(ruleFolder)}" />
   <tiles:insert page="rulesSystemMessages.jsp" flush="true">
     <tiles:put name="reloadURL" value="${reloadURL}" />
    <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
     <tiles:put name="objectTypeName" value="Rule" />
   </tiles:insert>
</div>
<div id="preTableBlock" align="left">
<h4>
<c:choose>
<c:when test="${fn:containsIgnoreCase(workflow, 'versions')}">
	<fmt:message key="rules.ruleListDetailContent.title.historyOfRule.fmt.txt">
		<fmt:param>${esapi:encodeForHTML(baseRuleId)}</fmt:param>
	</fmt:message>
<br><br>
    <c:if test="${not empty pendingApprovalRuleExists }" >
        <fmt:message key="rules.ruleListDetailContent.title.historyOfRule.pendingVersions.txt" />
    </c:if>
</c:when>
<c:when test="${fn:containsIgnoreCase(workflow, 'searchResults')}">
	<fmt:message key="rules.ruleListDetailContent.title.searchResult.txt" />
<br><br>
    <c:if test="${not empty pendingApprovalRuleExists }" >
        <fmt:message key="rules.ruleListDetailContent.title.pendingProdDeac.txt" />
    </c:if>
</c:when>
<c:when test="${fn:containsIgnoreCase(workflow, 'estimat')}">
   <tiles:insert page="/rules/estimationInfo.jsp"/>
<br>
    <c:if test="${not empty pendingApprovalRuleExists }" >
        <fmt:message key="rules.ruleListDetailContent.title.pendingProdDeac.txt" />
    </c:if>
</c:when>
<c:otherwise>
	<c:if test="${empty pendingApprovalRuleExists }" >
		<fmt:message key="rules.ruleListDetailContent.title.${workflow}.rules.txt" />
	</c:if>
	<c:if test="${not empty pendingApprovalRuleExists }" >
		<c:if test="${workflow == 'Testing' }">
			<fmt:message key="rules.ruleListDetailContent.title.pendingApproval.txt" />
		</c:if>
		<c:if test="${workflow == 'Production'}">
			<fmt:message key="rules.ruleListDetailContent.title.pendingDeactivation.txt" />
		</c:if>
	</c:if>
<br>
</c:otherwise>
</c:choose>
</h4>
</div>

<div >
<table width="98%">

<c:if test="${not empty pendingApprovalRuleExists}" >
<tr><td>
<table class="mainTable" id="rulePendingApprovalListTable" align="left" style="margin:0px 0px 0px 0px;-moz-user-select:none;" onselectstart="return false;" border="0" cellspacing="0" cellpadding="0">
   <thead>
       <TR class="tableColumnHeaderRow">
          <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsNum title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleListDetailContent.tableHeader.id.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.id.txt"/></TH>
          </c:if>
          <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
           <TH class="centeredTableHeader" nowrap rules:sortAsNum>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.version.txt"/></TH>
          </c:if>
         <TH class="centeredTableHeader" nowrap rules:sortAsText >&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.name.txt"/></TH>
         <c:choose>
         <c:when test ="${fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.action.txt"/></TH>
         </c:when>
         <c:when test="${isTenantInstall==true}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.alertType.txt"/></TH>
         </c:when>
         <c:otherwise>
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.type.txt"/></TH>
         </c:otherwise>
         </c:choose>
         <c:if test="${fn:containsIgnoreCase(searchFolder, 'allFolders') || fn:containsIgnoreCase(workflow, 'estimat')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.state.txt"/></TH>
         </c:if>
         <c:if test="${workflow == 'Testing' || workflow == 'Production'}">
         <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.pendingApproval.txt"/></TH>
         </c:if>
         <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.description.txt"/></TH>
         </c:if>
         <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText style="display:;">&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.transactionScope.txt"/></TH>
         </c:if>
         <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
         <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.notes.txt"/></TH>
         </c:if>
         <c:choose>
         <c:when test ="${fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.updatedBy.txt"/></TH>
            <TH class="centeredTableHeader" nowrap rules:sortAsLocalDate>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.updatedTime.txt"/></TH>
         </c:when>
         <c:otherwise>
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.lastUpdatedBy.txt"/></TH>
            <TH class="centeredTableHeader" nowrap rules:sortAsLocalDate>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.lastUpdatedTime.txt"/></TH>
         </c:otherwise>
         </c:choose>
       </TR>
   </thead>
   <TBODY id="rulePendingApprovalTableBody">
      <c:choose>
      <c:when test="${empty rules}">
      <TR rowspan="2">
         <TD align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></TD>
      </TR>
      </c:when>
      <c:otherwise>
      <c:forEach var="rule" items="${rules}" varStatus="status">

<c:if test="${rule.pendingApproval == 'true'}">
      <TR style="cursor:pointer;" id="${status.count}" class="dataRow${status.count%2+1}_tableRow" rulestate="${rule.workflowState}" baseruleid="${rule.baseRuleId}"
             <c:choose>
               <c:when test="${workflow=='Coding' && tenantUserNodeCount > 0}">
                    <c:if test="${empty updtRules || updtRules}">
                        ondblclick='processRequest("modifyRule","",true);'
                    </c:if>
                    <c:if test='${not empty updtRules && !updtRules}'>
                        ondblclick='processMultiSelectRequest("printRules", "", false);'
                    </c:if>
               </c:when>
               <c:otherwise>
                  ondblclick='processMultiSelectRequest("printRules", "", false);'
               </c:otherwise>
             </c:choose>
             <c:catch var="exception">${rule.isDeployed}</c:catch>
			 <c:if test="${not empty exception}"><c:set var="isDeployed" value=""/></c:if>
             onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)},ruleNames[${rule.id}],"${esapi:encodeForJavaScript(rule.ruleTypeName)}","${esapi:encodeForJavaScript(rule.description)}","${esapi:encodeForJavaScript(rule.operationalTimeLimit)}",${esapi:encodeForJavaScript(rule.version)},${esapi:encodeForJavaScript(rule.lockVersion)},"${esapi:encodeForJavaScript(isDeployed)}","${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}","${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}","${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event);' >

            <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
             <TD class="textTableCell" title="${rule.id}">&nbsp;${rule.baseRuleId}.${rule.version}</TD>
            </c:if>
            <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
             <TD class="textTableCell" >&nbsp;${rule.version}</TD>
            </c:if>
            <TD class="textTableCell" >&nbsp;
               ${fn:trim(fn:escapeXml(rule.name))}
            </TD>
            <c:choose>
            <c:when test="${fn:containsIgnoreCase(workflow, 'versions')}">
               <TD class="textTableCell" > &nbsp;
                   <fmt:message key="SystemNote.noteCode_${rule.noteCode}.txt" />
               </TD>
            </c:when>
            <c:when test='${isTenantInstall==true}'>
               <TD class="textTableCell">&nbsp;
                  <c:forEach var="alrt" items="${alertTypeInfo}">
                  	<c:if test="${not empty rule.alertTypeCode && rule.alertTypeCode != ' ' && rule.alertTypeCode==alrt.key}">
                  		${alrt.value.desc} (${rule.alertTypeCode})
                  	</c:if>
               	  </c:forEach>
               </TD>
            </c:when>
            <c:otherwise>
               <TD class="textTableCell">&nbsp;
                  <fmt:message key="rules.ruleType.${rule.ruleTypeName}.txt"/>
                  <c:if test="${not empty rule.alertTypeCode && rule.alertTypeCode != ' '}">(${rule.alertTypeCode})</c:if></TD>
            </c:otherwise>
            </c:choose>
            <c:if test="${fn:containsIgnoreCase(searchFolder, 'allFolders') || fn:containsIgnoreCase(workflow, 'estimat')}">
               <TD class="textTableCell" id="state_${status.count}"> &nbsp;<fmt:message key="rules.ruleState.${fn:trim(rule.workflowState)}.txt"/></TD>
            </c:if>
            <c:if test="${workflow == 'Testing' || workflow == 'Production'}">
               <c:choose>
               <c:when test="${rule.pendingApproval == 'true'}">
                  <TD class="textTableCell" > <fmt:message key="rules.ruleListDetailContent.requestedUser.fmt.txt"><fmt:param>${rule.lastUpdateUser}</fmt:param></fmt:message> </TD>
               </c:when>
               <c:otherwise>
                  <TD class="textTableCell" >&nbsp;</TD>
               </c:otherwise>
               </c:choose>
            </c:if>
            <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
               <TD class="textTableCell">&nbsp;
               <c:choose>
                  <c:when test="${fn:length(rule.description) < 32 }">
                     ${fn:trim(fn:escapeXml(rule.description))}
                  </c:when>
                  <c:otherwise>
                     ${fn:trim(fn:escapeXml(fn:substring(rule.description, 0, 32)))}...
                  </c:otherwise>
               </c:choose>
               </TD>
            </c:if>
            <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TD class="textTableCell" style="display:;" title="${fn:escapeXml(rule.businessUnitName)}"> &nbsp;
               ${fn:trim(fn:escapeXml(rule.multiOrgLabel))} (${fn:trim(fn:escapeXml(rule.multiOrgNodeKey))})
            </TD>
            </c:if>
            <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
            <TD class="textTableCell" >
            <c:choose>
               <c:when test="${fn:length(rule.noteUserText) < 200 }">
                  ${fn:trim(fn:escapeXml(rule.noteUserText))}
               </c:when>
               <c:otherwise>
                  ${fn:trim(fn:escapeXml(fn:substring(rule.noteUserText, 0, 200)))}...
               </c:otherwise>
            </c:choose>
            </TD>
            </c:if>
            <c:choose>
            <c:when test ="${fn:containsIgnoreCase(workflow, 'versions')}">
               <TD class="textTableCell" > &nbsp;${fn:escapeXml(rule.noteCreateUser)}</TD>
               <TD class="textTableCell" > &nbsp;
                  <span sortValue="${rule.noteCreateTimestampUtcMillis}">
                     <fmt:formatDate value='${rule.noteCreateTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
                  </span>
               </TD>
            </c:when>
            <c:otherwise>
               <TD class="textTableCell" > &nbsp;${fn:escapeXml(rule.lastUpdateUser)}</TD>
               <TD class="textTableCell" > &nbsp;
                  <span sortValue="${rule.lastUpdateTimestampUtcMillis}">
	                 <fmt:formatDate value='${rule.lastUpdateTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
	              </span>
               </TD>
            </c:otherwise>
            </c:choose>
         </TR>
</c:if>
      </c:forEach>
      </c:otherwise>
      </c:choose>
   </TBODY>
</table>
</td></tr>

<tr><td align="left">
<h4>
<c:choose>
<c:when test="${fn:containsIgnoreCase(workflow, 'versions')}">
    <fmt:message key="rules.ruleListDetailContent.title.historyOfRule.otherVersions.txt" />
</c:when>
<c:when test="${fn:containsIgnoreCase(workflow, 'searchResults')}">
    <fmt:message key="rules.ruleListDetailContent.title.${searchFolder}.rules.txt" />
</c:when>
<c:when test="${fn:containsIgnoreCase(workflow, 'estimat')}">
    <fmt:message key="rules.ruleListDetailContent.title.testingProduction.txt" />
</c:when>
<c:otherwise>
    <fmt:message key="rules.ruleListDetailContent.title.${workflow}.rules.txt" />
</c:otherwise>
</c:choose>
<br>
</h4>
</td></tr>

</c:if>

<tr><td>

<table class="mainTable" id="ruleListTable" align="left" style="margin:0px 0px 0px 0px;-moz-user-select:none;" onselectstart="return false;" border="0" cellspacing="0" cellpadding="0">
   <thead>
       <TR class="tableColumnHeaderRow">
          <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsNum title="<fmt:message key='rules.ruleListDetailContent.tableHeader.id.title.txt'/>">&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.id.txt"/></TH>
          </c:if>
          <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
           <TH class="centeredTableHeader" nowrap rules:sortAsNum>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.version.txt"/></TH>
          </c:if>
         <TH class="centeredTableHeader" nowrap rules:sortAsText >&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.name.txt"/></TH>
         <c:choose>
         <c:when test ="${fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.action.txt"/></TH>
         </c:when>
         <c:when test="${isTenantInstall==true}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.alertType.txt"/></TH>
            <TH class="centeredTableHeader" nowrap rules:sortAsRuleExec>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.orderPriority.txt"/></TH>
         </c:when>
         <c:otherwise>
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.type.txt"/></TH>
            <TH class="centeredTableHeader" nowrap rules:sortAsRuleExec>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.orderPriority.txt"/></TH>
         </c:otherwise>
         </c:choose>
         <c:if test="${fn:containsIgnoreCase(searchFolder, 'allFolders') || fn:containsIgnoreCase(workflow, 'estimat')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.state.txt"/></TH>
         </c:if>
         <c:if test="${workflow == 'Testing' || workflow == 'Production'}">
         <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.pendingApproval.txt"/></TH>
         </c:if>
         <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.description.txt"/></TH>
         </c:if>
         <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText style="display:;">&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.transactionScope.txt"/></TH>
         </c:if>
         <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
         <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.notes.txt"/></TH>
         </c:if>
         <c:choose>
         <c:when test ="${fn:containsIgnoreCase(workflow, 'versions')}">
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.updatedBy.txt"/></TH>
            <TH class="centeredTableHeader" nowrap rules:sortAsLocalDate>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.updatedTime.txt"/></TH>
         </c:when>
         <c:otherwise>
            <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.lastUpdatedBy.txt"/></TH>
            <TH class="centeredTableHeader" nowrap rules:sortAsLocalDate>&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.lastUpdatedTime.txt"/></TH>
         </c:otherwise>
         </c:choose>
         <c:if test ="${workflow=='Coding'}">
         <TH class="centeredTableHeader" nowrap rules:sortAsText >&nbsp;<fmt:message key="rules.ruleListDetailContent.tableHeader.guided.txt"/></TH>
         </c:if>
       </TR>
   </thead>
   <TBODY id="ruleTableBody">
      <c:choose>
      <c:when test="${empty rules}">
      <TR rowspan="2">
         <TD align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></TD>
      </TR>
      </c:when>
      <c:otherwise>
      <c:forEach var="rule" items="${rules}" varStatus="status">
 <c:if test="${rule.pendingApproval != 'true'}">
      <TR style="cursor:pointer;" id="${status.count}" class="dataRow${status.count%2+1}_tableRow" ruleState="${rule.workflowState}" baseRuleId="${rule.baseRuleId}"
             <c:choose>
               <c:when test="${workflow=='Coding' && tenantUserNodeCount > 0}">
                    <c:if test="${empty updtRules || updtRules}">
                        ondblclick='processRequest("modifyRule","",true);'
                    </c:if>
                    <c:if test='${not empty updtRules && !updtRules}'>
                        ondblclick='processMultiSelectRequest("printRules", "", false);'
                    </c:if>
               </c:when>
               <c:otherwise>
                  ondblclick='processMultiSelectRequest("printRules", "", false);'
               </c:otherwise>
             </c:choose>
             <c:catch var="exception">${rule.isDeployed}</c:catch>
			 <c:if test="${not empty exception}"><c:set var="isDeployed" value=""/></c:if>
             onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${rule.id}], "${esapi:encodeForJavaScript(rule.ruleTypeName)}","${esapi:encodeForJavaScript(rule.description)}","${esapi:encodeForJavaScript(rule.operationalTimeLimit)}",${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)}, "${esapi:encodeForJavaScript(isDeployed)}", "${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}", "${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}","${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event);' >

            <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
             <TD class="textTableCell" title="${rule.id}">&nbsp;${rule.baseRuleId}.${rule.version}</TD>
            </c:if>
            <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
             <TD class="textTableCell" >&nbsp;${rule.version}</TD>
            </c:if>
            <TD class="textTableCell" >&nbsp;
               ${fn:trim(fn:escapeXml(rule.name))}
            </TD>
            <c:choose>
            <c:when test="${fn:containsIgnoreCase(workflow, 'versions')}">
               <TD class="textTableCell" > &nbsp;
                  <fmt:message key="SystemNote.noteCode_${rule.noteCode}.txt" />
               </TD>
            </c:when>
            <c:when test='${isTenantInstall==true}'>
               <TD class="textTableCell">&nbsp;
               	  <c:forEach var="alrt" items="${alertTypeInfo}">
                  	<c:if test="${not empty rule.alertTypeCode && rule.alertTypeCode != ' ' && rule.alertTypeCode==alrt.key}">
                  		${alrt.value.desc} (${rule.alertTypeCode})
                  	</c:if>
               	  </c:forEach>
               </TD>
               <TD class="textTableCell" >&nbsp;<c:if test="${rule.executionOrderType==1}"><fmt:message key="rules.ruleListDetailContent.table.postRule.txt"/> : ${rule.executionOrderPriority}</c:if><c:if test="${rule.executionOrderType==0}"><fmt:message key="rules.ruleListDetailContent.table.mainRule.txt"/></c:if><c:if test="${rule.executionOrderType==-1}"><fmt:message key="rules.ruleListDetailContent.table.preRule.txt"/> : ${rule.executionOrderPriority}</c:if></TD>
            </c:when>
            <c:otherwise>
               <TD class="textTableCell">&nbsp;
                  <fmt:message key="rules.ruleType.${rule.ruleTypeName}.txt"/>
                  <c:if test="${not empty rule.alertTypeCode && rule.alertTypeCode != ' '}">(${rule.alertTypeCode})</c:if></TD>
                  <TD class="textTableCell" data-rule='{"id":${rule.id},"baseRuleId":${rule.baseRuleId},"typeName":"${rule.ruleTypeName}","execOrder":${rule.executionOrderType},"execPriority":${rule.executionOrderPriority}}'>
                  <c:if test="${rule.executionOrderType==1}"><fmt:message key="rules.ruleListDetailContent.table.postRule.txt"/> : ${rule.executionOrderPriority}</c:if>
                  <c:if test="${rule.executionOrderType==0}"><fmt:message key="rules.ruleListDetailContent.table.mainRule.txt"/></c:if>
                  <c:if test="${rule.executionOrderType==-1}"><fmt:message key="rules.ruleListDetailContent.table.preRule.txt"/> : ${rule.executionOrderPriority}</c:if>
              </TD>
            </c:otherwise>
            </c:choose>
            <c:if test="${fn:containsIgnoreCase(searchFolder, 'allFolders') || fn:containsIgnoreCase(workflow, 'estimat')}">
               <TD class="textTableCell" id="state_${status.count}"> &nbsp;<fmt:message key="rules.ruleState.${fn:trim(rule.workflowState)}.txt"/></TD>
            </c:if>
            <c:if test="${workflow == 'Testing' || workflow == 'Production'}">
               <c:choose>
               <c:when test="${rule.pendingApproval == 'true'}">
                  <TD class="textTableCell" > <fmt:message key="rules.ruleListDetailContent.requestedUser.fmt.txt"><fmt:param>${rule.lastUpdateUser}</fmt:param></fmt:message> </TD>
               </c:when>
               <c:otherwise>
                  <TD class="textTableCell" >&nbsp;</TD>
               </c:otherwise>
               </c:choose>
            </c:if>
            <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
               <TD class="textTableCell">
               <c:choose>
                  <c:when test="${fn:length(rule.description) < 32 }">
                     ${fn:trim(fn:escapeXml(rule.description))}
                  </c:when>
                  <c:otherwise>
                     ${fn:trim(fn:escapeXml(fn:substring(rule.description, 0, 32)))}...
                  </c:otherwise>
               </c:choose>
               </TD>
            </c:if>
            <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
            <TD class="textTableCell" style="display:;" title="${fn:escapeXml(rule.businessUnitName)}"> &nbsp;
               ${fn:trim(fn:escapeXml(rule.multiOrgLabel))} (${fn:trim(fn:escapeXml(rule.multiOrgNodeKey))})
            </TD>
            </c:if>
            <c:if test ="${fn:containsIgnoreCase(workflow, 'versions')}">
            <TD class="textTableCell" >
            <c:choose>
               <c:when test="${fn:length(rule.noteUserText) < 200 }">
                  ${fn:trim(fn:escapeXml(rule.noteUserText))}
               </c:when>
               <c:otherwise>
                  ${fn:trim(fn:escapeXml(fn:substring(rule.noteUserText, 0, 200)))}...
               </c:otherwise>
            </c:choose>
            </TD>
            </c:if>
            <c:choose>
            <c:when test ="${fn:containsIgnoreCase(workflow, 'versions')}">
               <TD class="textTableCell" > &nbsp;${fn:escapeXml(rule.noteCreateUser)}</TD>
               <TD class="textTableCell" > &nbsp;
                  <span sortValue="${rule.noteCreateTimestampUtcMillis}">
                     <fmt:formatDate value='${rule.noteCreateTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
                  </span>
               </TD>
            </c:when>
            <c:otherwise>
               <TD class="textTableCell" > &nbsp;${fn:escapeXml(rule.lastUpdateUser)}</TD>
               <TD class="textTableCell" > &nbsp;
                  <span sortValue="${rule.lastUpdateTimestampUtcMillis}">
                     <fmt:formatDate value='${rule.lastUpdateTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
                  </span>
               </TD>
            </c:otherwise>
            </c:choose>
	        <c:if test ="${workflow=='Coding'}">
            <TD class="textTableCell" >&nbsp;
               <c:if test="${rule.guidedRule}">
			   <span><fmt:message key="rules.ruleListDetailContent.table.yes.txt"/></span>
               </c:if>
               <c:if test="${!rule.guidedRule}">
			   <span><fmt:message key="rules.ruleListDetailContent.table.no.txt"/></span>
               </c:if>
            </TD>
            </c:if>
         </TR>
</c:if>
      </c:forEach>
      </c:otherwise>
      </c:choose>
   </TBODY>
</table>
</td></tr>
</table>
</div>

<%-- commented out the below as it is *TEST* code? **** Also this tag suffers XSS attack. ****

<c:if test="${workflow == 'Production'}">
<div id="rulesExportDiv" style="display:none;">
<h2> this is a test </h2>
<span id="ruleData" style="width:100%">
      <ec:table
         items="rules"
         var="rules"
         action="r_rules.do"
         title="Production Rules"
         width="100%"
         sortable="false"
         filterable="false"
         showExports="true"
         showStatusBar="true"
         tableId="ruleData"
         styleClass="mainTable"
         rowsDisplayed="20"
         view="html2"
       >
       <ec:exportPdf
          imageName="pdf"
          fileName="ProductionRules.pdf"
          tooltip="Export PDF"
          headerColor="#353535"
          headerBackgroundColor="#e0e2e5"
          headerTitle="Production Rules"
          view="pdfRulesList"
       />
       <ec:row>
       <c:set var="color" value="black" />
       <ec:column property="ruleId" title="ID" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="name" title="Name" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="businessUnitName" title="Business Unit" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="ruleTypeName" title="Type" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="alertTypeCode" title="Alert Type" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="shortDescription" title="Description" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="multiOrgNode" title="Multi-Org" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="lastUpdateUser" title="Last Updated By" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="lastUpdateTimestamp" title="Last Updated Time" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       </ec:row>
   </ec:table>
   <br><br>
</span>
</div>
</c:if>

<c:if test="${fn:containsIgnoreCase(workflow, 'versions')}">
<div id="rulesExportDiv" style="display:none;">
<h2> this is a test </h2>
<span id="ruleData" style="width:100%">
      <ec:table
         items="rules"
         var="rules"
         action="r_rules.do"
         title="History of Rule ${esapi:encodeForHTML(baseRuleId)}"
         width="100%"
         sortable="false"
         filterable="false"
         showExports="true"
         showStatusBar="true"
         tableId="ruleData"
         styleClass="mainTable"
         rowsDisplayed="20"
         view="html2"
       >
       <ec:exportPdf
          imageName="pdf"
          fileName="RuleHistory.pdf"
          tooltip="Export PDF"
          headerColor="#353535"
          headerBackgroundColor="#e0e2e5"
          headerTitle="History of Rule ${esapi:encodeForHTML(baseRuleId)}"
          view="pdfRulesList"
       />
       <ec:row>
       <c:set var="color" value="black" />
       <ec:column property="version" title="Version" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="name" title="Name" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="noteType" title="Action" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="noteUserText" title="Notes" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="multiOrgNode" title="Multi-Org" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="noteCreateUser" title="Updated By" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       <ec:column property="noteCreateTimestamp" title="Updated Time" headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
       </ec:row>
   </ec:table>
   <br><br>
</span>
</div>
</c:if>
--%>

</div>

<script>

   attachEventHandlerToTableCells(['ruleListTable', 'rulePendingApprovalListTable']);
   // refresh rule folders because items may have changed

   <c:if test="${! (fn:containsIgnoreCase(workflow, 'versions') || fn:containsIgnoreCase(workflow, 'searchResults')) }">
     refreshRuleFolders(action);
   </c:if>

   <c:if test ="${!fn:containsIgnoreCase(workflow, 'versions')}">
      sortRules("ruleListTable");
      sortRules("rulePendingApprovalListTable");
   </c:if>

   <c:if test="${empty sessionScope.transactionLatestDate}">
      var url = '<c:url value="/r_rules.do"/>?method=setDateRange';
      var iframe = document.createElement('iframe');
      (iframe.frameElement || iframe).style.cssText = "width: 0; height: 0; border: 0";
      var where = document.getElementsByTagName('script');
      where = where[where.length - 1];
      where.parentNode.insertBefore(iframe, where);
      var doc = iframe.contentWindow.document;
      doc.open().write('<body onload="'+
        'var js = document.createElement(\'script\');'+
        'js.src = \''+ url +'\';'+
        'document.body.appendChild(js);">');
      doc.close();
   </c:if>

</script>


  <%-- Debug log --%>
  <pre id="debugLog" style="position:absolute; top:300px; left:0px; height:0px; width:0px; border:0px; background:yellow;text-align:left;"></pre>


