// for single select
var selectedRuleId = '';
var selectedBaseRuleId = '';
var selectedRuleName = '';
var selectedRuleDescription = '';
var selectedRuleOperationalTimeLimit = "";
var selectedRuleVersion = '';
var selectedRuleLockVersion = '';
var selectedRuleIsDeployed = '';
var selectedRuleState = '';
var selectedRuleGuidedRule = '';
var selectedRuleTransactionTypeId = '';
var selectedRuleMultiOrgNodeId = '';
var selectedRuleAlertTypeCode='';
var selectedRuleExecutionOrderPriority='';
var selectedRuleQueueId='';
var selectedRuleAlertReason='';

// for multi select
var selectedRuleIds = '';
var selectedBaseRuleIds = '';
var selectedRuleNames = '';
var selectedRuleDescriptions = '';
var selectedRuleOperationalTimeLimits = "";
var selectedRuleVersions = '';
var selectedRuleLockVersions = '';
var selectedRulesAreDeployed = '';
var selectedRuleStates = '';
var selectedRuleGuidedRules = '';
var selectedRuleTransactionTypeIds = '';
var selectedRuleMultiOrgNodeIds = '';
var selectedRuleAlertTypeCodes = '';
var selectedRuleExecutionOrderPriorities = '';
var selectedRuleQueueIds = '';
var selectedRuleAlertReasons='';

function setSelectedRules()
{
    var selectedRuleIdList = new Array();
    var selectedBaseRuleIdList = new Array();
    var selectedRuleNameList = new Array();
    var selectedRuleDescriptionList = new Array();
    var selectedRuleOperationalTimeLimitList = new Array();
    var selectedRuleVersionList = new Array();
    var selectedRuleLockVersionList = new Array();
    var selectedRuleDeployedList = new Array();
    var selectedRuleStateList = new Array();
    var selectedRuleGuidedRuleList = new Array();
    var selectedRuleTransactionTypeIdList = new Array();
    var selectedRuleMultiOrgNodeIdList = new Array();
    var selectedRuleAlertTypeCodeList= new Array();
    var selectedRuleExecutionOrderPriorityList= new Array();
    var selectedRuleQueueIdList= new Array();
    var selectedRuleAlertReasonList = new Array();

    selectedRuleId = '';
    selectedBaseRuleId = '';
    selectedRuleName = '';
    selectedRuleDescription = '';
    selectedRuleOperationalTimeLimit = "";
    selectedRuleVersion = '';
    selectedRuleLockVersion = '';
    selectedRuleDeployed = '';
    selectedRuleState = '';
    selectedRuleGuidedRule = '';
    selectedRuleTransactionTypeId = '';
    selectedRuleMultiOrgNodeId = '';
    selectedRuleQueueId='';
    selectedRuleExecutionOrderPriority='';
    selectedRuleAlertTypeCode='';
    selectedRuleAlertReason='';

    // alert("setSelectedRules");

    // iterate through keys in hashmap
    for(var i in _highlightedRowMap)
    {
        var selection = _highlightedRowMap[i];
        if(selection != null && isDefined(selection))
        {
          var rule = selection.mappedObject;
          var p = rule.position;
          selectedRuleIdList[p] = rule.id;
          selectedBaseRuleIdList[p] = rule.baseRuleId;
          selectedRuleNameList[p] = rule.name;
          selectedRuleDescriptionList[p] = rule.description.replace(/,/g,"%2C");
          selectedRuleOperationalTimeLimitList[p] = rule.operationalTimeLimit;
          selectedRuleVersionList[p] = rule.version;
          selectedRuleLockVersionList[p] = rule.lockVersion;
          selectedRuleDeployedList[p] = rule.isDeployed;
          selectedRuleStateList[p] = rule.state;
          selectedRuleGuidedRuleList[p] = rule.guidedRule;
          selectedRuleTransactionTypeIdList[p] = rule.transactionTypeId;
          selectedRuleMultiOrgNodeIdList[p] = rule.multiOrgNodeId;
          selectedRuleAlertTypeCodeList[p]=rule.alertTypeCode;
          selectedRuleExecutionOrderPriorityList[p]=rule.executionOrderPriority;
          selectedRuleQueueIdList[p]=rule.queueId;
          selectedRuleAlertReasonList[p] = rule.alertReason.replace(/,/g,"%2C");
        }
    }

    // Assign values in their displayed order (trim multi, leading, and trailing commas)
    selectedRuleIds = selectedRuleIdList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedBaseRuleIds = selectedBaseRuleIdList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleNames = selectedRuleNameList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleDescriptions = selectedRuleDescriptionList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleOperationalTimeLimits = selectedRuleOperationalTimeLimitList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleVersions = selectedRuleVersionList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleLockVersions = selectedRuleLockVersionList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRulesAreDeployed = selectedRuleDeployedList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleStates = selectedRuleStateList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleGuidedRules = selectedRuleGuidedRuleList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleTransactionTypeIds = selectedRuleTransactionTypeIdList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleMultiOrgNodeIds = selectedRuleMultiOrgNodeIdList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleAlertTypeCodes=selectedRuleAlertTypeCodeList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleExecutionOrderPriorities=selectedRuleExecutionOrderPriorityList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleQueueIds=selectedRuleQueueIdList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    selectedRuleAlertReasons=selectedRuleAlertReasonList.join(",").replace(/^,*|,*$/g,"").replace(/,+/g,",");
    // Show single selection if only one selected
    if (selectedRuleIds.split(',').length == 1)
    {
      selectedRuleId = selectedRuleIds.split(',')[0];
      selectedBaseRuleId = selectedBaseRuleIds.split(',')[0];
      selectedRuleName = selectedRuleNames.split(',')[0];
      selectedRuleDescription = selectedRuleDescriptions.split(',')[0];
      selectedRuleOperationalTimeLimit = selectedRuleOperationalTimeLimits.split(",")[0];
      selectedRuleVersion = selectedRuleVersions.split(',')[0];
      selectedRuleLockVersion = selectedRuleLockVersions.split(',')[0];
      selectedRuleIsDeployed = selectedRulesAreDeployed.split(',')[0];
      selectedRuleState = selectedRuleStates.split(',')[0];
      selectedRuleGuidedRule = selectedRuleGuidedRules.split(',')[0];
      selectedRuleTransactionTypeId = selectedRuleTransactionTypeIds.split(',')[0];
      selectedRuleMultiOrgNodeId = selectedRuleMultiOrgNodeIds.split(',')[0];
      selectedRuleAlertTypeCode=selectedRuleAlertTypeCodes.split(',')[0];
      selectedRuleExecutionOrderPriority=selectedRuleExecutionOrderPriorities.split(',')[0];
      selectedRuleQueueId=selectedRuleQueueIds.split(',')[0];
      selectedRuleAlertReason=selectedRuleAlertReasons.split(',')[0];
   }

}

//variables to store values updated by model dialog
var fromEmailAddress = '';
var emailList = '';
var userNotes = '';

function changeRuleEnableState(bEnabled, successMessage) {
	setSelectedRules();
	var buId=parent.frames["overview"].getContent("workingBuId");
	var opState = (bEnabled) ? "0" : "1";
	var confMsg=$i18n("rules.rulesPage.ruleAction.enable.txt");
	var jsonData = [];	
	var selectedRuleIdList=selectedRuleIds.split(",");
	var disabledIds=[];
	for (var i = 0; i < selectedRuleIdList.length; i++) {
		jsonData.push({id: selectedRuleIdList[i], configuredOperationalState: opState});
	}
	if(opState!="0"){//if disabling, check for rule dependencies
		parent.sas.ajax({url:"rest/businessunits/" + buId + "/rules/dependents", type: "POST", data: jsonData})
		.done(function(oData){			
			disabledIds=Object.keys(oData);
			if(disabledIds.length>0){
				var confMsg2="";
				for (i=0;i<disabledIds.length;i++){
					confMsg2+=$i18n("rules.rulesPage.ruleAction.confirmDependencies.txt",[oData[disabledIds[i]],disabledIds[i]])
				}
			}
			if((disabledIds.length==0 ||( disabledIds.length>0 && confirm(confMsg2+=$i18n("rules.rulesPage.ruleAction.confirmProceed.txt"))))){
				parent.sas.ajax({url:"rest/businessunits/" + buId + "/rules", type: "PUT", data: jsonData})
				.done(function(oData){
					confMsg=$i18n("rules.rulesPage.ruleAction.disable.txt");
					console.log($i18n("rules.rulesPage.ruleAction.disable.txt"));
					getActiveDeployment(confMsg);
				}).fail(function(oObj,textStatus,errorThrown){
					console.log("Rule failed to update");
				});
			}
				
		}).fail(function(oObj,textStatus,errThrown){
			console.log("Could not retrieve rules' dependents.");
		});
	}else{
		parent.sas.ajax({url:"rest/businessunits/" + buId + "/rules", type: "PUT", data: jsonData})
		.done(function(oData){
			confMsg=$i18n("rules.rulesPage.ruleAction.enable.txt");
			console.log($i18n("rules.rulesPage.ruleAction.enable.txt"));
			getActiveDeployment(confMsg);
		}).fail(function(oObj,textStatus,errorThrown){
			console.log("Rule failed to update");
		});
	}			
}

//optional: destWorkflow, newWindow, srcWorkflow, allowAll) (S1102363)
function processMultiSelectRequest(method, destWorkflow, newWindow, srcWorkflow, allowAll) // S1102363
{
   setSelectedRules();
   if(selectedRuleIds.length == 0) {
      if (!allowAll || !confirm($i18n("rules.ruleAction.js.selectAllRules.confirm.txt"))) {  // S1102363
         alert($i18n("rules.ruleAction.js.selectRules.alert.txt"));
         return;
      }
   }
   // escape # character
   selectedRuleNames = selectedRuleNames.replace(/#/g, '%23').replace(/%/g, '%25');

   var theAction = (method == "createEstimate") ? estimateAction : action;
   var showAll = true; // S1358446, S1407594
   var overviewFrameSelectedObject = top.frames["overview"]._selectedObject;
   if (((workflow == "Coding") && (overviewFrameSelectedObject != "allCoding"))
		   || ((workflow.indexOf("ESTIMATION_USER") === 0) && (overviewFrameSelectedObject != "ESTIMATION_USER_allEstimates")) ) {
	   showAll = false;
   };
   // TODO: Use POST of form fields instead of a GET with a URL
   var link = theAction + "?method=" + method + "&idList=" + selectedRuleIds +
                 "&lockVersionList=" + selectedRuleLockVersions +
                 "&destWorkflow=" + destWorkflow + "&showAll=" + showAll;

   if (workflow=='Estimations')
      link += "&workflow=" + (document.forms.estimateForm.excludeTestingRules.checked ? "Production" : "Testing");
   else if (allowAll) // S1102363
      link += "&workflow=" + srcWorkflow; // S1102363
   else
      link += "&workflow=" + selectedRuleStates.split(",")[0];
   selectedRuleIds = '';
   if(method == "processStateTransition") {
      link += "&fromEmailAddress=" + fromEmailAddress;
      link += "&emailList=" + emailList;
      link += "&userNotes=" + userNotes;
      if (srcWorkflow != "Production") {
          if (destWorkflow=="Production" && hasUnacceptableStates("Testing", "rules.ruleAction.js.toProduction.alert.fmt.txt")) return;
          else if (destWorkflow=="Coding" && hasUnacceptableStates("Testing", "rules.ruleAction.js.toCoding.alert.fmt.txt")) return;
          else if (destWorkflow=="Deactivated" && hasUnacceptableStates("Production","rules.ruleAction.js.toDeactivated.alert.fmt.txt")) return;
      }
   }
   if(method == 'createEstimate') {
      var excludeTestingRules = document.getElementById("excludeTestingRules"); // S1065224
      link += "&excludeTestingRules=" + (excludeTestingRules && excludeTestingRules.checked); // S1065224
      var estName = trim(document.getElementById("estimateName").value);
      if (estName.length>50 && estName.substring(0,5)=='DEBUG') {
          alert($i18n("rules.ruleAction.js.nameLengthLimit.alert.fmt.txt", [estName.length-50]));
          return;
      }
      link +="&estimateName=" + encodeURIComponent(estName);
      link +="&estimationStartDate=" +  document.getElementById("estimationStartDate").value;
      link +="&estimationEndDate=" + document.getElementById("estimationEndDate").value;
      link += "&debug=" + document.getElementById("debug").value; // S1162965

      if (document.getElementById("noRecontactBox").checked) {
         var nrdays = trim(document.getElementById("noRecontactDays").value);
         if (!nrdays.match(/^\d+$/))
             nrdays = -1;
         else {
            try { nrdays = parseInt(nrdays); }
            catch (e) { nrdays = -1; }
         }
         if (nrdays=='' || nrdays < 1 || nrdays > 2147483647) {
             alert($i18n("rules.ruleAction.js.noRecontactLimit.alert.fmt.txt", [document.getElementById("noRecontactDays").value]));
             return;
         }
         link += "&noRecontactDays=" + encodeURIComponent(trim(document.getElementById("noRecontactDays").value));
      }
      else
         link += "&noRecontactDays=0";
      link += "&dampenFirings=" + document.getElementById("dampenFirings").checked;
      link += "&reportTotalCounts=" + document.getElementById("reportTotalCounts").checked;
      link += "&cacheUserVars=" + document.getElementById("cacheUserVars").checked;
      link += "&sortInSas=" + document.getElementById("sortInSas").checked;

      var splitTransactions = document.getElementById("splitTransactions").checked;
      link += "&splitTransactions=" + splitTransactions;
      var sampPct = getValidSamplePercent(document.getElementById("samplePercent"));
      var multiThreading = document.getElementById("useMultiThreading").checked;
      if (splitTransactions) {
         var sampKey = document.getElementById("sampleKey");
         link += "&sampleKey=" + sampKey.options[sampKey.selectedIndex].value;

         if (!sampPct)
             return;
         link += "&samplePercent=" + sampPct;

         var sampBktStr = document.getElementById("sampleBucket").value;
         var sampBkt;
         var sampBktLimit = Math.ceil(100/sampPct);
         try { sampBkt = parseInt(sampBktStr); }
         catch (e) { sampBkt = -1; }
         if (!sampBkt || sampBkt <= 0 || sampBkt > sampBktLimit || sampBktStr.indexOf(".")>=0)
         {
             alert($i18n("rules.ruleAction.js.bucketNumberLimit.alert.fmt.txt", [sampBktStr, sampBktLimit]) );
             return;
         }
         link += "&sampleBucket=" + sampBkt;

         var sampThd;
         if (multiThreading) {
            var sampThdStr = document.getElementById("sampleThreads").value;
            var sampThdMax = document.getElementById("estimationMaxThreadCount") ? document.getElementById("estimationMaxThreadCount").value : 1;
            sampThdLimit = Math.min(sampThdMax, Math.floor(10*sampPct));
            try { sampThd = parseInt(sampThdStr); }
            catch (e) { sampThd = -1; }
            if (!sampThd || sampThd < 1 || sampThd > sampThdLimit || sampThdStr.indexOf(".")>=0)
            {
                alert( $i18n("rules.ruleAction.js.threadCountLimit.alert.fmt.txt", [sampThdStr, sampThdLimit, sampThdMax]) );
                return;
            }
         }
         else
             sampThd = 1;
         link += "&sampleThreads=" + sampThd;
      }
      else {
         if (sampPct && sampPct != 100) {
             alert( $i18n("rules.ruleAction.js.samplePercentInvalid.alert.fmt.txt", [sampPct]) );
             return;
         }
         if (multiThreading) {
             alert( $i18n("rules.ruleAction.js.parallelProcessingInvalid.alert.txt") );
             return;
         }
      }

      link += "&filterAccount=" + encodeURIComponent(document.getElementById("filterAccount").value);
      if (document.getElementById("reportRedistributableAlerts"))
      {
          var isRedist = document.getElementById("reportRedistributableAlerts").checked;
          if (isRedist && selectedRuleStates.indexOf('Testing')>=0) {
            alert( $i18n("rules.ruleAction.js.redistributionInvalid.alert.txt") );
            return;
          }
          link += "&reportRedistributableAlerts=" + isRedist;
      }
      var tags = document.getElementsByTagName("INPUT");
      for (var t in tags)
      {
         if (tags[t].id && tags[t].id.substr(0,9)=='reportPer')
            link += "&" + tags[t].id + "=" + tags[t].checked;
      }
   }
   /*if(destWorkflow=='Trash' && selectedRuleIsDeployed == 'true'){
	   alert(selectedRuleName + " - " + $i18n("rules.ruleAction.ruleRepoService.cannotDeleteDeployedRule.txt"));
	      return;
   }*/ //can now allow delete since rule is logically deleted
   if(method == 'deleteRules')
   {
      if(!confirm( $i18n("rules.ruleAction.js.deleteRule.confirm.txt") ))
        return;
   }

   // Send the request to a new window (if so requested and not already open)
   if (newWindow)
   {
         openRuleDetailWindow( link, selectedRuleId );
   }
   else if (method == 'printRules')
   {
     var printWindowName = 'PrintableRule'+new Date().valueOf();
     var w = window.open('common/blank.html',
                         printWindowName,
                         'menubar,toolbar,resizable=1, scrollbars=1, status=1, width=800, height=600');
     $df.postURL(printWindowName, link);
     w.focus();
   }
   else
   {
      if(method != 'exportRules')
         setBusyDetail();
      //parent.frames[ "detail" ].location.href = link;
      link += '&__sfmrt=' + getCookie("__sfmrt");
	  $df.postURL("detail", link);
   }

}

function showTxnsFired(method, destWorkflow, newWindow, buildID){
	setSelectedRules();
	 if (selectedRuleId == '')
	   {
	      alert("A single rule must be selected before this action can be processed");
	      return;
	}
	// escape # character
	   selectedRuleName = selectedRuleName.replace(/#/g, '%23').replace(/%/g, '%25');

	var link = action + "?method=" + method + "&id=" + selectedRuleId + "&baseRuleId=" + selectedBaseRuleId +
    "&version=" + selectedRuleVersion + "&name=" + selectedRuleName +
    "&lockVersion=" + selectedRuleLockVersion + "&workflow=" + selectedRuleState
    + "&destWorkflow=" + destWorkflow+"&buildId="+buildID;

	setBusyDetail();
  	parent.sas.fscf.getCurrentDetailToolbar().setContentFor();
    link += '&__sfmrt=' + getCookie("__sfmrt");
	$df.postURL("detail", link);

}


// Invokes a detail view of the previously-established rule (optional: destWorkflow, newWindow)
function processRequest(method, destWorkflow, newWindow)
{
   setSelectedRules();
   if (selectedRuleId == '')
   {
      alert($i18n("rules.ruleAction.js.selectSingleRule.alert.txt"));
      return;
   }
   if(destWorkflow=='Trash'){
	   alert("Cannot be deleted since it is deployed");
	      return;
   }
   if (method == 'createVersion' && destWorkflow=="Coding" && hasUnacceptableStates("Production Deactivated Trash Archive","rules.ruleAction.js.toNewVersion.alert.fmt.txt")) return;

   if(method == 'deleteRule')
   {
      if(!confirm($i18n("rules.ruleAction.js.deleteRule.confirm.txt")))
        return;
   }
   // escape # character
   selectedRuleName = selectedRuleName.replace(/#/g, '%23').replace(/%/g, '%25');

   var link = action + "?method=" + method + "&id=" + selectedRuleId + "&baseRuleId=" + selectedBaseRuleId +
              "&version=" + selectedRuleVersion + "&name=" + selectedRuleName +
              "&lockVersion=" + selectedRuleLockVersion + "&executionOrderPriority=" + selectedRuleExecutionOrderPriority + "&workflow=" + selectedRuleState
              + "&destWorkflow=" + destWorkflow;
   if (method == 'modifyRule' && selectedRuleGuidedRule == "true") {
	   parent.sas.fscf.ruleApproach = parent.sas.fscf.RULE_APPROACH_GUIDED;

	   parent.sas.fscf.getCurrentPageView().jsonRule = {
			"id":selectedRuleId,
			"name":selectedRuleName,
			"revision":selectedRuleVersion,
			"lastUpdateNumber":selectedRuleLockVersion,
			"transactionTypeId":selectedRuleTransactionTypeId,
			"multiOrgNodeId":selectedRuleMultiOrgNodeId,
			"description":selectedRuleDescription.replace(/%2C/g,","),
			"operationalTimeLimit":selectedRuleOperationalTimeLimit.replace(/%2C/g,","),
			"createUser":parent.frames['overview'].getContent("_userName"),
			"businessUnitId":parent.frames['overview'].getContent("workingBuId"),
			"guidedRule":selectedRuleGuidedRule,
			"alertTypeId":selectedRuleAlertTypeCode,
			"queueId":selectedRuleQueueId,
			"alertReason":selectedRuleAlertReason.replace(/%2C/g,",")
	   };
	   parent.sas.fscf.getCurrentPageView().isDevEnv = parent.frames['overview'].getContent("isDevEnv");
	   parent.sas.fscf.getCurrentPageView().getNewRuleDialog().open();
   } else {
	   // Send the request to a new window (if so requested and not already open)
	   if (newWindow)
	   {
		 openRuleDetailWindow( link, selectedRuleId );
	   }
	   else
	   {
	     // alert(link);
	     setBusyDetail();
	   	 parent.sas.fscf.getCurrentDetailToolbar().setContentFor((method == 'getRuleVersions') ? method : getCookie('rules_folders'),'','','','',parent.frames['overview']._canModify);
	     link += '&__sfmrt=' + getCookie("__sfmrt");
	     // parent.frames[ "detail" ].location.href = link;
		 $df.postURL("detail", link);
	   }
   }
}

function prioritizeRules(){
	var link = action + "?method=prioritizeRules";

	setBusyDetail();
    link += '&__sfmrt=' + getCookie("__sfmrt");
	$df.postURL("detail", link);

}

function emptyTrash()
{
   if(!confirm( $i18n("rules.ruleAction.js.deleteTrashRules.confirm.txt")) )
        return;
   var link = action + "?method=emptyTrash";
   setBusyDetail();
   link += '&__sfmrt=' + getCookie("__sfmrt");
   // parent.frames[ "detail" ].location.href = link;
   $df.postURL("detail", link);
}

//Opens rule detail in a separate, possibly new window (optional:id (for existing rule))
function openRuleDetailWindow(link, id)
{
   top.ruleWindowCache = (top.ruleWindowCache) ? top.ruleWindowCache : new Array();
   var theWindowName;
   var theWindow;
   if (id)
   {
      theWindowName = 'rule_detail_window_' + id;
      try { theWindow = top.ruleWindowCache[ theWindowName ]; }
      catch(e) { /* alert('throw ruleWindowCache: ' + e); */ }
   }
   else
   {
      var dt = new Date();
      var guid = dt.getHours()*3600000 + dt.getMinutes()*60000 + dt.getSeconds()*1000 + dt.getMilliseconds();
      theWindowName = 'rule_detail_window_' + guid;
   }

   if (!theWindow || theWindow.closed)
   {
	 // Slight delay so any processing in the main window that might give focus to
	 // the main window can finish before we open and focus the secondary window
	 setTimeout(function () {
	     var popH = getCookie("rule_detail_window_height");
	     var popW = getCookie("rule_detail_window_width");
	     if (!popH || !popW)
	     {
	       popW = (top.innerWidth)  ? (top.innerWidth-30)  : (top.document.body.offsetWidth-30);
	       popH = (top.innerHeight) ? (top.innerHeight-30) : (top.document.body.offsetHeight-50);
	       popW = 1085;
	       popH = 650;
	     }
	     var popOff = getCookie("rule_detail_window_offset");
	     if (!popOff || popOff > 125)
	       popOff = 25;
	     else
	       popOff = parseInt(popOff) + 25;
	     var theDate = new Date();
	     theDate.setYear(theDate.getYear() + 100);
	     setCookie("rule_detail_window_offset", popOff, theDate);
	     // Make sure the window will not go off the edge of the screen
	     var popX = Math.min(screen.width - 30 - popW, parent.screenLeft + popOff);
	     var popY = Math.min(screen.height - 70 - popH, parent.screenTop + popOff);
	     theWindow = window.open('common/blank.html', theWindowName,
	             'resizable=1,scrollbars=1,status=1,width=' + popW + ',height=' + popH + ',left=' + popX + ',top=' + popY);
	     $df.postURL(theWindowName, link);
	     top.ruleWindowCache[ theWindowName ] = theWindow;
	     theWindow.focus();
	 }, 200);
   } else {
	   theWindow.focus();
   }
}

function showRequestApprovalPopup(workflow, msgKey, buId)
{ // debugger;
   setSelectedRules();
   if(selectedRuleIds.length == 0)
   {
      alert( $i18n("rules.ruleAction.js.selectRules.alert.txt") );
      return;
   }
   if (hasUnacceptableStates(workflow, msgKey)) return;

   // Initiates a request to fetch data for the request approval window
   var url = action + "?method=" +"requestApproval" + "&businessUnitId=" + buId ;
   rval = window.showModalDialog(url, window, "dialogHeight:410px;dialogWidth:460px;resizable:1;scroll:1;status:1;help:0;")
   // alert("control back to main window, rval: " + rval);
   if(rval == 1)
   {
      processMultiSelectRequest('processStateTransition', workflow, '', 'Production');	// method, destWorkflow, newWindow, srcWorkflow
   }
   else
   {
      return;
   }

}

//Validates then submits a request to execute an estimation
function runEstimation(debug, validate)
{
   if (noLandlordEstimation) {
      alert( $i18n("rules.ruleAction.js.businessUnitLimit.alert.fmt.txt", [estimationBusinessUnitName]) );
      return;
   }

   if (validate && document.getElementById('estimateName').value.indexOf('VALEST')<0)
      document.getElementById('estimateName').value += ' VALEST';

   var acct = document.getElementById("filterAccount").value;
   if (acct!=acct.replace(/[^a-zA-Z0-9\-=\.\+_%\$#@!&\*|:;<>,\?/]/,''))
   {
      alert( $i18n("rules.ruleAction.js.accountCharsInvalid.alert.txt") );
      return false;
   }
   var timezone = trim(document.getElementById('timezoneLabel').innerHTML);

   var startDateValue = trim(document.getElementById('startMonth').value)  + "/" +
                        trim(document.getElementById('startDay').value)    + "/" +
                        trim(document.getElementById('startYear').value)   ;
   var startTimeValue = trim(document.getElementById('startHour').value)   + ":" +
                        trim(document.getElementById('startMinute').value) + ":" +
                        trim(document.getElementById('startSecond').value) ;

   var endDateValue = trim(document.getElementById('endMonth').value)  + "/" +
                      trim(document.getElementById('endDay').value)    + "/" +
                      trim(document.getElementById('endYear').value)   ;
   var endTimeValue = trim(document.getElementById('endHour').value)   + ":" +
                      trim(document.getElementById('endMinute').value) + ":" +
                      trim(document.getElementById('endSecond').value) ;
   if (startDateValue == '//')
       startDateValue = '';
   if (startTimeValue == '::')
       startTimeValue = '';
   if (endDateValue == '//')
       endDateValue = '';
   if (endTimeValue == '::')
       endTimeValue = '';

   if (!isValidTimestampRange(startDateValue, startTimeValue, endDateValue, endTimeValue))
       return;

   // Remember datetimes
   var theDate = new Date();
   theDate.setYear(theDate.getYear() + 100);

   var estimationStartDate = startDateValue + " " + startTimeValue + " " + "GMT";
   var estimationEndDate = endDateValue + " " + endTimeValue + " " + "GMT";
   var estimationCreationDatetimes = estimationStartDate + " " + estimationEndDate;

   setCookie("estimation_creation_datetimes", estimationCreationDatetimes, theDate);
   document.getElementById("estimationStartDate").value = estimationStartDate;
   document.getElementById("estimationEndDate").value = estimationEndDate;
   
   setDebugFlag(debug);  // S1162965

   // Submit request
   processMultiSelectRequest('createEstimate','');
   return;
}

function setDebugFlag(isDebug) {
	getDebugElt().value = isDebug;
}

function getDebugElt() {
	var debugElt = document.querySelector("form#estimateForm > input#debug");
	if (!debugElt) {
		var $debug = $("<input>", {
			type: "hidden",
		    id: "debug",
		    name: "debug",
		} );
		$debug.appendTo( $("#estimateForm") );
		debugElt = $debug.get(0);
	}
	return debugElt;
}

// Validate date range for estimation and rule testing
function isValidTimestampRange(startDateValue, startTimeValue, endDateValue, endTimeValue)
{
   if(startDateValue == '' || !isDate(startDateValue))
   {
      alert( $i18n("rules.ruleAction.js.startDateInvalid.alert.txt") );
      return false;
   }
   if(endDateValue == '' ||  !isDate(endDateValue))
   {
	  alert( $i18n("rules.ruleAction.js.endDateInvalid.alert.txt") );
      return false;
   }
   if(startTimeValue == '' || !isTime(startTimeValue))
   {
      alert( $i18n("rules.ruleAction.js.startTimeInvalid.alert.fmt.txt", [startTimeValue]) );
      return false;
   }
   if(endTimeValue == '' || !isTime24(endTimeValue))
   {
	  alert( $i18n("rules.ruleAction.js.endTimeInvalid.alert.fmt.txt", [endTimeValue]) );
      return false;
   }
   var sds = startDateValue + " " + startTimeValue;
   var eds = endDateValue   + " " + endTimeValue;
   try {
       var sd;
       if (startTimeValue=='24:00:00') {
           sd = new Date(startDateValue);
           sd = new Date(sd.getFullYear(), sd.getMonth(), sd.getDate()+1);
       }
       else
           sd = new Date(sds);
       var ed;
       if (endTimeValue=='24:00:00') {
           ed = new Date(endDateValue);
           ed = new Date(ed.getFullYear(), ed.getMonth(), ed.getDate()+1);
       }
       else
           ed = new Date(eds);
       if (!sd || isNaN(sd)) {
           alert( $i18n("rules.ruleAction.js.startTimestampInvalid.alert.fmt.txt", [sds, sd]) );
           return false;
       }
       if (!ed || isNaN(ed)) {
           alert( $i18n("rules.ruleAction.js.endTimestampInvalid.alert.fmt.txt", [eds, ed]) );
           return false;
       }
       if (sd > ed) { // S1020338
           alert( $i18n("rules.ruleAction.js.timestampIntervalInvalid.alert.fmt.txt", [sds, sd, eds, ed]) );
           return false;
       }
   } catch(e) {
       alert( $i18n("rules.ruleAction.js.timestampParseError.alert.fmt.txt", [e, sds, sd, eds, ed]) );
       return false;
   }
   return true;
}

//Creates an empty rule form for rule creation
function newRule(newWindow)
{
var link = action + "?method=createRule";
if (newWindow)
   openRuleDetailWindow( link );
else
   parent.frames[ "detail" ].location.href = link;
}
