/*
 +-------------+----------------------------------------------------------------+
 | PRODUCT:    | SAS Fraud Management
 | FILE:       | cpp_autoexec.sas
 | DESCRIPTION:| Defines CPP_FRAUD_COLS and calls general job autoexec
 +------------------------------------------------------------------------------+
 | USAGE:      | -autoexec "!SASFMCP_IMPLEMENT_HOME/cpp/src/sas/cpp_auotexec.sas"
 +-------------+----------------------------------------------------------------+
 | COMMENTS:   | May be specified in the job definition table to reference an
 |             | implementation-specific autoexec.
 +-------------+----------------------------------------------------------------+
 */

/*-------------------------------------------------------------------
 * Copyright (c) 2016 by SAS Institute Inc., Cary, NC 27513 USA
 *  ---All Rights Reserved.
 *-------------------------------------------------------------------*/

%global cpp_fraud_cols;

%let CPP_FRAUD_COLS=TCA_AUTH_SYS_DEC WAX_SCORE_1_TAG WAX_USER_FRAUD_C_IND RRR_ACTION_CODE RRR_ACTION_INFO RRR_PRELIM_DEC_CODE;
%put cpp_fraud_cols=&cpp_fraud_cols;

%include "$SASFMCP_IMPLEMENT_HOME/common/etc/autoexec.sas" / source2;
	
