<%-- this file uses leading tabs; don't insert leading spaces --%>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>
<style type="text/css">@import "common/styles/cf.css";</style>
<script src="common/scripts/jquery.fcm.dynaform.js" type="text/javascript"></script>
<script language="Javascript" src="admin/scripts/preference.js"></script>

<!-- Tree header. -->
<%-- <div id="navhead" class="mmhide_navhd"><fmt:message key="fcm.preferences.overview.allPreferences.txt" /></div> --%>
<div class="sapUiTreeHeader" id="preferencesHeader" role="heading">
  <div class="sapUiTreeTitle"><fmt:message key="fcm.preferences.overview.allPreferences.txt" /></div>
</div>

<!-- Nested tables with fixed height -->
<table id="overview_table" cellspacing=0 cellpadding=2 border="0"  >
    <tr>
        <td id="navcol" align="left" valign="top" nowrap>

<script language="JavaScript">

	var _canModify = false;
	<c:if test="${empty updatePrefs || updatePrefs}">
	_canModify = true;
	</c:if>
	parent.sas.fscf.getCurrentOverviewToolbar().setContentFor('any', _canModify);

    var MARKS = ["MASK","GRID","ACCOUNT","ACTIVITY","CALLRESULT","ECM","SYSPROP"];

//<!--
    var selectedNode = getCookieForTab("-1");
    var openNode = selectedNode;
    var _isSomethingSelected = false;
    var gridTemplateNodeId = '';
    var accountNodeId = '';
    var activityNodeId ='';

    // Place holder node for the grid templates
    var topGridTemplateNodeId = "-1";

    // Transaction grid nodes
    var gridNodes = new Array();
    var params = new Array();

    var transactionGrids ="<fmt:message key='fcm.preferences.overview.transactionGrids.txt' />";
    var transactionGrid ="<fmt:message key='fcm.preferences.overview.transactionGrid.txt' />";
    var gridAccount ="<fmt:message key='fcm.preferences.overview.gridAccount.txt' />";
    var gridActivity ="<fmt:message key='fcm.preferences.overview.gridActivity.txt' />";
    var dataMasking ="<fmt:message key='fcm.preferences.overview.transaction.fieldDisplayOptions.txt' />";
<xams:hide>
<c:if test="${not empty gridTemplates || not empty hasPrivilege}">

    node = new Node(topGridTemplateNodeId, 0, "folder", transactionGrids, transactionGrids, params, "", "", "");
    gridNodes.push(node);
    //alert("treeSelectedItemId: " + "${esapi:encodeForJavaScript(treeSelectedItemId)}");

    transDataMaskingNodeId = "G0";

    params = new Array();
    params[0] = "<c:url value="/preference.sj?method=viewTransactionDataMasking"/>";
    params[1] = "transDataMaskingNodeId=" + transDataMaskingNodeId;

    node = new Node(transDataMaskingNodeId, topGridTemplateNodeId, "template", dataMasking, dataMasking, params, "", "", "", MARKS[0]);
    gridNodes.push(node);

    <c:if test="${not empty treeSelectedItemId and treeSelectedItemId==transDataMaskingNodeId}">
           _isSomethingSelected = true;
           selectedNode = transDataMaskingNodeId;
           openNode = topGridTemplateNodeId + "|" + transDataMaskingNodeId;
    </c:if>

    if(selectedNode == null || selectedNode == '') {
        selectedNode = getCookieForTab("-1");
    } else {
        _isSomethingSelected = true;
    }

    if( selectedNode == transDataMaskingNodeId )
        openNode = topGridTemplateNodeId + "|" + transDataMaskingNodeId;

    <c:forEach var="gridTemplate" items="${gridTemplates}" varStatus="gtStatus">

        gridTemplateNodeId = "G" + "${gtStatus.count}";

        params = new Array();
        params[0] = "<c:url value="preference.sj?method=viewGridTemplate"/>";
        params[1] = "id=" + "${gridTemplate.id}";

        node = new Node(gridTemplateNodeId, topGridTemplateNodeId, "folder", "${esapi:encodeForJavaScript(esapi:encodeForHTML(gridTemplate.name))}", transactionGrid, params, "", "", "", MARKS[1]);
        gridNodes.push(node);

        <c:if test="${not empty grid_templateId and grid_templateId==gridTemplate.id and empty grid_accountId and empty grid_activityId}">
            _isSomethingSelected = true;
            selectedNode = gridTemplateNodeId;
            openNode = topGridTemplateNodeId+"|"+selectedNode;
        </c:if>

        if( selectedNode == gridTemplateNodeId )
            openNode = topGridTemplateNodeId +"|"+ selectedNode;

        _hasAccounts[gridTemplateNodeId] = ${esapi:encodeForJavaScript(fn:length(gridTemplate.accountTypes) > 0)};

        <%-- Default Grid Template node id --%>
        <c:if test="${gridTemplate.id == -1}">
            _DEFAULT_GRID_TEMPLATE_ = gridTemplateNodeId;
        </c:if>

        <c:forEach var="accountType" items="${gridTemplate.accountTypes}" varStatus="acctStatus" >

        <c:if test="${accountType.selected == true}">
            accountNodeId = gridTemplateNodeId +  "A" + "${acctStatus.count}";
            params = new Array();
            params[0] = "<c:url value="preference.sj?method=viewAccountType"/>";
            params[1] = "gridTemplateId=" + ${gridTemplate.id};
            params[2] = "accountTypeId=" + ${accountType.id};

            node = new Node(accountNodeId,gridTemplateNodeId,"folder","${esapi:encodeForJavaScript(esapi:encodeForHTML(accountType.name))}", gridAccount, params, "", "", "", MARKS[2]);
            gridNodes.push(node);

            <c:if test="${not empty grid_templateId and grid_templateId==gridTemplate.id and not empty grid_accountId and grid_accountId==accountType.id and empty grid_activityId}">
                _isSomethingSelected = true;
                selectedNode = accountNodeId;
                openNode = topGridTemplateNodeId+"|"+gridTemplateNodeId+"|"+selectedNode;
            </c:if>

            if( selectedNode == accountNodeId )
                openNode = topGridTemplateNodeId +"|"+ gridTemplateNodeId +"|"+  selectedNode;

            _hasActivitys[accountNodeId] = ${esapi:encodeForJavaScript(fn:length(accountType.transactionActivityTypes) > 0)};

            <c:forEach var="activityType" items="${accountType.transactionActivityTypes}" varStatus="activityStatus" >

            <c:if test="${activityType.selected == true}">

                activityNodeId = accountNodeId +  "T" + "${activityStatus.count}";

                params = new Array();
                params[0] = "<c:url value="preference.sj?method=viewActivityType"/>";
                params[1] = "gridTemplateId=" + ${gridTemplate.id};
                params[2] = "accountTypeId=" + ${accountType.id};
                params[3] = "activityTypeId=" + ${activityType.id};

                node = new Node(activityNodeId,accountNodeId,"template","${esapi:encodeForJavaScript(esapi:encodeForHTML(activityType.name))}", gridActivity, params, "", "", "", MARKS[3]);
                gridNodes.push(node);

                <c:if test="${not empty grid_templateId and grid_templateId==gridTemplate.id and not empty grid_accountId and grid_accountId==accountType.id and not empty grid_activityId and grid_activityId==activityType.id }">
                    _isSomethingSelected = true;
                    selectedNode = activityNodeId;
                    openNode = topGridTemplateNodeId +"|"+ gridTemplateNodeId +"|"+ accountNodeId +"|"+ selectedNode;
                </c:if>

                if( selectedNode == activityNodeId )
                    openNode = topGridTemplateNodeId +"|"+ gridTemplateNodeId +"|"+ accountNodeId+"|"+selectedNode;
             </c:if>

            </c:forEach>
           </c:if>
        </c:forEach>


    </c:forEach>
</c:if>
</xams:hide>
topGridTemplateNodeId = '-4';

<c:if test="${not empty systemTemplates || not empty hasPrivilege}">

transactionGrids ="<fmt:message key='fcm.preferences.overview.systemGrids.txt' />";

node = new Node(topGridTemplateNodeId, 0, "folder", transactionGrids, transactionGrids, [], "", "", "");
gridNodes.push(node);
//alert("treeSelectedItemId: " + "${esapi:encodeForJavaScript(treeSelectedItemId)}");

<c:forEach var="gridTemplate" items="${systemTemplates}" varStatus="gtStatus">

    gridTemplateNodeId = "SG" + "${gtStatus.count}";

    params = new Array();
    params[0] = "<c:url value="preference.sj?method=viewGridTemplate"/>";
    params[1] = "id=" + ${gridTemplate.id};

    node = new Node(gridTemplateNodeId, topGridTemplateNodeId, "folder", "${esapi:encodeForJavaScript(esapi:encodeForHTML(gridTemplate.name))}", transactionGrid, params, "", "", "", MARKS[1]);
    gridNodes.push(node);

    <c:if test="${not empty grid_templateId and grid_templateId==gridTemplate.id and empty grid_accountId and empty grid_activityId}">
        _isSomethingSelected = true;
        selectedNode = gridTemplateNodeId;
        openNode = topGridTemplateNodeId+"|"+selectedNode;
    </c:if>

    if( selectedNode == gridTemplateNodeId )
        openNode = topGridTemplateNodeId +"|"+ selectedNode;

    _hasAccounts[gridTemplateNodeId] = ${esapi:encodeForJavaScript(fn:length(gridTemplate.accountTypes) > 0)};


    <c:forEach var="accountType" items="${gridTemplate.accountTypes}" varStatus="acctStatus" >

    <c:if test="${accountType.selected == true}">
        accountNodeId = gridTemplateNodeId +  "A" + "${acctStatus.count}";
        params = new Array();
        params[0] = "<c:url value="preference.sj?method=viewAccountType"/>";
        params[1] = "gridTemplateId=" + ${gridTemplate.id};
        params[2] = "accountTypeId=" + ${accountType.id};

        node = new Node(accountNodeId,gridTemplateNodeId,"folder","${esapi:encodeForJavaScript(esapi:encodeForHTML(accountType.name))}", gridAccount, params, "", "", "", MARKS[2]);
        gridNodes.push(node);

            <c:if test="${not empty grid_templateId and grid_templateId==gridTemplate.id and not empty grid_accountId and grid_accountId==accountType.id and empty grid_activityId}">
            _isSomethingSelected = true;
            selectedNode = accountNodeId;
            openNode = topGridTemplateNodeId+"|"+gridTemplateNodeId+"|"+selectedNode;
        </c:if>

        if( selectedNode == accountNodeId )
            openNode = topGridTemplateNodeId +"|"+ gridTemplateNodeId +"|"+  selectedNode;

        _hasActivitys[accountNodeId] = ${esapi:encodeForJavaScript(fn:length(accountType.transactionActivityTypes) > 0)};

        <c:forEach var="activityType" items="${accountType.transactionActivityTypes}" varStatus="activityStatus" >

        <c:if test="${activityType.selected == true}">

            activityNodeId = accountNodeId +  "T" + "${activityStatus.count}";

            params = new Array();
            params[0] = "<c:url value="preference.sj?method=viewActivityType"/>";
            params[1] = "gridTemplateId=" + ${gridTemplate.id};
            params[2] = "accountTypeId=" + ${accountType.id};
            params[3] = "activityTypeId=" + ${activityType.id};

            node = new Node(activityNodeId,accountNodeId,"template","${esapi:encodeForJavaScript(esapi:encodeForHTML(activityType.name))}", gridActivity, params, "", "", "", MARKS[3]);
            gridNodes.push(node);

                <c:if test="${not empty grid_templateId and grid_templateId==gridTemplate.id and not empty grid_accountId and grid_accountId==accountType.id and not empty grid_activityId and grid_activityId==activityType.id }">
                _isSomethingSelected = true;
                selectedNode = activityNodeId;
                openNode = topGridTemplateNodeId +"|"+ gridTemplateNodeId +"|"+ accountNodeId +"|"+ selectedNode;
            </c:if>

            if( selectedNode == activityNodeId )
                openNode = topGridTemplateNodeId +"|"+ gridTemplateNodeId +"|"+ accountNodeId+"|"+selectedNode;
         </c:if>

        </c:forEach>
       </c:if>
    </c:forEach>


</c:forEach>
</c:if>

<xams:hide>
    // Place holder node for Call Results
    var topCallResultsNodeId = '-5';

    <c:if test="${not empty callResults}">

        var callResults ="<fmt:message key='fcm.preferences.overview.callResults.txt' />";
        var callResultsCfg ="<fmt:message key='fcm.preferences.overview.callResultsCfg.txt' />";
        var caseMgtEvent ="<fmt:message key='fcm.preferences.overview.caseMgtEvent.txt' />";

        node = new Node(topCallResultsNodeId, 0, "folder", callResults, callResults, [], "", "", "");
        gridNodes.push(node);

        params = new Array();
        params[0] = "<c:url value="preference.sj?method=viewCallResultsConfig"/>";

        var callResultsCfgNodeId = "CR1";
        node = new Node(callResultsCfgNodeId, topCallResultsNodeId, "folder", callResultsCfg, callResultsCfg, params, "", "", "", MARKS[4]);
        gridNodes.push(node);

        if( selectedNode == callResultsCfgNodeId )
            openNode = topCallResultsNodeId +"|"+ selectedNode;

        params = new Array();
        params[0] = "<c:url value="preference.sj?method=viewCaseMgtEventsConfig"/>";

        var caseMgtEventNodeId = "CR2";
        node = new Node(caseMgtEventNodeId, topCallResultsNodeId, "folder", caseMgtEvent, caseMgtEvent, params, "", "", "", MARKS[5]);
        gridNodes.push(node);

        if( selectedNode == caseMgtEventNodeId )
            openNode = topCallResultsNodeId +"|"+ selectedNode;

    </c:if>
</xams:hide>

    // Place holder node to show system properties
    var topPropertyNodeId = '-2';
    var propertyTypeNodeId = '';
    var propertySubTypeNodeId = '';
    // System propertyType nodes
    var propertyNodes = new Array();
    params = new Array();

<c:if test="${not empty property_types}">
    var systemProperties ="<fmt:message key='fcm.preferences.overview.systemProperties.txt' />";
    node = new Node(topPropertyNodeId, 0, "folder", systemProperties, systemProperties, params, "", "", "");
    propertyNodes.push(node);
    <c:forEach var="property" items="${property_types}" varStatus="ptStatus">
        <c:set var="message"><fmt:message key='fcm.preferences.property.type.${property.type}.txt' /></c:set>
        var propertyTypeName = "${esapi:encodeForJavaScript(esapi:encodeForHTML(message))}";
        var propertyTypeNameTip = "${esapi:encodeForJavaScript(esapi:encodeForHTMLAttribute(message))}";
        propertyTypeNodeId = "P" + "${ptStatus.count}";
        params = new Array();

        <c:if test="${fn:length(property.subTypes) == 1 }">
            <c:forEach var="subType" items="${property.subTypes}" varStatus="pSubStatus" >

                params[0] = "<c:url value="preference.sj?method=viewProperties"/>";
                params[1] = "propertyType=" + "${esapi:encodeForURL(property.type)}";
                params[2] = "propertySubType=" + "${esapi:encodeForURL(subType.propertySubType)}";
                params[3] = "propertySubTypeLabel=" + "${esapi:encodeForURL(subType.propertySubTypeLabel)}";
                params[4] = "isSubTypeNode=false";

                node = new Node(propertyTypeNodeId, topPropertyNodeId, "folder", propertyTypeName, propertyTypeNameTip, params, "", "", "", MARKS[6]);
                propertyNodes.push(node);
                <c:if test="${not empty treeSelectedItemId and treeSelectedItemId==property.type }">
                    _isSomethingSelected = true;
                    selectedNode = propertyTypeNodeId;
                    openNode = topPropertyNodeId ;
                </c:if>

                if(selectedNode == null || selectedNode == '') {
                    selectedNode = getCookieForTab("-1");
                } else {
                    _isSomethingSelected = true;
                }
                if( selectedNode == propertyTypeNodeId )
                    openNode = topPropertyNodeId ;
            </c:forEach>
        </c:if>

        <c:if test="${fn:length(property.subTypes) > 1 }">
            params[0] = "common/blank.html";
            node = new Node(propertyTypeNodeId, topPropertyNodeId, "folder", propertyTypeName, propertyTypeNameTip, params, "", "", "");
            propertyNodes.push(node);
            <c:if test="${not empty treeSelectedItemId and treeSelectedItemId==property.type }">
                _isSomethingSelected = true;
                selectedNode = propertyTypeNodeId;
                openNode = topPropertyNodeId + "|" + selectedNode;
            </c:if>

            if(selectedNode == null || selectedNode == '') {
                selectedNode = getCookieForTab("-1");
            } else {
                _isSomethingSelected = true;
            }

            if( selectedNode == propertyTypeNodeId )
                openNode = topPropertyNodeId + "|" + selectedNode;

            <c:forEach var="subType" items="${property.subTypes}" varStatus="pSubStatus" >
                propertySubTypeNodeId = propertyTypeNodeId + "S" + "${pSubStatus.count}";
                params = new Array();
                params[0] = "<c:url value="preference.sj?method=viewProperties"/>";
                params[1] = "propertyType=" + "${esapi:encodeForURL(property.type)}";
                params[2] = "propertySubType=" + "${esapi:encodeForURL(subType.propertySubType)}";
                params[3] = "propertySubTypeLabel=" + "${esapi:encodeForURL(subType.propertySubTypeLabel)}";
                params[4] = "isSubTypeNode=true";

                var propertyNodeName = "${esapi:encodeForJavaScript(subType.propertySubTypeLabel)}";
                var propertyNodeTip =  "${esapi:encodeForJavaScript(subType.propertySubType)}";

                node = new Node(propertySubTypeNodeId, propertyTypeNodeId, "template", propertyNodeName, propertyNodeTip, params, "", "", "", MARKS[6]);
                propertyNodes.push(node);

                <c:if test="${not empty treeSelectedItemId and treeSelectedItemId==subType.propertySubType }">
            _isSomethingSelected = true;
                    selectedNode = propertySubTypeNodeId;
                    openNode = topPropertyNodeId + "|" + propertyTypeNodeId + "|" + selectedNode;
        </c:if>

                if(selectedNode == null || selectedNode == '') {
                    selectedNode = getCookieForTab("-1");
                } else {
                    _isSomethingSelected = true;
                }

                if( selectedNode == propertySubTypeNodeId )
                    openNode = topPropertyNodeId + "|" + propertyTypeNodeId + "|" + selectedNode;
            </c:forEach>
        </c:if>

    </c:forEach>
</c:if>

    var preferenceNodes = gridNodes.concat(propertyNodes);

    <%-- function Tree( name, data, start, open, selected, eventHandler, extend, location, enabled, treeImages, nodeImages )--%>

    var preferenceTree = new Tree("preferenceTree", preferenceNodes, 0, openNode, selectedNode,
                                 'doPreferenceAction(\'modify\')', false, false, true,
                                 "common/images/tree/", "common/images/" );

   <%-- Generic method defined to show selected node --%>
   Tree.showSelectedAdminNode = function(){ preferenceTree.showNode();};
//-->
</script>

        </td>
    </tr>
</table>

<%-- Error handling code --%>
<tiles:insert page="/admin/adminOverviewErrorHandling.jsp" flush="true">
    <tiles:put name="treeObj" value="preferenceTree" />
    <tiles:put name="showCommand" value="doPreferenceAction" />
    <tiles:put name="showCommandArgs" value="modify" />
    <tiles:put name="window" value="window"/>
</tiles:insert>
