
// declare variables
var _highlightedRow = undefined;
var previousHighlightedRowId = null;
var previousHighlightedRowClassName = "";
var previousColumnImage=null;

var inAddMode= false;
//var edittxt   = "<img id=\"editImg\" src=\"admin/images/edit.gif\" ALT=\"Edit\" onclick=\"editColumn(this, 'availableTable');\">";
var edittxt = "<span class=\"sapUiBtnIco sapUiBtnIcoL sapUiIcon\" style=\"font-family: sas-icons; cursor: pointer\" data-sap-ui-icon-content=\"&#xf201;\" onclick=\"editColumn(this, 'availableTable');\"></span>";
//var delNewRow = "<img id=\"delImg\" src=\"admin/images/delete.gif\" ALT=\"Delete\" onclick=\"deleteNewRow(this, 'availableTable');\">";
var delNewRow = "<span class=\"sapUiBtnIco sapUiBtnIcoL sapUiIcon\" style=\"font-family: sas-icons; cursor: pointer\" data-sap-ui-icon-content=\"&#xf1a7;\" onclick=\"deleteNewRow(this, 'availableTable');\"></span>";
//var delNewRow2 = "<img id=\"delImg\" src=\"admin/images/delete.gif\" ALT=\"Delete\" onclick=\"deleteNewRow(this, 'availableTable');resetInterface();\">";
var delNewRow2 = "<span class=\"sapUiBtnIco sapUiBtnIcoL sapUiIcon\" style=\"font-family: sas-icons; cursor: pointer\" data-sap-ui-icon-content=\"&#xf1a7;\" onclick=\"deleteNewRow(this, 'availableTable');resetInterface();\"></span>";
//var addtxt = "<img src=\"admin/images/add.gif\" ALT=\"Add\" onclick=\"addNewRow(this, 'availableTable');\">";
//var resettxt = "<img id=\"resetImg\" src=\"admin/images/reset.gif\" ALT=\"Reset\" onclick=\"resetColumn(this, 'availableTable');\">";
var resettxt = "<span class=\"sapUiBtnIco sapUiBtnIcoL sapUiIcon\" style=\"font-family: sas-icons; cursor: pointer\" data-sap-ui-icon-content=\"&#xf5bc;\" onclick=\"resetColumn(this, 'availableTable');\"></span>";
var delChk = "<span id='tooltip' style='display:none;position:absolute;padding:1px;border:1px solid #333333;;background-color:#fffedf;font-size:smaller;'></span>"
			+ "<input type='checkBox' name='Delete' checked onmousemove='showTooltip(this);' onmouseout='hideTooltip(this);' onclick=\"deleteRow(this, 'availableTable')\">";
var delUnChk = "<span id='tooltip' style='display:none;position:absolute;padding:1px;border:1px solid #333333;;background-color:#fffedf;font-size:smaller;'></span>"
			+ "<input type='checkBox' name='Delete' onmousemove='showTooltip(this);' onmouseout='hideTooltip(this);' onclick=\"deleteRow(this, 'availableTable')\">";

/* ******************************************************************* */
/*   Highlights selected rowId   */
/* ******************************************************************* */
function highlightRowById(row,classNameValue)
{
  if(isDefined(_highlightedRow))
   {
      if (_highlightedRow != row)
      {
          var previousHighlightedRow = getElement(previousHighlightedRowId);
          previousHighlightedRow.className = previousHighlightedRowClassName;
	  previousHighlightedRowClassName = row.className;
      }

   }
   else
   {
	   previousHighlightedRowClassName = row.className;
   }

   _highlightedRow = row;
   _highlightedRow.className = classNameValue;

   previousHighlightedRowId = row.id;
}
function unhighlightRow(){
	if(isDefined(_highlightedRow)){
		//unhighlight the row
		_highlightedRow.className = previousHighlightedRowClassName;
		_highlightedRow=undefined;
		previousHighlightedRowId = null;
		previousHighlightedRowClassName = "";

	}
}

/* ******************************************************************* */
/*   Loads the Detail Page from Tree for Incremental Loader tables   */
/* ******************************************************************* */
function doLoaderAction()
{
     var selectedNodes = parent.frames['overview'].loaderTree.getSelectedNodes();
	 if(selectedNodes.length != 1)
	 {
     	parent.sas.fscf.getCurrentDetailToolbar().setContentFor();
		parent.frames[ "detail" ].location.href = 'common/blank.html';
		return;
  	 }

  	var node = selectedNodes[0];
  	setCookieForTab(node.getId());

//|| node.nodeId == "-3"
     if (node.nodeId == "-2"  || node.nodeId == "-4" || node.nodeId == "-5" || node.nodeId == "-6")
     {
     	parent.sas.fscf.getCurrentDetailToolbar().setContentFor();
    	parent.frames[ "detail" ].location.href = 'common/blank.html';
    	return;
     }
     else
     {
        var action = node.parameters.join('&');
        setBusy();
        var toolbarType = "any";
        if (node.nodeId.charAt(0) == "M") {
        	toolbarType = "masking";
        }
    	parent.sas.fscf.getCurrentDetailToolbar().setContentFor(toolbarType);
//        parent.frames['detail'].location.href = action;
        $df.postURL("detail", action);
     }

}


/* ******************************************************************* */
/*  Hide and show tool tip  */
/* ******************************************************************* */
function showTooltip(arg){
        var tooltip = document.getElementById('tooltip');
        tooltip.innerHTML = arg.title;
}
function hideTooltip(arg){
        var tooltip = document.getElementById('tooltip');
        tooltip.innerHTML = '';
        tooltip.style.display = 'none';
}


/* ******************************************************************* */
/*  Edit Text Columns in the selected row */
/* ******************************************************************* */
//function editColumn(columnImage, dstTableId)
//{
//   if(!inAddMode){
//   	updateMode(columnImage, dstTableId,"Edit") ;
//   	updateImage(dstTableId);
//   	document.getElementById("addNewButton").disabled=true;
//   }
//}

function editColumn(columnImage, dstTableId)
{
//	if($(columnImage).attr('src') === 'admin/images/reset.gif')
//	{
//		resetColumn(columnImage,dstTableId);
//		return;
//	}

	// disable Add New button
//	$('#addNewButton').prop('disabled',true);

	var $table = $('#'+dstTableId);
	var $selectedRow = $(columnImage).parent().parent();// get TR

	// Save selected row and retrieve previous selected row
	var $previousRow = $table.data('$selectedRow') || $();
	$table.data('$selectedRow',$selectedRow);

	// switch the row highlighted
	$previousRow.removeClass('rowSelected');
	$selectedRow.addClass('rowSelected');

	// Change icon
//	$previousRow.find('img').attr('src','admin/images/edit.gif');
//	$previousRow.find('img').attr('alt',$i18n('fcm.loaders.js.Edit.txt'));
	$previousRow.find('span.sapUiIcon').attr("data-sap-ui-icon-content", $("<div/>").html("&#xf201;").text());
	$previousRow.find('span.sapUiIcon').attr("onclick", "editColumn(this, 'availableTable');");
//	$selectedRow.find('img').attr('src','admin/images/reset.gif');
//	$selectedRow.find('img').attr('alt',$i18n('fcm.loaders.js.Reset.txt'));
	$selectedRow.find('span.sapUiIcon').attr("data-sap-ui-icon-content", $("<div/>").html("&#xf5bc;").text());
	$selectedRow.find('span.sapUiIcon').attr("onclick", "resetColumn(this, 'availableTable');");

	// Enable/Disable visible form elements
	// Only get form elements immediately within the TD tag
	var formElementQuery = 'td > input[type="text"], td > textarea, td > select';
	// Make sure they have one of these classnames
	var formElementFilter = '.textCell1,.textCell2';

	// Make readonly and disabled
	$previousRow.find(formElementQuery).filter(formElementFilter)
		.prop('readonly',true).filter('select').prop('disabled',true);

	// Make editable
	var $elems = $selectedRow.find(formElementQuery).filter(formElementFilter);

	$elems.each(function(){
		var $this = $(this);
		$this.prop('readonly',false).filter('select').prop('disabled',false);

		// textarea and textfield store the original value in an attribute called defaultValue
		if($this.is('input,textarea'))
		{
			$this.attr('defaultValue', $this.val());
		}

	});

	// Mark it as edited
	$selectedRow.find('input[name="Mode"]').val('Edit');

}



/* ******************************************************************* */
/*  Add new row and append it to the last row of the table */
/* ******************************************************************* */
function addNewRowEx(dstTableId, autoListOption)
{

   inAddMode=true;
   var tdId = "";
   var dst = document.getElementById(dstTableId);
   var dstRowCount = dst.rows.length;
   var rowsExist = dstRowCount > 1;
   if(rowsExist){//clone existing row
	   var thisRow = dst.tBodies[0].rows[dstRowCount-2]; ;
	   var rowNum = thisRow.rowIndex;

	   // Clone thisRow to be moved/deleted
	   var rowClone = thisRow.cloneNode(true);

	   // append the new row at the end
	   dst.tBodies[0].appendChild(rowClone);
   }

   else{//create new row from metadata
   	var rowClone=createRowFromMetadata(dstTableId,dstRowCount);
   }

	if (autoListOption != undefined)
	{
		// set autocomplete if input has auto attribute set
	   	$(rowClone).find("INPUT[auto]").each(function(){
	   		$(this).autocomplete(autoListOption);
		    this.readOnly=undefined;
	   	});
	}

   var newRowCount = dst.getElementsByTagName("TR").length;   // same as dst.rows.length;
   // set text to blank
   var firstEditableCell = false;
   for(i = 0; i < rowClone.cells.length-1; i++ ) {
	 tdId = rowClone.cells[i];
	 if (tdId == undefined)
	 {
			continue;
		 }else{
		    var cellId = tdId.children[0];
				if(cellId == undefined || cellId.tagName == null)
				{
					continue;
				}else if(cellId.tagName && cellId.tagName.toLowerCase() == 'div')
				{
					setDivTextNodes(cellId, 'A');
				}else{
					if(cellId.type == "text" || cellId.type == "textarea")
					{
						 if(cellId.style.visibility == "hidden")
						 {
							cellId.readOnly = undefined;
						 }else{
							 cellId.readOnly = undefined;
							 cellId.value = "";
							 cellId.text = "";
						 }
						 if(firstEditableCell == false)
						 {
							cellId.focus();
							firstEditableCell = true;
						 }
					}else if(cellId.type == "select-one")
					{
						//dont do anything else
						cellId.disabled = false;
						//TD - disable hidden text
						disableTextChildNodes(tdId,'A');
					}
				}
	 }
   }
  setDivTextNodes(rowClone.cells[rowClone.cells.length-1].children[0],"Add");

  dst.rows[newRowCount-1].style.cursor = "pointer;";
  dst.rows[newRowCount-1].className = "dataRow"+(newRowCount%2+1)+"_tableRow";
  dst.rows[newRowCount-1].cells[0].className = "imageTableCell";

  if(rowsExist){
  	dst.rows[newRowCount-1].cells[0].innerHTML = eval(rowStart(dstTableId)) + eval(dstRowCount - 1);
  }
  _highlightedRowClassName = dst.rows[newRowCount-1].className;
  highlightRowById(dst.rows[newRowCount-1],'rowSelected');

  updateImage(dstTableId);

/*  if(rowsExist){
  	updateImage(dstTableId);
//	$('span.sapUiIcon', rowClone).attr("data-sap-ui-icon-content", $("<div/>").html("&#xf1a7;").text());
//	$('span.sapUiIcon', rowClone).attr("onclick", "deleteNewRow(this, 'availableTable');");
  }
  else{
	var dstRowCount = dst.rows.length;
	for(var i = 1; i < dstRowCount ; i++ ){
		highlightRowById(dst.rows[1],'rowSelected');
		dst.rows[1].cells[dst.rows[1].cells.length-2].innerHTML =  delNewRow2;
	}

//	document.getElementById("saveButton").disabled=false;
	document.getElementById("noRecordsMsg").innerHTML="";
  }
 */

}

/* ******************************************************************* */
/*  Reset the columns with default value for the selected row */
/* ******************************************************************* */
//function resetColumn(columnImage, dstTableId,phr)
//{
//   var tdId = "";
//   var dst = document.getElementById(dstTableId);
//   var dstRowCount = dst.rows.length;
//   //user clicked on reset icon
//   if(columnImage!=null)var thisRow = columnImage.parentNode.parentNode;
//   //user clicked on Edit icon
//   else var thisRow=getElement(phr);
//   var rowNum = thisRow.rowIndex;
//
//   // get thisRow's the onclick/onmousedown event.
//   var eventAttr = thisRow.getAttribute("onmousedown");
//
//   for(i = 0; i < thisRow.cells.length-1; i++ )
//   {
//         tdId = thisRow.childNodes[i];
//         if (tdId == undefined)
//         {
//			continue;
//		 }else{
//		    var cellId = tdId.childNodes[0];
//			var div;
//			if(cellId == undefined || cellId.tagName == null)
//			{
//					continue;
//			}else if(cellId.tagName && cellId.tagName.toLowerCase() == 'div')
//			{
//					if(i == thisRow.cells.length - 1)
//			         	if(columnImage) setDivTextNodes(cellId, 'Reset');
//				    else
//						setDivTextNodes(cellId, 'R');
//			}else{
//				if(cellId.type == "text" || cellId.type == "textarea")
// 				{
//					if(columnImage)
//					 cellId.value = cellId.defaultValue;
//
//					 cellId.readOnly = true;
//				}	else if(cellId.type == "select-one")
//				{
//					 //TD - to get the default value from hidden text
//					if(columnImage)
//					{
//					  for (var j = 0; j < tdId.childNodes.length; j++) {
//					  	 var tdNode = tdId.childNodes.item(j);
//					  	 if(tdNode == undefined)
//					  	 {
//					  		 continue;
//					  	 }
//						 else if(tdNode.type == "text" && tdNode.name == "SELECT_RESET")
//						 {
//							 str = tdNode.value;
//							 tdNode.readOnly = true;
//						 }
//					  }
//					cellId.value = str;
//					}
//					else
//					{
//
//					}
//
////					cellId.readOnly = true;
//					cellId.disabled = true;
//				}
//			}
//         }
//   }
//
//   	setDivTextNodes(thisRow.childNodes[thisRow.cells.length - 1].childNodes[0],"Reset");
//   unhighlightRow();
//   updateImage(dstTableId);
//   document.getElementById("addNewButton").disabled=false;
//}

function resetColumn(columnImage, dstTableId)
{

	var $table = $('#'+dstTableId);
	var $selectedRow = $(columnImage).parent().parent();// get TR

	// Remove selected row
	$table.removeData('$selectedRow');

	// switch the row highlighted
	$selectedRow.removeClass('rowSelected');

	// Change icon
//	$selectedRow.find('img').attr('src','admin/images/edit.gif');
//	$selectedRow.find('img').attr('alt',$i18n('fcm.loaders.js.Edit.txt'));
	$selectedRow.find('span.sapUiIcon').attr("data-sap-ui-icon-content", $("<div/>").html("&#xf201;").text());
	$selectedRow.find('span.sapUiIcon').attr("onclick", "editColumn(this, 'availableTable');");


	// Enable/Disable visible form elements
	// Only get form elements immediately within the TD tag
	var formElementQuery = 'td > input[type="text"], td > textarea, td > select';
	// Make sure they have one of these classnames
	var formElementFilter = '.textCell1,.textCell2';

	// Make readonly and disabled
	var $elems = $selectedRow.find(formElementQuery).filter(formElementFilter);

	$elems.each(function(){
		var $this = $(this);
		$this.prop('readonly',true).filter('select').prop('disabled',true);

		// textarea and textfield have the original value in an attribute called defaultValue
		if($this.is('input,textarea'))
		{
			var resetVal = $this.attr('defaultValue');
			$this.val(resetVal);
		}
		// selects have the default selected option value stored two siblings away
		else if($this.is('select'))
		{
			var resetVal = $this.next().next().val();
			$this.find('option[value="'+resetVal+'"]').prop('selected',true);
		}

	});


	// Mark it as edited
	$selectedRow.find('input[name="Mode"]').val('Reset');

	// enable Add New button
//	$('#addNewButton').prop('disabled',false);
}

/* ******************************************************************* */
/*  Delete  row */
/* ******************************************************************* */
//function deleteRow(columnImage,  dstTableId)
//{
//	//alert("columnImage checked? " + columnImage.checked);
//	if(columnImage.checked == true)
//	{
//		updateMode(columnImage, dstTableId,"Delete");
//		updateImage(dstTableId);
//	}
//	else
//	{
//		updateMode(columnImage, dstTableId,"Undo");
//		updateImage(dstTableId);
//	}
//}

function deleteRow(columnImage,  dstTableId)
{
	var $selectedRow = $(columnImage).parent().parent();// get TR

	if(columnImage.checked)
	{

		var $table = $('#'+dstTableId);

		// Remove selected row
		$table.removeData('$selectedRow');

		// switch the row highlighted
		$selectedRow.removeClass('rowSelected');

		// Change icon
//		$selectedRow.find('img').attr('src','admin/images/edit.gif');
//		$selectedRow.find('img').attr('alt',$i18n('fcm.loaders.js.Edit.txt'));
		$selectedRow.find('span.sapUiIcon').attr("data-sap-ui-icon-content", $("<div/>").html("&#xf201;").text());
		$selectedRow.find('span.sapUiIcon').attr("onclick", "editColumn(this, 'availableTable');");

		// Enable/Disable visible form elements
		// Only get form elements immediately within the TD tag
		var formElementQuery = 'td > input[type="text"], td > textarea, td > select';
		// Make sure they have one of these classnames
		var formElementFilter = '.textCell1,.textCell2';

		// Make readonly and disabled
		$selectedRow.find(formElementQuery).filter(formElementFilter)
								.prop('readonly',true).filter('select').prop('disabled',true);;

		// enable Add New button
//		$('#addNewButton').prop('disabled',false);
		// Mark it as deleted
		$selectedRow.find('input[name="Mode"]').val('Delete');
	}
	else
	{
		// make sure any previous edits are saved
		$selectedRow.find('input[name="Mode"]').val('Edit');
	}



}
/* ******************************************************************* */
/*  Delete the row from database */
/* ******************************************************************* */
function deleteNewRow(columnImage,  dstTableId)
{
   //confirm delete
   var agree=confirm($i18n("fcm.loaders.js.deleteNewRow.confirm.fmt.txt",[(columnImage.parentNode.parentNode).rowIndex]));
   if (agree==false) return false;

   var dst = document.getElementById(dstTableId);
   var row = columnImage.parentNode.parentNode;
   var cnt = row.cells.length;
   // Clone the row that is to be moved/deleted
   var rowNum = row.rowIndex;
   var dstRowCount = dst.rows.length;

   dst.deleteRow(rowNum);
   previousid = null;

   var srcRowCount = dst.rows.length;
   for(i = rowNum; i < srcRowCount; i++)
   {
	  dst.rows[i].className = "dataRow"+((i-1)%2+1)+"_tableRow";
	  dst.rows[i].cells[0].innerHTML = i;
   }
   updateImage(dstTableId);

   _highlightedRow = undefined;
   previousHighlightedRowId = null;
   previousHighlightedRowSegmentId =null;
//   document.getElementById("addNewButton").disabled=false;
}

/* ****Common code for updating mode ********/
function updateMode(columnImage, dstTableId,mode)
{
   var tdId = "";
   var dst = document.getElementById(dstTableId);
   var dstRowCount = dst.rows.length;
   if(isDefined(columnImage)){
	   var thisRow = columnImage.parentNode.parentNode;
   	   var rowNum = thisRow.rowIndex;
   	   var firstEditableCell = false;

	   for(i = 0; i < thisRow.cells.length; i++ )
	   {
	         tdId = thisRow.cells[i];
	         if (tdId == undefined)
	         {
				continue;
			 }else{
			        var cellId = tdId.children[0];
					if(cellId == undefined || cellId.tagName == null)
					{
						continue;
					}else if(cellId.tagName && cellId.tagName.toLowerCase() == 'div')
					{
						// hidden columns are inside div tags
						if(i == thisRow.cells.length - 1)
						{
				         	setDivTextNodes(cellId, mode);
					    }else
						{
							if(mode != 'Undo')
								setDivTextNodes(cellId, "U");
							else
							    setDivTextNodes(cellId, "R");
						}
					}else{
						if(mode == "Edit")
						{
				  			if(cellId.type == "text" || cellId.type == "select-one" || cellId.type == "textarea")
			 				{

								 if( cellId.type == "select-one")
								 {
								 	cellId.disabled = false;
								 	disableTextChildNodes(tdId,"U");
								 }else
								 {
									 cellId.readOnly = undefined;
								 }
		 	 					 if(firstEditableCell == false && cellId.type == "text")
			 					 {
			 						cellId.focus();
			 						firstEditableCell = true;
			 					 }
							}
						}
					}

	         }
	   }
   }
}


/* ******************************************************************* */
/*  Update Action column with Edit-delete images  */
/* ******************************************************************* */
/*
function updateImage(dstTableId)
{
   var tdId = "";
   var dst = document.getElementById(dstTableId);
   var dstRowCount = dst.rows.length;
   for(var i = 0; i < dstRowCount ; i++ )
   {
	    if(i != 0)
		{
		   var value = getDivTextNodeValue(dst.rows[i].cells[dst.rows[i].cells.length-1].children[0]);
		   if(value == "Add" || value=="Edit" || value=="Delete")
		   	updateMode($(dst.rows[i]).find('img').get(0),dstTableId,value);
  		   if(value == "Add")
		   {
		   	//if there is a previous row that was in Edit mode we want to set it back
			if(previousHighlightedRowId!=null && previousHighlightedRowId!=0 ){
				var phr=previousHighlightedRowId;
				//unhighlight previous row
				unhighlightRow();
				//reset column values
				resetColumn(null, dstTableId,phr);
				//return the image to its original format
				var valDel = document.forms[0].allowDelete.value;
				var valEdit = document.forms[0].allowEdit.value;
				if(valDel == "1" && valEdit == "1")
					dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  edittxt + delUnChk;
				else if(valEdit == "1" && valDel == "0")
					dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  edittxt;
				else if(valDel == "1" && valEdit == "0")
					dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  delUnChk;
				else
				    dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  "<TD class='imageTableCell lastCol'></TD>";

				 var $selectedRow = $(dst.rows[phr].cells[dst.rows[phr].cells.length-2]).parent();
				 var alt=$selectedRow.find('img').attr('alt');
				 if(alt=='Edit')
				    $selectedRow.find('img').attr('alt',$i18n('fcm.loaders.js.Edit.txt'));
		   	}
		   	highlightRowById(dst.rows[i],'rowSelected');
			dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  delNewRow;
		    var $selectedRow = $(dst.rows[i].cells[dst.rows[i].cells.length-2]).parent();
		    var alt=$selectedRow.find('img').attr('alt');
		    if (alt=='Delete')
		    	$selectedRow.find('img').attr('alt',$i18n('fcm.loaders.js.Delete.txt'));
		   }
		   else if(value == "Edit")
		   {
			//if there is a previous row that was in Edit mode we want to set it back
		   	if(previousHighlightedRowId!=null){
		   		var phr=previousHighlightedRowId;
		   		//unhighlight previous row
		   		unhighlightRow();
		   		//reset column values
		   		resetColumn(null, dstTableId,phr);
		   		//return the image to its original format
		   		var valDel = document.forms[0].allowDelete.value;
				var valEdit = document.forms[0].allowEdit.value;
				if(valDel == "1" && valEdit == "1")
					dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  edittxt + delUnChk;
				else if(valEdit == "1" && valDel == "0")
					dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  edittxt;
				else if(valDel == "1" && valEdit == "0")
					dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  delUnChk;
				else
				    dst.rows[phr].cells[dst.rows[phr].cells.length-2].innerHTML =  "<TD class='imageTableCell lastCol'></TD>";
		   	}
		   	highlightRowById(dst.rows[i],'rowSelected');
		   	dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  resettxt;

		   }

		   else if(value == "Delete")
		   {
			  dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  edittxt + delChk;
		   }
		   else
		   {
			    var valDel = document.forms[0].allowDelete.value;
			   	var valEdit = document.forms[0].allowEdit.value;
				if(valDel == "1" && valEdit == "1"){
					dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  edittxt + delUnChk;}
				else if(valEdit == "1" && valDel == "0")
					dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  edittxt;
				else if(valDel == "1" && valEdit == "0")
					dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  delUnChk;
				else
				    dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  "<TD class='imageTableCell lastCol'></TD>";
		   }

  		   	var $selectedRow = $(dst.rows[i].cells[dst.rows[i].cells.length-2]).parent();
		    var alt=$selectedRow.find('img').attr('alt');
		    if (alt=='Delete')
		    	   $selectedRow.find('img').attr('alt',$i18n('fcm.loaders.js.Delete.txt'));
			 if(alt=='Edit')
			   $selectedRow.find('img').attr('alt',$i18n('fcm.loaders.js.Edit.txt'));
		}
   }

}
*/

function updateImage(dstTableId)
{
   var tdId = "";
   var dst = document.getElementById(dstTableId);
   var dstRowCount = dst.rows.length;
   var i = dst.rows.length -1;

   var value = getDivTextNodeValue(dst.rows[i].cells[dst.rows[i].cells.length-1].children[0]);
   if(value == "Add" || value=="Edit" || value=="Delete")
   	updateMode($(dst.rows[i]).find('img').get(0),dstTableId,value);
   if(value == "Add")
   {
	   	highlightRowById(dst.rows[i],'rowSelected');
		dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML = (i>1 ? delNewRow : delNewRow2);
		if (document.forms[0].allowDelete.value == "1" && document.forms[0].allowEdit.value == "1")
			dst.rows[i].cells[dst.rows[i].cells.length-3].innerHTML = "";

	    var $selectedRow = $(dst.rows[i].cells[dst.rows[i].cells.length-2]).parent();
   }
}


/* ****Common code for updating mode ********/
function enableUnsavedRows(row, dstTableId,mode)
{
   var tdId = "";
   var dst = document.getElementById(dstTableId);
   var dstRowCount = dst.rows.length;
   var thisRow = row;
   var firstEditableCell = false;

   for(i = 0; i < thisRow.cells.length; i++ )
   {
         tdId = thisRow.cells[i];
         if (tdId == undefined)
         {
			continue;
		 }else{
		        var cellId = tdId.children[0];
				if(cellId == undefined || cellId.tagName == null)
				{
					continue;
				}else if(cellId.tagName && cellId.tagName.toLowerCase() == 'div')
				{
					// hidden columns are inside div tags
					if(i == thisRow.cells.length - 1)
					{
			         	setDivTextNodes(cellId, mode);
				    }else
					{
						if(mode != 'Undo')
							setDivTextNodes(cellId, "U");
						else
						    setDivTextNodes(cellId, "R");
					}
				}else{
					if(mode == "Edit" || mode == "Add")
					{
			  			if(cellId.type == "text" || cellId.type == "select-one" || cellId.type == "textarea")
		 				{

							 if( cellId.type == "select-one")
							 {
							 	cellId.disabled = false;
							 	disableTextChildNodes(tdId,"U");
							 }else
							 {
							 	 cellId.readOnly = undefined;
							 }
	 	 					 if(firstEditableCell == false && cellId.type == "text")
		 					 {
		 						cellId.focus();
		 						firstEditableCell = true;
		 					 }
						}
					}
				}

         }
   }
//   document.getElementById("addNewButton").disabled=true;
}
/* ******************************************************************* */
/*  Update Action column with Edit-delete images  */
/* ******************************************************************* */
function updateUnsavedRows(dstTableId)
{

   var tdId = "";
   var dst = document.getElementById(dstTableId);
   var dstRowCount = dst.rows.length;
   for(var i = 0; i < dstRowCount ; i++ )
   {
	   if(i != 0)
		{
		   var value = getDivTextNodeValueByIndex(dst.rows[i].cells[dst.rows[i].cells.length-1].children[0],0);
		   var error = getDivTextNodeValueByIndex(dst.rows[i].cells[dst.rows[i].cells.length-1].children[0],1);

		   enableUnsavedRows(dst.rows[i], dstTableId,value);
		   if(value == "Add")
		   {
				dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML = delNewRow;
				if (document.forms[0].allowDelete.value == "1" && document.forms[0].allowEdit.value == "1")
					dst.rows[i].cells[dst.rows[i].cells.length-3].innerHTML = "";
		   }
		   else if(value == "Edit")
		   {
		   		var $selectedRow = $(dst.rows[i]);
				$selectedRow.find('span.sapUiIcon').attr("data-sap-ui-icon-content", $("<div/>").html("&#xf5bc;").text());
				$selectedRow.find('span.sapUiIcon').attr("onclick", "resetColumn(this, 'availableTable');");
		   }
		   else if(value == "Delete")
		   {
		   		var $selectedRow = $(dst.rows[i]);
				$selectedRow.find(':checkbox').click();
		   }
/*
  		   if(value == "Add")
		   {
			  enableUnsavedRows(dst.rows[i], dstTableId,"Add");
			  dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  delNewRow;
		   }else if(value == "Edit")
		   {
		   	 enableUnsavedRows(dst.rows[i], dstTableId,"Edit");
			  dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  resettxt;
		   }else if(value == "Delete")
		   {
			  enableUnsavedRows(dst.rows[i], dstTableId,"Delete");
			  dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  edittxt + delChk;
		   }

		   else
		   {
			   	var valDel = document.forms[0].allowDelete.value;
			   	var valEdit = document.forms[0].allowEdit.value;
				if(valDel == "1" && valEdit == "1")
					dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  edittxt + delUnChk;
				else if(valEdit == "1" && valDel == "0")
					dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  edittxt;
				else if(valDel == "1" && valEdit == "0")
					dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  delUnChk;
				else
				    dst.rows[i].cells[dst.rows[i].cells.length-2].innerHTML =  "<TD class='imageTableCell lastCol'></TD>";

		   }
*/
		   if(error == 'error')
		   {
			   	dst.rows[i].style.backgroundColor = "red";
		   }

		}
   }
}

/* ******************************************************************* */
/* *************** Enable the columns that are selected for delete */
/* ******************************************************************* */
function enableDeleteColumnsForSave(dstTableId){
   var dst = document.getElementById(dstTableId);
   var dstRowCount = dst.rows.length;
   var firstEditableCell = false;
   for(var i = 0; i < dstRowCount ; i++ )
   {
	   if(i != 0)
		{
		   var thisRow = dst.rows[i];
		   var tdId = "";
		   var value = getDivTextNodeValue(thisRow.cells[thisRow.cells.length-1].children[0]);

		   if(value == "Delete"){
			   var colCnt = thisRow.cells.length;
			   for(j = 0; j < colCnt; j++ ){
					tdId = thisRow.cells[j];
					 if (tdId == undefined){
						continue;
					 }else{
							var cellId = tdId.children[0];
							if(cellId == undefined || cellId.tagName == null){
								continue;
							}else if(cellId.tagName && cellId.tagName.toLowerCase() == 'div'){
									setDivTextNodes(cellId, "U");
							}else{

									if(cellId.type == "text" || cellId.type == "select-one" || cellId.type == "textarea"){

										 if( cellId.type == "select-one")
										 {
										 	cellId.disabled = false;
											disableTextChildNodes(tdId,"U");
										 }else
										 {
										 	cellId.readOnly = undefined;
										 }
										 if(firstEditableCell == false && cellId.type == "text")
										 {
											firstEditableCell = true;
										 }
									}

							}

					 }
			   }
		   }
		}
   }
}

/* ******************************************************************* */
/*   Disables text child Nodes within a td -Add/Edit/Reset  */
/* ******************************************************************* */
function disableTextChildNodes(tdId,mode){
	for (var j = 0; j < tdId.childNodes.length; j++) {
		var tdNode = tdId.childNodes.item(j);
		if(tdNode == undefined)
		{
			 continue;
		}else if(tdNode.type == "text")
		{
		 	if(mode == 'E' || mode == 'A')
			 tdNode.readOnly = true;
		}
	}
}

/* ******************************************************************* */
/*  Sets text childNode properties within a div based on the Mode -Add/Edit
 *  Reset had to be handled separately to retain default values */
/* ******************************************************************* */
function setDivTextNodes(cellId,mode){
	var div = cellId;
	var str = "";
	var cs = div.childNodes;
	var l = cs.length;

	for (var j = 0; j < l; j++) {
			 var tdNode = cs.item(j);
			 if(tdNode == undefined)
			 {
				 continue;
			 }else if(tdNode.type == "text")
			 {
				 if(mode == "U")//For Edit or Delete
				 {
					 tdNode.readOnly = undefined;
				 }
				 else if(mode == "A")
				 {
				 	tdNode.value = '';
  				        tdNode.text = '';
					tdNode.readOnly = undefined;
				 }else if(mode == "R")
				 {
				 	 tdNode.value = tdNode.defaultValue;
					 tdNode.readOnly = true;
				 }else if(mode == 'Add' || mode == 'Edit' || mode == 'Delete')// if last column has values 'Add' or 'Edit' the column needs to be enabled
				 {
				 	tdNode.value = mode;
  				        tdNode.text = mode;
					tdNode.readOnly = undefined;

				 }else if(mode == 'Reset' || mode == 'Undo') // if last column has value 'Reset' this column needs to be disabled
				 {
				 	tdNode.value = mode;
  				        tdNode.text = mode;
					tdNode.readOnly = true;
				 }
			 }

	}

}

/* ******************************************************************* */
/*  gets text childNode properties within a div  */
/* ******************************************************************* */
function getDivTextNodeValue(cellId){
	var div = cellId;
	var str = "";
	var cs = div.childNodes;
	var l = cs.length;
	for (var j = 0; j < l; j++) {
			 var tdNode = cs.item(j);
			 if(tdNode == undefined)
			 {
				 continue;
			 }else if(tdNode.type == "text")
			 {
				 	return tdNode.value;
			 }
	}

}

/* ******************************************************************* */
/*  gets text childNode properties within a div using the index */
/* ******************************************************************* */
function getDivTextNodeValueByIndex(cellId,index){
	var div = cellId;
	var str = "";
	var cs = div.childNodes;

	 var tdNode = cs.item(index);
	 if(tdNode.type == "text")
	 {
		 return tdNode.value;
	 }
}

/* ******************************************************************* */
/*  Gets the selected Filter value and submits it to the action  */
/* ******************************************************************* */
function submitCode(str){
	var lbl = document.forms[0].label.value;
	if(lbl == "postal_code" || lbl == 'FCM_ENUM'){
		var select = document.getElementById('code');
		var stateVal = select.options[select.selectedIndex].value;

		if(stateVal == ''){
			alert("Please select a code for filtering records");
			return;
		}
		if(str == 'true'){
			document.forms[0].pageRefresh.value = 'Y';
			if(document.forms[0].recordsPerPage != null || document.forms[0].recordsPerPage != undefined)
			document.forms[0].recordsPerPage.value = '50';
		}
		var action = "incrloader.sj?method=viewTableContents";
		document.forms[0].action = action;
		document.forms[0].submit();
	}
}

/* ******************************************************************* */
/*  Saves the contents by calling the action method  */
/* ******************************************************************* */
function onSaveLoader(){
	if(!checkAll('availableTable'))
	return false;
	//confirm update/save
	var tableName = $('#tableName').attr('value').toUpperCase();
	var deleteOp = $(":checked[name='Delete']").length > 0; //only delete is checkbox
	var agree=confirm($i18n(deleteOp ? "fcm.loaders.js.onSaveLoader.confirmDelete.fmt.txt":"fcm.loaders.js.onSaveLoader.confirm.fmt.txt",[tableName]));
	if (agree==false) return false;
//	var savebtn = document.getElementById("saveButton");
//	savebtn.readOnly = true;
//	var addbtn = document.getElementById("addNewButton");
//	if(addbtn!=null)addbtn.readOnly = true;
	enableDeleteColumnsForSave('availableTable');
	var action = "saveincrloader.sj?method=saveContents";
	document.forms[0].action = action;
	document.forms[0].submit();
	document.forms[0].disabled=true;
}

/* The following functions are not being used currently *************/
/* ******************************************************************* */
/*  Gets the selected Filter value and submits it to the action  */
/* ******************************************************************* */
function getFilterType(){
	var id = document.forms[0].gridId.value;
	if(id == 2 || id == 3){
		var select = document.getElementById('filter');
		var filterType = select.options[select.selectedIndex].value;

		if(filterType == ''){
			alert("Please select an Lov Type for filtering records");
			return;
		}
		var action = "incrloader.sj?method=viewTableContents&filterType=" + filterType;
		document.forms[0].action = action;
		document.forms[0].submit();
	}
}

/* ******************************************************************* */
/*  Following functions help in adding values to the dropdown list dynamically */
/* ******************************************************************* */

/* ******************************************************************* */
/*  Enable the text box and hide the dropdown for dynamically adding the
 * new dropdown value  */
/* ******************************************************************* */
function enableDropDownText(selectedspan){
	var thisTR = selectedspan.parentNode.parentNode;
	var thisTD = selectedspan.parentNode;
	var cellId = thisTD.children[0];
	var str = '';
	if(cellId == undefined){
	}
	else{
		if(cellId.type == "select-one"){
			str =cellId.value;
		}
	}
	//TD - to get the default value from hidden text
	for (var j = 0; j < thisTD.childNodes.length; j++){
		var tdNode = thisTD.childNodes.item(j);
		if(tdNode == undefined){
			continue;
		}
		else if(tdNode.type == "text" && tdNode.id != "SELECT_RESET"){
			tdNode.text = str;
			tdNode.value = str;
		}
	}
}

/* ******************************************************************* */
/*  Add the value in the text to the dropdown at last index and hide
 * the text and show the dropdown with the new value*/
/* ******************************************************************* */
function appendInSelect(selectedspan){
	var thisTR = selectedspan.parentNode.parentNode;
	var thisTD = selectedspan.parentNode;
	var str = '';
	for (var i = 0; i < thisTD.childNodes.length; i++) {
		var cellId = thisTD.childNodes.item(i);
		if(cellId == undefined){
			continue;
		}else{
			if(cellId.type == "text" && cellId.id == "addNew"){
				str =cellId.value;
			}
		}
	}
	if(str != ''){
		//TD - to get the default value from hidden text
		for (var j = 0; j < thisTD.childNodes.length; j++) {
			var tdNode = thisTD.childNodes.item(j);
			if(tdNode == undefined){
				continue;
			}else if(tdNode.type == "text" && tdNode.id == "addNew"){
				tdNode.readOnly = true;
				tdNode.style.display="none";
				tdNode.style.visibility="hidden";
			}else if(tdNode.type == "select-one"){
				tdNode.disabled = false;
				tdNode.style.display="";
				tdNode.style.visibility="visible";
				addOption(tdNode,str,str);
				tdNode.value = str;
			}
		}
	}else{
		alert("Please enter a new value to be added to the list");
	}
}

/* ******************************************************************* */
/*  Method to Add the value in the text to the dropdown at last index  */
/* ******************************************************************* */
function addOption(selectbox,text,value ){
	var optn = document.createElement("OPTION");
	optn.text = text;
	optn.value = value;
	selectbox.options.add(optn,0);
}

function rowStart(tableId){
	var table = document.getElementById(tableId);
	var rows = table.tBodies[0].rows;
	var col0 = rows[0].cells[0];
	return col0.innerHTML;
}

function validateGroupCode(obj){
	if(obj.value.length>2){
		alert($i18n("fcm.loaders.js.validateGroupCode.alert0.txt"));
		obj.value='';
	}
	if(!isAlphaNumeric(obj.value)){
		alert($i18n("fcm.loaders.js.validateGroupCode.alert1.txt"));
		obj.value='';
	}
}

function isAlphaNumeric(str) {
	var number = /[0-9]+/;
	var alpha = /[A-Za-z]+/;
	str = str.replace(number,"").replace(alpha,"");
	if(str.length == 0)
		return true;
	return false;
}
