<%@ page language="java" session="true" %>
<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<!-- Overriding styles -->

<STYLE>

/* Override styles from admin.css */
BODY{
   text-align:center;
}

.ruleIdeTable
{
    background-color: #f0f1f2;
    border-collapse: separate;
    border: 0px;
    padding-left: 2px;
    vertical-align: top;
}
.ruleIdeTableLabel
{
   padding-left: 10px;
   text-align: left;
}
.ruleIdeTableValue
{
   padding-left: 0px;
   text-align: left;
   white-space: nowrap;
}
.ruleIdeTableDataRow TD
{
   padding-top: 2px;
}
.ruleIdeTableComponentRow TD
{
   padding-top: 0px;
}
.componentClosedHeadHover
{
   background-color: #287eab;
   border: 1px solid #719db9;
   padding-left:5px;
   cursor:pointer;
}
.componentOpenHeadHover
{
   background-color: #287eab;
   border: 1px solid #719db9;
   padding-left:5px;
   cursor:pointer;
}
.componentClosedHead
{
   background-color: #287eab;
   border: 1px solid #f0f1f2;
   padding-left:5px;
   cursor:pointer;
}
.componentOpenHead
{
   background-color: #287eab;
   border-top:1px solid #719db9;
   border-left:1px solid #719db9;
   border-right:1px solid #719db9;
   border-bottom:1px solid #719db9;
   padding-left:5px;
   cursor:pointer;
}
.componentSubTypeLabel
{
   background-color:white;
   border-left:1px solid #719db9;
   border-right:1px solid #719db9;
   padding-left:5px;
   text-align:left;
}
.componentSubTypeLine
{
   background-color:white;
}
.componentSubTypeLineLeft
{
   background-color:white;
   border-left:1px solid #719db9;
}
.componentSubTypeLineRight
{
   background-color:white;
   border-right:1px solid #719db9;
}
.componentSubTypeLineLabel
{
   text-align:left;
   cursor:pointer;
}
.componentValuesClosed
{
   background-color:#f0f1f2;
}
.componentValuesOpen
{
   background-color:#e0e2e5;
}



/* Override menu.js and cf.css style for light-color tabber with header buttons */
td.fsp_menubar
{  border-bottom:1px solid #000000;
}
.tabs a {
   background:url("images/rules/sTabLeftLite.gif") no-repeat left top;
}
.tabs a span {
   background:url("images/rules/sTabRightLite.gif") no-repeat right top;
}
.tabs .current a {
   background-color:#f0f1f2;
}
.tabs .current a span {
   background-color:#f0f1f2;
}
</STYLE>

<script language="JavaScript">
//<!--
function goBack()
{
   history.go(-1);
}
function isEmpty( fieldvalue )
{
    var re = /\s/g; //Match any white space including space, tab, form-feed, etc.
    RegExp.multiline = true; // IE support
    var str = fieldvalue.replace(re, "");
    if (str.length == 0)
      return true;
    return false;
}

function validateNotEmpty(fieldname,fieldvalue)
{
    if (isEmpty(fieldvalue) == true )
    {
      alert($i18n("rules.ruleDetailContent.warning.validateNotEmpty.fmt.txt", [fieldname]));
      return false;
    }
    return true;
}

function isNumeric( value )
{
   var test1 = "+-0123456789";
   var test2 = "0123456789";
   var c;

   // Trim leading and trailing blanks.
   var number=value.replace(/^\s+|\s+$/g,"");

   // The first character can be a + or -
   c = test1.indexOf(number.charAt(0));
   if (c < 0)
      return false;

   // The rest must be digits.
   for (ii=1; ii<value.length; ii++)
   {
      c = test2.indexOf(number.charAt(ii));
      if (c < 0)
         return false;
   }
   return true;
}

function validateNumber(field, fieldname)
{
   // Consider null values valid
   if (isEmpty( field.value ) == true)
      return true;

   if ( isNumeric( field.value ) == true)
      return true;

   alert($i18n("rules.ruleDetailContent.warning.validateNumber.fmt.txt", [fieldname]));
   field.select();
   field.focus();

   return false;
}

function checkCharacters(event){
	var key_codes = [35,37,38,44,60,62];
	var statusArea = document.getElementById("errorDisplay");
	if ($.inArray(event.keyCode, key_codes) >= 0) {			
		if(timeout && statusArea.innerHTML == $i18n("rules.ruleDetailContent.specialCharacters.error.txt")){
			clearTimeout(timeout);
		}
		statusArea.innerHTML = $i18n("rules.ruleDetailContent.specialCharacters.error.txt");	
		timeout = setTimeout(function() {
			statusArea.innerHTML = "";
		}, 5000);
        event.preventDefault();
    }
	else{
		statusArea.innerHTML = "";
		enableSaveButton(event);
	}
}

function submitForm(nextOp)
{
  if (validateForm())
  {
    document.forms[0].nextOp.value = nextOp;
    disableSaveButton();
    bar.setEnabled( 1, false );
    bar.setEnabled( 2, false );
    
    convertVariableNamesToIds();
    convertPreRequisiteHandlesToIds();
    var status = '<image title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.ruleDetailContent.saveInProgress.txt'/></esapi:encodeForHTMLAttribute>" src="' + sasSpinner + '" border="0" height="15" width="15"/>';
    setSaveStatusDisplay( document, status);
	document.getElementById("operationalTimeLimit").value=document.getElementById("otl").value;
    if(document.getElementById("otl").value==""){
    	document.getElementById("operationalTimeLimit").value=-1;
    }
    document.forms[0].submit();
  }
}



// Initiates a cancel, status, or reset request for the SAS process
function requestProcessAction( action, msgKey )
{
  var url = '<c:url value="/r_ruleTester.do"/>';
  var baseRuleId = document.getElementById('baseRuleId');
  baseRuleId = (baseRuleId) ? baseRuleId.value : 0;
  var version = document.getElementById('version');
  version = (version) ? version.value : 0;

  var confirmMsg = (msgKey) ? $i18n(msgKey) : "";
  if (confirmMsg=="" ||  confirm(confirmMsg))
  {
    document.getElementById('statusCancelResultsFrame').src = url +
        "?timestamp=" + new Date().getTime() +    // Guarantee no cache
        "&action=" + action +
        "&version=" + version +
        "&baseRuleId=${rule.baseRuleId}";
  }
}


// Initiates a request for the generated SAS code
function showGeneratedCode()
{
   var url = '<c:url value="/rules/generatedCodeContent.jsp"/>';
   if (window.showModalDialog)
      window.showModalDialog(url, window, "dialogHeight:768px;dialogWidth:1024px;resizable:1;scroll:1;status:1;help:0;")
   else
   {
      var theWindow = window.open(url, "generatedCode", 'dependent=1,alwaysRaised=1,resizable=1,scrollbars=1,status=1,width=768,height=1024');
      theWindow.focus();
   }
}

var bypassSaveCheck = false;

var activeTab = new Array('ruleProperties');
function swapGridContents(gridName,gridNum)
{
   if (document.getElementById(gridName + "Tab") && document.getElementById(gridName + "Div"))
   {
     var prev=activeTab[gridNum-1];
     document.getElementById(prev+"Div").style.display = "none";
     document.getElementById(prev + "Tab").className = "normal";
     document.getElementById(gridName + "Div").style.display = "block";
     document.getElementById(gridName + "Tab").className = "current";
     window.focus();
     //-document.getElementById(gridName + "Tab").blur();
     //eval("currGridName"+gridNum) = gridName;
     activeTab[gridNum-1]=gridName;
     bypassSaveCheck = false;
   }
}

//check if an element exists in array using a comparer function
//comparer : function(currentElement)
Array.prototype.inArray = function(comparer) {
 for(var i=0; i < this.length; i++) {
     if(comparer(this[i])) return true;
 }
 return false;
};

//adds an element to the array if it does not already exist using a comparer
//function
Array.prototype.pushIfNotExist = function(element, comparer) {
 if (!this.inArray(comparer)) {
     this.push(element);
 }
};


function getTransactionsForAlertType(compsForAlertType){
	var transactionsForAlertTypes=new Array();
	<c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}">
		<c:forEach var="c" items="${sasEditorSelectorMaps.tranCompsMap[t.key]}">
			if(compsForAlertType[TransactionComponentsMap["${t.key}"]["${c}"]]){
				//transactionsForAlertTypes.push("${t.value}");
				var element="- ${t.value}";
				transactionsForAlertTypes.pushIfNotExist(element, function(e) {
					 return e  === element;
				});
			}
		</c:forEach>
    </c:forEach>
	return transactionsForAlertTypes;
}


//-->
</script>


<%-- Buttons at the top --%>
<table width="100%" border="0" cellpadding="0"><tr><td colspan="1">
 <tiles:insert page="/rules/ruleDetailMenu.jsp"/>
 </td></tr>
</table>


<%-- Error handling code --%>
<%--
  <table width="100%" style="background-color:white"><tr><td>
  <c:url var="reloadURL" value="/r_rules.do?method=modifyRule&id=${rule.id}" />
  <tiles:insert page="rulesSystemMessages.jsp" flush="true">
     <tiles:put name="reloadURL" value="${reloadURL}" />
     <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
     <tiles:put name="objectTypeName" value="Rule" />
  </tiles:insert>
  </td></tr></table>
--%>


<%-- Handle for optimistic lock exception for deleted rules during reload --%>
<c:choose>
   <c:when test="${ruleNotFound != null}">
    <!-- Rule was deleted by another user the error message above will indicate this-->
   </c:when>
   <c:otherwise>

      <table  align="center" width="100%" name="searchView" cellspacing="0" cellpadding="0" style="margin-top:0px">
         <THEAD>
            <TR><TH scope="col" style="margin:0px;padding:0px;border:0px;" nowrap>
               <div class="tabs">
                  <ul>
                    <li id="rulePropertiesTab"><a href="JavaScript:swapGridContents('ruleProperties',1);"><span onclick="bypassSaveCheck=true;"><fmt:message key="rules.ruleDetailContent.tab.generalProperties.txt" /></span></a></li>
                    <li id="sasCodeTab"><a href="JavaScript:swapGridContents('sasCode',1);"><span onclick="bypassSaveCheck=true;"><fmt:message key="rules.ruleDetailContent.tab.editor.txt" /></span></a></li>
                    <li id="sasLogTab"><a href="JavaScript:swapGridContents('sasLog',1);"><span onclick="bypassSaveCheck=true;"><fmt:message key="rules.ruleDetailContent.tab.log.txt" /></span></a></li>
                    <li id="testResultsTab"><a href="JavaScript:swapGridContents('testResults',1);"><span onclick="bypassSaveCheck=true;"><fmt:message key="rules.ruleDetailContent.tab.results.txt" /></span></a></li>

                    <%-- Remove code builder prototype code for production but leave stubs here for easy use in demos --%>
                    <c:if test="{not empty CODE_BUILDER}">
                      <li id="codeBuilderTab"><a href="JavaScript:swapGridContents('codeBuilder',1);"><span onclick="bypassSaveCheck=true;"><fmt:message key="rules.ruleDetailContent.tab.builder.txt" /></span></a></li>
                    </c:if>

                    <%-- Status indicators appear beside the tabs --%>
                    <li style="float:left">&nbsp;
                        <span id="errorWarningDisplay"></span>
                        &nbsp;
                        <span id="saveStatusDisplay" style="padding-top:2px;">
                          <c:if test="${not empty confirmationMessage}">
                            <c:choose>
                            <c:when test="${not empty errorMessage}">
                              <span id="refreshOpenerIndicator" title="${errorMessage}" onclick="alert(this.title);" style="color:red; font-weight:bold; cursor:pointer;">${confirmationMessage}</span>
                            </c:when>
                            <c:otherwise>
                              <span id="refreshOpenerIndicator" title="<fmt:message key='rules.ruleDetailContent.opSuccess.txt' />" onclick="alert(this.title);" style="color:black; font-weight:normal; cursor:pointer;">${confirmationMessage}</span>
                            </c:otherwise>
                            </c:choose>
                          </c:if>
                        </span>
                        <span id="errorDisplay" style="padding-top:2px;color:red;">
                        </span>
                    </li>

                    <%-- Ctrl and shift keys appear for clarity S1053953 --%>
                    <li style="float:right">&nbsp; <%-- S1053953 --%>
                        <span id="Shift" style='display:none;font-size:xx-small;color:Gainsboro;'><fmt:message key="rules.ruleDetailContent.key.shift.txt" /></span>      <%-- S1053953 --%>
                        <span id="Ctrl" style='display:none;font-size:xx-small;color:Gainsboro;'><fmt:message key="rules.ruleDetailContent.key.ctrl.txt" /></span> &nbsp; <%-- S1053953 --%>
                    </li> <%-- S1053953 --%>
                  </ul>
               </div>
            </TH></TR>
         </THEAD>
         <TBODY><TR><TD valign="top" style="background-color:#f0f1f2">
            <form name="ruleForm" id="ruleForm" action="<c:url value='/r_ruleDefinition.do'/>" method="post" target="saveResultsFrame">

            <input type="hidden" name="ignoreShiftSpaceInd" value="${ignoreShiftSpaceInd}"/> <%-- S0844689 --%>
            <input type="hidden" name="method" value="saveRule" />
            <input type="hidden" name="nextOp" value="" />
            <input type="hidden" name="enableXAMS" value="${enableXAMS}" />  <%-- S0750302 --%>

            <c:if test="${rule != null}">
               <input type="hidden" name="ruleId" value="${rule.id}">
               <input type="hidden" name="lockVersion" value="${rule.lockVersion}">
               <input type="hidden" name="version" value="${rule.version}">
               <input type="hidden" name="baseRuleId" id="baseRuleId" value="${rule.baseRuleId}">
               <input type="hidden" name="state" value="${rule.workflow.state}" />
               <input type="hidden" name="checkoutUser" value="${fn:escapeXml(rule.checkoutUser)}" />
               <input type="hidden" name="slotId" id="slotId" value="${rule.ruleFiredSlotsByTenantMultiOrgId[rule.businessUnitItem.rootMultiOrgId].id}" />
            </c:if>


            <!-- Rule identity stuff -->
            <div id="rulePropertiesDiv" style="display:;background-color:#f0f1f2;">
              <tiles:insert page="/rules/tiles/ruleProperties.jsp"/>
            </div>

            <!-- SAS Code stuff -->
            <div id="sasCodeDiv" style="display:none;background-color:#f0f1f2;">
              <tiles:insert page="/rules/tiles/sasEditor.jsp"/>
            </div>

            <!-- SAS Log stuff -->
            <div id="sasLogDiv" style="display:none;background-color:#f0f1f2;">
              <tiles:insert page="/rules/tiles/sasLog.jsp"/>
            </div>

            <!-- SAS Test stuff -->
            <div id="testResultsDiv" style="display:none;background-color:#f0f1f2;">
              <tiles:insert page="/rules/tiles/testResults.jsp"/>
            </div>

            </form>

         </TD></TR></TBODY>
      </table>





      <%-- Form tags are made readonly if not Coding or new rule --%>
      <c:if test="${ rule != null && rule.workflow.state != 'Coding' }" >
        <script language="JavaScript">
        //<!--
        setFormsReadOnly("doNotDisable");
        //-->
        </script>
      </c:if>


      <%-- Event handlers are established here --%>
      <SCRIPT language="JavaScript">
      //<!--
        // Catch when the page closes
        if (window.onbeforeunload  &&  window.onbeforeunload != beforeUnloadHandler)
          alert('Window already has an onBeforeUnload handler: ' + window.onbeforeunload);
        else
          window.onbeforeunload = beforeUnloadHandler;

      //-->
      </SCRIPT>



      <!-- TBD add State transition buttons on rule detail page -->

   </c:otherwise>
</c:choose>


<%-- Pre-load spinner so it appears quickly when we need it --%>
<image style="height:0px;width:0px" src="common/images/spinner.gif">





<%-- Hidden iframes for various purposes --%>
<%-- @TODO: Replace these iframes with dynamically constructed ones (dojo/dwr) --%>

  <%-- Invisible iframe used to dispatch a save --%>
  <iframe id="saveResultsFrame" name="saveResultsFrame" src="blank.html" style="position:absolute; top:500px; left:0px; height:0px; width:0px; border:0px;"></iframe>

  <%-- Invisible iframe used to dispatch status and cancellation requests --%>
  <iframe id="statusCancelResultsFrame" name="statusCancelResultsFrame" src="blank.html" style="position:absolute; top:500px; left:0px; height:0px; width:0px; border:0px;"></iframe>

  <%-- Debug log --%>
  <pre id="debugLog" style="position:absolute; top:300px; left:0px; height:0px; width:0px; border:0px; background:yellow;text-align:left;"></pre>


