<!-- Author: Benjamin George -->
<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<script src="common/scripts/jquery-ui.js"></script>
<script src="common/scripts/jquery-1.10.2.js"></script>
<script src="common/scripts/jquery-ui.js"></script>
<link rel="stylesheet" href="common/styles/jquery-ui.css">

<style>
#ulhead { list-style-type: none; margin: 0; padding: 0; width: 60%; background-color:#43698F; text-align:left;

border-color:#43698F;
border-top-style:solid;
border-bottom:none;
border-left:none;
border-right:none;
border-width:2px;}

.tabs .current a {
   background-color:#f0f1f2;
}
.tabs .current a span {
   background-color:#f0f1f2;
}

 .ulhead li { margin: 0 3px 3px 3px; padding: 0.4em; padding-left: 1.5em; height: 18px; cursor:hand;}
 .sortable { list-style-type: none; margin: 0; padding: 0; width: 60%; }
 .sortable li { margin: 0 3px 3px 3px; padding: 0.4em; padding-left: 1.5em; height: 18px; cursor:hand; text-align:left;}
 .sortable li span { position: absolute; margin-left: -1.3em; }
</style>
<script>

var draggedRules = "";
var allIds = [];

$( document ).ready(function() {

	<c:forEach var="rule" items="${preRulesAuth}">   
		var baseId = '${rule.baseRuleId}'+"_"+'${rule.workflowState}';
		allIds['${rule.id}'] = baseId;
	</c:forEach>
	<c:forEach var="rule" items="${postRulesAuth}">
		var baseId = '${rule.baseRuleId}'+"_"+'${rule.workflowState}';
		allIds['${rule.id}'] = baseId;
	</c:forEach>
	<c:forEach var="rule" items="${preRulesVar}">
		var baseId = '${rule.baseRuleId}'+"_"+'${rule.workflowState}';
		allIds['${rule.id}'] = baseId;
	</c:forEach>
	<c:forEach var="rule" items="${postRulesVar}">
		var baseId = '${rule.baseRuleId}'+"_"+'${rule.workflowState}';
		allIds['${rule.id}'] = baseId;
	</c:forEach>
	<c:forEach var="rule" items="${preRulesQueue}">
		var baseId = '${rule.baseRuleId}'+"_"+'${rule.workflowState}';
		allIds['${rule.id}'] = baseId;
	</c:forEach>
	<c:forEach var="rule" items="${postRulesQueue}">
		var baseId = '${rule.baseRuleId}'+"_"+'${rule.workflowState}';
		allIds['${rule.id}'] = baseId;
	</c:forEach>

$("#sortablePreAuth, #sortablePostAuth, #sortablePreVar, #sortablePostVar, #sortablePreQueue, #sortablePostQueue").sortable({
	cancel: ".ui-state-disabled",
	update: function( event, ui ) {
		var baseIdWorkflow = ui.item.attr("id");
		for(var key in allIds){
			if(baseIdWorkflow == allIds[key]){
				draggedRules = draggedRules + key + ",";
			}
		}
	}
});

  $( "#sortablePostAuth li, #sortablePreAuth li, #sortablePostVar li, #sortablePreVar li, #sortablePostQueue li, #sortablePreQueue li" ).disableSelection();

});

  function savePriorities(){

	   formElem = document.ruleForm;

	   var str = "";
	   var dependenciesMoved = "";
	   var strName, strValue, listItem;

	   <c:forEach var="rule" items="${preRulesAuth}">

 	    listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
 	    strValue = $("#sortablePreAuth li").index(listItem);

 	   if(strValue!=${rule.executionOrderPriority} || (${rule.executionOrderPriority} == 0 && draggedRules.indexOf("${rule.id}") != -1)){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePreAuth li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePreAuth li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePreAuth li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
     		   }

	         </c:forEach>
	 	   </c:if>
	 	   strName = ${rule.id};
	 	   str = str + strName+":"+strValue + ",";
         }

	   </c:forEach>

	   <c:forEach var="rule" items="${postRulesAuth}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePostAuth li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority} || (${rule.executionOrderPriority} == 0 && draggedRules.indexOf("${rule.id}") != -1)){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePostAuth li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePostAuth li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePostAuth li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${preRulesVar}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePreVar li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority} || (${rule.executionOrderPriority} == 0 && draggedRules.indexOf("${rule.id}") != -1)){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePreVar li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePreVar li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePreVar li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${postRulesVar}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePostVar li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority} || (${rule.executionOrderPriority} == 0 && draggedRules.indexOf("${rule.id}") != -1)){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePostVar li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePostVar li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePostVar li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${preRulesQueue}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePreQueue li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority} || (${rule.executionOrderPriority} == 0 && draggedRules.indexOf("${rule.id}") != -1)){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePreQueue li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePreQueue li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePreQueue li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${postRulesQueue}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePostQueue li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority} || (${rule.executionOrderPriority} == 0 && draggedRules.indexOf("${rule.id}") != -1)){
		     <c:if test="${not empty rule.ruleDependencies}">
		        <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

		           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
		           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
		           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

		           dependentRuleCodingIndex = $("#sortablePostQueue li").index(dependentRuleCoding);
		           dependentRuleTestingIndex = $("#sortablePostQueue li").index(dependentRuleTesting);
		           dependentRuleProductionIndex = $("#sortablePostQueue li").index(dependentRuleProduction);

		           if(strValue < dependentRuleCodingIndex ||
		        	  strValue < dependentRuleTestingIndex ||
		        	  strValue < dependentRuleProductionIndex)
		           {
		             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
	   		   	   }

		         </c:forEach>
		 	   </c:if>
		 	   strName = ${rule.id};
		 	   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   if(dependenciesMoved!=""){
	     alert("<fmt:message key='rules.rulePriority.warning.txt' />");{return false};
	   }

       ele = document.createElement("input");
	   ele.type = "hidden";
	   ele.name = "rulesPriorityChanged";
	   ele.value = str;
	   formElem.appendChild(ele);

	   ele1 = document.createElement("input");
	   ele1.type = "hidden";
	   ele1.name = "activeTab";
	   if(document.getElementById("postRuleAuthDiv").style.display!="none"){
	     ele1.value = "postRuleAuthDiv";
	   }
	   if(document.getElementById("preRuleAuthDiv").style.display!="none"){
	     ele1.value = "preRuleAuthDiv";
	   }
	   if(document.getElementById("postRuleVarDiv").style.display!="none"){
	     ele1.value = "postRuleVarDiv";
	   }
	   if(document.getElementById("preRuleVarDiv").style.display!="none"){
	     ele1.value = "preRuleVarDiv";
	   }
	   if(document.getElementById("postRuleQueueDiv").style.display!="none"){
		 ele1.value = "postRuleQueueDiv";
	   }
	   if(document.getElementById("preRuleQueueDiv").style.display!="none"){
		 ele1.value = "preRuleQueueDiv";
	   }
	   formElem.appendChild(ele1);

	   ele2 = document.createElement("input");
	   ele2.type = "hidden";
	   ele2.name = "changeType";
	   ele2.value = "save";
	   formElem.appendChild(ele2);
	   
	   ele3 = document.createElement("input");
	   ele3.type = "hidden";
	   ele3.name = "draggedRules";
	   ele3.value = draggedRules;
	   formElem.appendChild(ele3);

	   formElem.submit();
  }

  function resetPriorities(){
	   formElem = document.ruleForm;
	   ele1 = document.createElement("input");
	   ele1.type = "hidden";
	   ele1.name = "activeTab";

	   if(document.getElementById("postRuleAuthDiv").style.display!="none"){
	     ele1.value = "postRuleAuthDiv";
	   }
	   if(document.getElementById("preRuleAuthDiv").style.display!="none"){
	     ele1.value = "preRuleAuthDiv";
	   }
	   if(document.getElementById("postRuleVarDiv").style.display!="none"){
	     ele1.value = "postRuleVarDiv";
	   }
	   if(document.getElementById("preRuleVarDiv").style.display!="none"){
	     ele1.value = "preRuleVarDiv";
	   }
	   if(document.getElementById("postRuleQueueDiv").style.display!="none"){
		 ele1.value = "postRuleQueueDiv";
	   }
	   if(document.getElementById("preRuleQueueDiv").style.display!="none"){
		 ele1.value = "preRuleQueueDiv";
	   }
	   formElem.appendChild(ele1);

	   ele2 = document.createElement("input");
	   ele2.type = "hidden";
	   ele2.name = "changeType";
	   ele2.value = "reset";
	   formElem.appendChild(ele2);

	   formElem.submit();
  }

  function cancelPriorities(){
	   formEmpty = document.emptyRuleForm;
	   formEmpty.submit();
  }

  var activeTab = new Array('preRuleAuth');

  function swapGridContents(gridName,gridNum)
  {
     if (document.getElementById(gridName + "Tab") && document.getElementById(gridName + "Div"))
     {
       var prev=activeTab[gridNum-1];
       document.getElementById(prev+"Div").style.display = "none";
       document.getElementById(prev + "Tab").className = "normal";
       document.getElementById(gridName + "Div").style.display = "block";
       document.getElementById(gridName + "Tab").className = "current";
       window.focus();
       activeTab[gridNum-1]=gridName;
       bypassSaveCheck = false;
     }
  }

</script>

<div id="prioritizeRulesBlock">
<table>
  <tr>
   <td>
   		<h4><fmt:message key='rules.rulePriority.title.txt' /> &nbsp;&nbsp;<span style="margin-left:227px;"></span></h4>
   </td>
    <td>
      <button title="<fmt:message key='rules.rulePriority.save.txt' />" class="sapMBtn" id="save" type="button" onclick="javascript:savePriorities()">
    	<div class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnPaddingLeft sapMBtnPaddingRight sapMFocusable">
			<span class="sapMBtnContent"><fmt:message key='rules.rulePriority.save.txt' /></span>
		</div>
	  </button>
   </td>
   <td>
     <button title="<fmt:message key='rules.rulePriority.reset.txt' />" class="sapMBtn" id="reset" type="button" onclick="javascript:resetPriorities()">
	   <div class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnPaddingLeft sapMBtnPaddingRight sapMFocusable">
		   <span class="sapMBtnContent"><fmt:message key='rules.rulePriority.reset.txt' /></span>
	   </div>
	 </button>
   </td>
   <td>
     <button title="<fmt:message key='rules.rulePriority.return.txt' />" class="sapMBtn" id="cancel" type="button" onclick="javascript:cancelPriorities()">
       <div class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnPaddingLeft sapMBtnPaddingRight sapMFocusable">
	       <span class="sapMBtnContent"><fmt:message key='rules.rulePriority.return.txt' /></span>
       </div>
     </button>
  </td>
</tr>
</table>

<br/><fmt:message key='rules.rulePriority.directions.txt' />
<br/><br/>

<form name="emptyRuleForm" id="emptyRuleForm" action="<c:url value='/r_rules.do?method=listRules&workflow=Coding&showAll=true' />" method="post">
</form>

<table name="searchView" cellspacing="0" cellpadding="0" style="margin-top:0px">
         <THEAD>
            <TR><TH scope="col" style="margin:0px;padding:0px;border:0px;" nowrap>
               <div class="tabs">
                  <ul>
                    <c:if test="${isTenantInstall==true}">
                      <li id="preRuleAuthTab" class="current"><a href="JavaScript:swapGridContents('preRuleAuth',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.preRulesTab.txt' /></span></a></li>
                      <li id="postRuleAuthTab"><a href="JavaScript:swapGridContents('postRuleAuth',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.postRulesTab.txt' /></span></a></li>
                    </c:if>
					<c:if test="${isTenantInstall==false}">
					  <li id="preRuleAuthTab" class="current"><a href="JavaScript:swapGridContents('preRuleAuth',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.authPreRulesTab.txt' /></span></a></li>
                      <li id="postRuleAuthTab"><a href="JavaScript:swapGridContents('postRuleAuth',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.authPostRulesTab.txt' /></span></a></li>
					  <li id="preRuleVarTab"><a href="JavaScript:swapGridContents('preRuleVar',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.varPreRulesTab.txt' /></span></a></li>
                      <li id="postRuleVarTab"><a href="JavaScript:swapGridContents('postRuleVar',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.varPostRulesTab.txt' /></span></a></li>
                      <li id="preRuleQueueTab"><a href="JavaScript:swapGridContents('preRuleQueue',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.queuePreRulesTab.txt' /></span></a></li>
                      <li id="postRuleQueueTab"><a href="JavaScript:swapGridContents('postRuleQueue',1);"><span style="padding:10px;"><fmt:message key='rules.rulePriority.queuePostRulesTab.txt' /></span></a></li>
                    </c:if>
                  </ul>
               </div>
            </TH></TR>
         </THEAD>
         <TBODY><TR></TR><TR></TR>
         <TR ondblclick='processRequest("modifyRule","",true);'>
         <TD valign="top" style="background-color:#f0f1f2">
            <form name="ruleForm" id="ruleForm" action="<c:url value='/r_ruleDefinition.do'/>" method="post">

            <input type="hidden" name="method" value="updateRulePriority" />
            <input type="hidden" name="userId" value="${userId}" />

            <div id="preRuleAuthDiv" style="background-color:#f0f1f2;">
			           <ul class="sortable" id="sortablePreAuth" style="width:auto;white-space:nowrap;">
			             <c:choose>
					         <c:when test="${not empty preRulesAuth}">
			                 	<c:forEach var="i" begin="0" end="${maxPreRulesAuthPriority}" step="1">
					                 <c:forEach var="rule" items="${preRulesAuth}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                         <c:choose>
							 				    <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" style="cursor:pointer;" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleAuth" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${esapi:encodeForJavaScript(rule.id)}], "${esapi:encodeForJavaScript(rule.description)}",${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)},${esapi:encodeForJavaScript(rule.isDeployed)}, "${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}", "${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}", "${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event,"isPriority");'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt' />: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleAuth" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							       </c:when>
  							       <c:otherwise>
  							           <i align="right" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							       </c:otherwise>
  							</c:choose>
			           </ul>
            </div>

            <div id="postRuleAuthDiv" style="display:none;background-color:#f0f1f2;">
         			  <ul class="sortable" id="sortablePostAuth" style="width:auto;white-space:nowrap;">
         			    <c:choose>
					        <c:when test="${not empty postRulesAuth}">
			                    <c:forEach var="i" begin="0" end="${maxPostRulesAuthPriority}" step="1">
					               <c:forEach var="rule" items="${postRulesAuth}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                       <c:choose>
							 				  <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" style="cursor:pointer;" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleAuth" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${esapi:encodeForJavaScript(rule.id)}], "${esapi:encodeForJavaScript(rule.description)}",${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)},${esapi:encodeForJavaScript(rule.isDeployed)}, "${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}", "${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}", "${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event,"isPriority");'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleAuth" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							       </c:when>
  							       <c:otherwise>
  							           <i align="right" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							       </c:otherwise>
  							   </c:choose>
			           </ul>
            </div>

            <div id="preRuleVarDiv" style="display:none;background-color:#f0f1f2;">
			           <ul class="sortable" id="sortablePreVar" style="width:auto;white-space:nowrap;">
			             <c:choose>
					         <c:when test="${not empty preRulesVar}">
			                 	<c:forEach var="i" begin="0" end="${maxPreRulesVarPriority}" step="1">
					                 <c:forEach var="rule" items="${preRulesVar}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                     <c:choose>
							 				  <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" style="cursor:pointer;" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleVar" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${esapi:encodeForJavaScript(rule.id)}], "${esapi:encodeForJavaScript(rule.description)}",${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)},${esapi:encodeForJavaScript(rule.isDeployed)}, "${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}", "${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}", "${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event,"isPriority");'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleVar" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							       </c:when>
  							       <c:otherwise>
  							           <i align="right" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							       </c:otherwise>
  						      </c:choose>
			           </ul>
            </div>

            <div id="postRuleVarDiv" style="display:none;background-color:#f0f1f2;">
         			  <ul class="sortable" id="sortablePostVar" style="width:auto;white-space:nowrap;">
         			    <c:choose>
					        <c:when test="${not empty postRulesVar}">
			                     <c:forEach var="i" begin="0" end="${maxPostRulesVarPriority}" step="1">
					                 <c:forEach var="rule" items="${postRulesVar}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                       <c:choose>
							 				   <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" style="cursor:pointer;" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleVar" value="${rule.executionOrderPriority}"
  								                     onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${esapi:encodeForJavaScript(rule.id)}], "${esapi:encodeForJavaScript(rule.description)}",${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)},${esapi:encodeForJavaScript(rule.isDeployed)}, "${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}", "${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}", "${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event,"isPriority");'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleVar" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							      </c:when>
  							      <c:otherwise>
  							         <i align="right" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							      </c:otherwise>
  							  </c:choose>
			           </ul>
            </div>

            <div id="preRuleQueueDiv" style="display:none;background-color:#f0f1f2;">
			           <ul class="sortable" id="sortablePreQueue" style="width:auto;white-space:nowrap;">
			             <c:choose>
					        <c:when test="${not empty preRulesQueue}">
			                     <c:forEach var="i" begin="0" end="${maxPreRulesQueuePriority}" step="1">
					                 <c:forEach var="rule" items="${preRulesQueue}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                     <c:choose>
							 				  <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" style="cursor:pointer;" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleQueue" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${esapi:encodeForJavaScript(rule.id)}], "${esapi:encodeForJavaScript(rule.description)}",${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)},${esapi:encodeForJavaScript(rule.isDeployed)}, "${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}", "${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}", "${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event,"isPriority");'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleQueue" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                      &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt'/>: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							          </c:forEach>
  							    </c:when>
  							    <c:otherwise>
  							       <i align="right" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							    </c:otherwise>
  							</c:choose>
			           </ul>
            </div>

            <div id="postRuleQueueDiv" style="display:none;background-color:#f0f1f2;">
         			  <ul class="sortable" id="sortablePostQueue" style="width:auto;white-space:nowrap;">
         			    <c:choose>
					        <c:when test="${not empty postRulesQueue}">
			                     <c:forEach var="i" begin="0" end="${maxPostRulesQueuePriority}" step="1">
					                 <c:forEach var="rule" items="${postRulesQueue}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                      <c:choose>
							 				   <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" style="cursor:pointer;" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleQueue" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${esapi:encodeForJavaScript(rule.id)}, ${esapi:encodeForJavaScript(rule.baseRuleId)}, ruleNames[${esapi:encodeForJavaScript(rule.id)}], "${esapi:encodeForJavaScript(rule.description)}",${esapi:encodeForJavaScript(rule.version)}, ${esapi:encodeForJavaScript(rule.lockVersion)}, ${esapi:encodeForJavaScript(rule.isDeployed)},"${esapi:encodeForJavaScript(rule.workflowState)}", "${esapi:encodeForJavaScript(rule.guidedRule)}", "${esapi:encodeForJavaScript(rule.transactionTypeId)}", "${esapi:encodeForJavaScript(rule.multiOrgNodeId)}","${esapi:encodeForJavaScript(rule.queueId)}","${esapi:encodeForJavaScript(rule.alertTypeCode)}","${esapi:encodeForJavaScript(rule.alertReason)}", "${esapi:encodeForJavaScript(rule.executionOrderPriority)}", this,"rowSelected",event,"isPriority");'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                       &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt' />: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleQueue" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>

  								                       &nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.transaction.txt' />: ${rule.transactionTypeDesc}

  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							      </c:when>
  							      <c:otherwise>
  							         <i align="right" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							      </c:otherwise>
  							  </c:choose>
			           </ul>
            </div>

            </form>

         </TD></TR></TBODY>
      </table>
</div>
